set SSS_PROG "bloch"

#LASSPinterp .interp

set x0 0
set y0 0
set pottype "square well"
set resolution .00025
set eps 1.e-5
set gaplist ""
set emin 0
set depth 0
set num_band_graphs 0
set num_psi_graphs 0
#mod rbr
set bloch_config_palette 0
set bloch_band_palette 0

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0
set wd 0
set ht 0
set old_size "large"

proc startup {} {
global wd ht wdth hght font SCALE disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth [expr 600/3.0]
	set hght [expr 360/1.8]
	set disp_option "small"
	wm minsize . 650 330
	wm maxsize . 850 450
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	set SCALE 100

	} elseif {$wd <= 800} {
		set wdth [expr 700/2.5]
		set hght [expr 500/1.79]
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 720 390
		wm maxsize . 1000 600
		set SCALE 140
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set disp_option "large"
	                set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 900 500
			wm maxsize . 4000 3000
			set SCALE 200
			}

	set old_size $disp_option
}

proc set_para {} {
global wd ht wdth hght font SCALE disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth [expr 600/3.0]
	set hght [expr 360/1.8]
	wm minsize . 650 330
	wm maxsize . 850 450
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
        set SCALE 100

	} elseif {$disp_option == "medium"} {
		set wdth [expr 700/2.5]
		set hght [expr 500/1.79]
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 720 390
		wm maxsize . 1000 600
		set SCALE 140
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 900 500
			wm maxsize . 4000 3000
			set SCALE 200
			}

	# Configuring the font for all the widgets.
	config_all

	#if {($old_size == "small")||(($old_size == "medium") && ($disp_option == "large")) } {
		#Setting geometry as much as needed.
	#	wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
	#}

	

}


#mod spt
startup

#################configure window
proc configure {} {
	global font
	 set w .blochconfig

	 if {[winfo exists $w]} {
	set list [winfo children $w]
	set index [lsearch $list $w.controls]
	set list [lreplace $list $index $index]
	foreach win $list  {
		 destroy $win
	}
	raise $w
	 } else {
	toplevel $w
	wm title $w "bloch configure"

	frame $w.controls
	button $w.controls.b -text close -font $font -command "destroy .blochconfig"
	button $w.controls.b2 -text revert -font $font -command "configure"
	pack $w.controls.b2 -side left -fill x -expand yes
	pack $w.controls.b -side left -fill x -expand yes
	pack $w.controls -fill x -expand yes -pady 1
	 }

	 frame $w.resolution
	 label $w.resolution.l  -font $font -text "resolution (dE/(Emax-Emin)): "
	 LASSPentry $w.resolution.e \
		 {expr {[catch {expr -[%W get]}] \
		 || !([%W get]>0) \
		 || [catch {set resolution [%W get]}]}}
	 pack  $w.resolution.l -side left
	 pack $w.resolution.e -side right
	 pack $w.resolution

	 global resolution
	 LASSPentry_set $w.resolution.e $resolution

	 frame $w.eps
	 label $w.eps.l -font $font -text "integration accuracy: "
	 LASSPentry $w.eps.e \
		 {expr {[catch {expr -[%W get]}] \
		 || !([%W get]>0) \
		 || [catch {set eps [%W get]}]}}
	 pack  $w.eps.l -side left
	 pack $w.eps.e -side right
	 pack $w.eps

	 global eps
	 LASSPentry_set $w.eps.e $eps
#mod rbr
	 global bloch_config_palette
	 if { $bloch_config_palette == 0 } {
	tk_setPalette #d9d9d9
#	tk_setPalette blue
	set bloch_config_palette 1
	 }

}

################# the presetsave procedure ############################
proc presetsave {file} {
	 #global variables
	 foreach s {resolution eps}  {
	global $s
	puts $file "set $s \"[set $s]\" "
	 }
	 #selections
	 foreach s { .graphtype .pottype } {
	set val [LASSPselection_set $s]
	puts $file "LASSPselection_set $s \"$val\""
	 }
	 #sliders
	 foreach s {.lc .depth .width .separation .energy .bandstrcf.controls.emax \
		 .bandstrcf.controls.emin} {
	set val [LASSPscale2_configure $s -scrollinc]
	puts $file "LASSPscale2_configure $s -scrollinc $val"
	set val [LASSPscale2_configure $s -scrollmin]
	puts $file "LASSPscale2_configure $s -scrollmin $val"
	set val [LASSPscale2_configure $s -scrollmax]
	puts $file "LASSPscale2_configure $s -scrollmax $val"
	set val [LASSPscale2_configure $s -scrolltype]
	puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr remove font config from sliders
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"
	set var [LASSPscale2_configure $s -var]
	global $var
	puts $file "LASSPscale2_set $s [set $var]"
	 }
	 puts $file "pack_sliders"
	 puts $file ".calcpsi invoke"
	 puts $file ".calcband invoke"
}



############## put up a window showing gaps ###############################
proc gaps {} {
	 global list_gaps gaplist font

	 if {$list_gaps} {
	toplevel .bands
	button .bands.close  -font $font -text "close" -command ".list_gaps invoke"
	text .bands.text  -font $font -yscrollcommand ".bands.scroll set"
	scrollbar .bands.scroll  -command ".bands.text yview"
	pack .bands.close -side top
	pack .bands.scroll -side right -fill y
	pack .bands.text -side left
	.bands.text insert end $gaplist

	pack .bands.text
	bind .bands <Destroy>  { set list_gaps 0 }
	 } else {
	if { [winfo exists .bands] } {
		 destroy .bands
	}
	 }
#mod rbr
	 global bloch_band_palette
	 if { $bloch_band_palette == 0 } {
	tk_setPalette #d9d9d9
	set bloch_band_palette 1
	 }

}


#################  create polygons and coordinate axis for 3D plot ###########
proc bloch_init {} {
	 # line with tcl id 1
	 .psi create line 1 2 3 4 -fill black -width 3

	 # polygons with tcl id 2 - 51
	 for {set i 1} {$i <= 50} {incr i} {
	.psi create polygon 1 2 3 4 5 6 7 8 -fill red -outline black
	 }

	 # lines with tcl id 52 and 53
	 .psi create line 1 2 3 4 -fill blue -width 3
	 .psi create line 1 2 3 4 -fill green -width 3

	 # polygons with tcl id 54 - 103
	 for {set i 51} {$i <= 100} {incr i} {
	.psi create polygon 1 2 3 4 5 6 7 8 -fill red -outline black
	 }

	 # line with tcl id 104
	 .psi create line 1 2 3 4 -fill black -width 3
}

###########################################
proc bloch_display {} {
	 global graphtype font

	 if {$graphtype == "psi"} {
	pack forget .psigraph
	pack forget .psif.top.copy
	pack .psi -in .psif
	 } elseif {($graphtype == "psi-squared") || ($graphtype == "phase of psi")} {
	pack forget .psi
	pack .psif.top.copy -side right
	pack .psigraph -in .psif  -fill both -expand yes
	if {$graphtype == "psi-squared"} {
		 .psigraph element show {data0 data1}
		 .psigraph yaxis configure -title {psi^2 and potential (arb. units)}
	} else {
		 .psigraph element show {data0 data2}
		 .psigraph yaxis configure -title {phase of psi (pi) and potential (arb.)}
	}
	 }
}


######################################################################
proc pack_sliders {} {
	 global pottype

	 if {$pottype == "square well"} {
	pack forget .separation
	pack .width -in .box1 -before .energy -fill x  -pady 1
	 } elseif {($pottype == "cosine") || ($pottype == "atom (1/z)")} {
	pack forget .separation
	pack forget .width
	 } elseif {$pottype == "molecule"} {
	pack forget .width
	pack .separation -in .box1 -before .energy -fill x  -pady 1
	 }
}

################################# create widgets  #################


frame .psif
frame .box1
frame .box2
frame .box3

canvas .psi -width $wdth -height $hght -bd 2 -relief raised

#############################################
bind .psi <Button-1>  {
	 set x0 %x
	 set y0 %y
}
bind .psi <B1-Motion> {
	 set dy [expr (%x-$x0)/100.0]
	 set dx [expr (%y-$y0)/100.0]
	 set x0 %x
	 set y0 %y
	 xrotate
	 yrotate
	 update idletasks
}
bind .psi <Button-3> {
	 rotate_reset
}
#mod rbr - Button 3 to control button 1
bind .psi <Control-Button-1> [bind .psi <Button-3>]

#mod rbr cursor {clock red white} breaks on mac - use cursor watch
#mod rbr also just update instead of update idletasks

button .calcpsi  -font $font -text "calculate psi"  -height 2\
	-command {. config -cursor watch; update;wave_function_calculate; wave_function_draw; . config -cursor {}}
button .calcband  -font $font -text "calculate bands" -height 2\
	-command {. config -cursor watch; update; set gaplist "";\
	band_structure_calculate; catch {.bands.text insert end $gaplist;\
	.bands.text yview moveto 1 }; . config -cursor {}}
checkbutton .list_gaps  -font $font -text "band list" -relief raised -height 2\
	-var list_gaps -command {gaps}

LASSPselection .graphtype "show: " graphtype {bloch_display} \
	"psi" "psi-squared" "phase of psi"
LASSPselection_configure .graphtype -font $font

LASSPselection .pottype {potential:} pottype {pack_sliders} "square well" "cosine" "atom (1/z)" "molecule"
LASSPselection_configure .pottype -font $font

LASSPscale2 .lc -text "lattice const (A)" -font $font -scrollmin 0. -scrollmax 10. \
	-scrollinc .1 -initial 4. -type real\
	-test { [catch {global pwidth}] || (%v>$pwidth) } \
	-var periodicity -command {}

LASSPscale2 .depth -text "pot. depth (eV)" -font $font -scrollmin -100. -scrollmax 0. \
	-scrollinc 1 -initial -20. -type real -test {%v<=0.0}\
	-var depth -command {}

LASSPscale2 .width -text "pot. width (A)" -font $font -scrollmin 0. -scrollmax 10. \
	-scrollinc .1 -initial 3 -type real\
	-test { [catch {global periodicity}] || ((%v>=0.0)&&(%v<$periodicity)) }\
	-var pwidth -command {}

LASSPscale2 .separation -text "mol. sep. (A)" -font $font -scrollmin 0. -scrollmax 10. \
	-scrollinc .1 -initial 1 -type real -var separation -command {}

LASSPscale2 .energy -text "energy (eV)" -font $font -scrollmin -100. -scrollmax 100. \
	-scrollinc 2 -initial 37 -type real -var energy -command {}


frame .bandstrcf
frame .bandstrcf.top
blt_graph  .bandstrc -bd 2 -relief raised -plotbackground white \
	-height $hght -width $wdth
LASSPgrzoom .bandstrc
LASSPgrcursor .bandstrc "format {%.6lg,     %.6lg}"
.bandstrc element create data0
.bandstrc element create data1
.bandstrc element configure data0 -fg blue
.bandstrc element configure data1 -fg red
.bandstrc legend configure -mapped no
.bandstrc xaxis configure -title {wave vector (pi/a)}
.bandstrc yaxis configure -title {energy (eV)}
# mod rbr to check for double-button-3 emulation
bind .bandstrc <Double-Button-1> {
	 global SSS_CTRLB1
	 if { $SSS_CTRLB1 == 0 } {
	LASSPscale2_set .energy [lindex [.bandstrc invtransform %x %y] 1]
	.calcpsi invoke
	 }
}
# mod rbr - to force unzoom to correct limits
bind .bandstrc <ButtonRelease-3> {+
	 global emin, emax
	 if { [lindex [.bandstrc xaxis config -min] 4] == "" } {
	.bandstrc xaxis config -min -0.02
	 }
	 if { [lindex [.bandstrc xaxis config -max] 4] == "" } {
	.bandstrc xaxis config -max 1.02
	 }
	 if { [lindex [.bandstrc yaxis config -min] 4] == "" } {
	.bandstrc yaxis config -min [expr $emin-($emax-$emin)*.02]
	 }
	 if { [lindex [.bandstrc yaxis config -max] 4] == "" } {
	.bandstrc yaxis config -max [expr $emax+($emax-$emin)*.02]
	 }
}
# mod rbr - can bind control-ButtonRelease-1 and ButtonRelease-1
# as well since min and max should never be null unless unzooming
bind .bandstrc <Control-ButtonRelease-1> {+
	 global emin, emax
	 if { [lindex [.bandstrc xaxis config -min] 4] == "" } {
	.bandstrc xaxis config -min -0.02
	 }
	 if { [lindex [.bandstrc xaxis config -max] 4] == "" } {
	.bandstrc xaxis config -max 1.02
	 }
	 if { [lindex [.bandstrc yaxis config -min] 4] == "" } {
	.bandstrc yaxis config -min [expr $emin-($emax-$emin)*.02]
	 }
	 if { [lindex [.bandstrc yaxis config -max] 4] == "" } {
	.bandstrc yaxis config -max [expr $emax+($emax-$emin)*.02]
	 }
}
bind .bandstrc <ButtonRelease-1> {+
	 global emin, emax
	 if { [lindex [.bandstrc xaxis config -min] 4] == "" } {
	.bandstrc xaxis config -min -0.02
	 }
	 if { [lindex [.bandstrc xaxis config -max] 4] == "" } {
	.bandstrc xaxis config -max 1.02
	 }
	 if { [lindex [.bandstrc yaxis config -min] 4] == "" } {
	.bandstrc yaxis config -min [expr $emin-($emax-$emin)*.02]
	 }
	 if { [lindex [.bandstrc yaxis config -max] 4] == "" } {
	.bandstrc yaxis config -max [expr $emax+($emax-$emin)*.02]
	 }
}

frame .bandstrcf.controls

LASSPscale2 .bandstrcf.controls.emax  -font $font -text "E max (eV)" \
	-scrollmin -100. -scrollmax 100. -scrollinc 2 -initial 40. \
	-type real -var emax -command {} \
	-test {[catch {global emin}] || {%v>$emin}}
LASSPscale2_configure .bandstrcf.controls.emax  -font $font

LASSPscale2 .bandstrcf.controls.emin  -font $font -text "E min (eV)" \
	-scrollmin -100. -scrollmax 100. -scrollinc 2 -initial -20. \
	-type real -var emin -command {} \
	-test {[catch {global emax}] || {%v<$emax}}
LASSPscale2_configure .bandstrcf.controls.emin  -font $font


button .bandstrcf.top.copy  -font $font -text "copy graph" -command {
	 incr num_band_graphs 1
	 graph_create .band_graph$num_band_graphs .bandstrc
}

frame .psif.top
button .psif.top.copy   -font $font -text "copy graph" -command {
	 incr num_psi_graphs 1
	 graph_create .psi_graph$num_psi_graphs .psigraph
}
label .psif.top.number  -font $font -text "band index "

blt_graph .psigraph -bd 2 -relief raised -plotbackground white \
	-height $hght -width $wdth
.psigraph configure -font $font
.psigraph xaxis configure -font $font
.psigraph yaxis configure -font $font
.psigraph element create data0
.psigraph element configure data0 -fg blue
.psigraph element create data1
.psigraph element configure data1 -fg red
.psigraph element create data2
.psigraph element configure data2 -fg red
.psigraph element create data3
.psigraph element configure data3 -fg blue
.psigraph xaxis configure -title {distance (A)}
.psigraph legend configure -mapped no -font $font
LASSPgrzoom .psigraph
LASSPgrcursor .psigraph "format {%.3lf,    %.3lf}"

########################################################################
#mod spt to add top panel
frame .top_panel -relief sunken -bd 2
LASSPpresets .presets presetsave
#Added by spt
LASSPpresets_configure .presets -font $font

button .configure -font $font -text "configure..." -command {configure}
button .help   -font $font -text "help..." \
	-command {LASSPhelp2 .t2 [file join $SSS_DIR lib/bloch/bloch.htm]}
button .quit  -font $font -text "quit" -command {exit 0}


LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font
#######################################################################



#mod rbr
#tk_setPalette #d9d9d9
#spt
pack .quit .disp_type .configure .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top

pack .psif.top.number -side left -expand 1
pack .graphtype -in .psif.top -side left  -expand 1
pack .psif.top  -side top -fill both 
pack .psi -in .psif -side left -expand yes

pack .calcband .calcpsi .pottype .lc .depth .width .energy .list_gaps  -in .box1 \
	-fill x  -pady [expr ($wdth - 100)/50]
pack .bandstrcf.controls.emin  -side left -expand 1
pack .bandstrcf.controls.emax -side left  -expand 1
pack .psif -side left -fill both -pady 2
pack .box1  -side left   -pady 2 -expand no

pack .bandstrcf.top.copy 
pack .bandstrcf.top  -fill x
pack .bandstrc -in .bandstrcf  -fill both -expand yes  -pady 2
pack .bandstrcf.controls -fill x -side bottom

pack .bandstrcf -side left -fill both -expand yes
#wm minsize . 610 472

proc config_all {} {

	global font wdth hght

	# the scales
	LASSPscale2_configure .lc -font $font
	LASSPscale2_configure .depth -font $font
	LASSPscale2_configure .width -font $font
	LASSPscale2_configure .energy -font $font
	LASSPscale2_configure .separation -font $font



	LASSPscale2_configure .bandstrcf.controls.emax  -font $font
	LASSPscale2_configure .bandstrcf.controls.emin  -font $font

	# the selections
	LASSPselection_configure .graphtype -font $font
	LASSPselection_configure .pottype -font $font
	LASSPselection_configure .disp_type -font $font


	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.bandstrcf.top.copy configure -font $font
	.psif.top.copy configure -font $font
	.calcpsi configure -font $font
	.calcband configure -font $font
	.list_gaps configure -font $font
	.configure configure -font $font
	.help configure -font $font
	.quit configure -font $font

	#RHS cosmetics
	pack .calcband .calcpsi .pottype .lc .depth .width .energy .list_gaps  -in .box1 \
	-fill x  -pady [expr ($wdth - 100)/50]

	#labels
	.psif.top.number configure -font $font

	#graphs
	.bandstrc configure -width $wdth -height $hght
	.psigraph configure -width $wdth -height $hght
	.psi configure -width $wdth -height $hght -bd 2 -relief raised
        .psigraph configure -font $font
        .psigraph xaxis configure  -font $font
        .psigraph yaxis configure -font $font
        .psigraph legend configure -font $font

	#procedures to redraw
	 rotate_reset

	#mod rbr - blt graphs
	.bandstrc configure -font $font
	.bandstrc xaxis config -font $font -ticklength 6
	.bandstrc yaxis config -font $font -ticklength 6

	wave_function_calculate
	wave_function_draw
	bloch_init
	
      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}
}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option

############################## special bindings #######################3
bind . <Key-Escape> {.quit invoke}
bind . <KeyPress-space> {
	 .calcpsi configure -relief sunken
	 update idletasks
	 .calcpsi invoke
	 .calcpsi configure -relief raised
}
bind . <KeyPress-i> {
	 .calcband configure -relief sunken
	 update idletasks
	 .calcband invoke
	 .calcband configure -relief raised
}






