set SSS_PROG "born"

#LASSPinterp .interp
################################ global variables #########################
set pause 1
set displaydelay 1
set bc periodic
set initial standing_packet
set crystal_type pure
set natoms 64
set graph_update 20
set data0 {}
set data1 {}
set data2 {}
set data3 {}
set data4 {}
set num_graphs 0
set showgrid 1
set show_initial 1
#mod rbr
set born_config_palette 0
#mod spt
set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0

############################mod spt for three sizes.
proc startup {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 300
	set hght 120
	set disp_option "small"
	wm minsize . 580 430
	wm maxsize . 850 540
    	global tcl_platform    
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	} elseif {$wd <= 800} {
		set wdth 400
		set hght 160
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 650 480
		wm maxsize . 1000 740
	 } else {
			set wdth 500
			set hght 200
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 700 550
   			wm maxsize . 4000 3000
			}
}

proc set_para {} {
global wd ht wdth hght font disp_option  tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 300
	set hght 120
	wm minsize . 580 430       
        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
		}

	wm maxsize . 850 540
	global tcl_platform
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}

	} elseif {$disp_option == "medium"} {
		set wdth 400
		set hght 160
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 650 480
		wm maxsize . 1000 740
	 } else {
			set wdth 500
			set hght 200
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 700 550
      			wm maxsize . 4000 3000
			}
	# Configuring the font for all the widgets.
	config_all

	#if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
	#	wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
	#}

}


#mod spt
startup

########## atoms_init - create & init canvas, set scales ##################
proc atoms_init {} {
	 global natoms wdth hght

	 # destroy the old canvas
	 catch {destroy .atoms}
	 # create the new canvas
	 canvas .atoms -width $wdth -height $hght -bd 2 -relief raised
	 # create natoms atoms
	 for {set i 0} {$i<$natoms} {incr i 1} {
	.atoms create oval 0 0 0 0 -fill red -outline {} -tag atom
	 }

	 bind .atoms <Configure> {
	set xscale [expr 0.9*%w/$natoms]
	set xoffset [expr 0.5*(%w-$xscale*$natoms)]
	set yoffset [expr 0.5*%h]
	set yscale [expr 0.3333333*%h]
	set radius [expr (%w*0.5)/$natoms]
	if {$radius < 1.} {set radius 1.}
	if {$radius > 10.} {set radius 10.}
	tcl_initialize
	.atoms create text 50 10 -anchor nw -tag clock -text "time: 0"
	 }

	 pack .atoms -in .atomsf -fill both -expand yes
}

################ initialize atom positions and graph #################
proc tcl_initialize {} {
	 global data0 data1 data2 data3 data4


	 # Determine the initial positions and velocities
	 born_initialize

	 # Draw the atoms on the screen
	 born_update

	 # Draw the impurity atom
	 impurity_toggle

	 # Draw the grid
	 draw_grid

	 # Draw the initial continuous function
	 draw_initial

	 # Reset graph to no data
	 for {set i 0} {$i<5} {incr i 1} {
	.xygraph element configure data$i -data {}
	set data$i {}
	 }
}


################### Draw continuous initial function #################
proc draw_initial {} {

	 global xscale yscale xoffset yoffset natoms amplitude wavevector \
		 initial show_initial pause

	 # delete the old initial function
	 .atoms delete withtag initialtag

	 # draw the new one
	 if {$show_initial && $pause && \
		 (($initial == "standing_wave") ||\
		 ($initial == "traveling_wave"))} {

	set steps [expr 2*$natoms*(abs($wavevector)+2)]
	set x1 0
	set y1 0
	set xmax [expr ($natoms-1)*$xscale+$xoffset]
	set amp [expr -1.15*$amplitude*$yscale]
	#1.15 fudge factor to make display look right
	set wv [expr abs($wavevector)/$xscale*3.1415926]
	if {$wv==0.0} {
		 set xinc [expr $xmax/$steps]
	} else {
		 set xinc [expr 1./$wv]
	}

	set cmd ".atoms create line $xoffset $yoffset "
	for {set x $xoffset} {$x<=$xmax} {set x [expr $x+$xinc]} {
		 lappend cmd $x [expr $amp*sin($wv*($x-$xoffset))+$yoffset]
	}
	lappend cmd -fill black -tag initialtag -smooth yes
	eval $cmd
	 }
}


######################### draw the grid #############################
proc draw_grid {} {
	 global showgrid xscale xoffset yscale yoffset natoms

	 .atoms delete grid
	 if $showgrid {
	foreach y {-1 -0.5 0 .5 1} {
		 .atoms create line $xoffset [expr $y*$yscale+$yoffset]  \
			 [expr ($natoms-1)*$xscale+$xoffset] \
			 [expr $y*$yscale+$yoffset] -tag grid
	}
	for {set x 0} {$x<$natoms} {incr x 10} {
		 .atoms create line [expr $x*$xscale+$xoffset] \
			 [expr -$yscale*5/4+$yoffset] \
			 [expr $x*$xscale+$xoffset] [expr $yscale*5/4+$yoffset] \
			 -tag grid
	}
	.atoms lower grid atom
	 }
}


######################### born_graph - updates data  ##################
proc born_graph {} {
	 global data0 data1 data2 data3 data4

	 if {[llength $data0] > 0} {
		for {set k 0} {$k < 5} {incr k} {
		 set temp data$k
		 .xygraph element append data$k [set [set temp]]
		 set data$k {}
	}
	 }
}


################ impurity toggle #####################################
proc impurity_toggle {} {
	 global crystal_type imp_position
	 # make all atoms red
	 .atoms itemconfigure atom -fill red
	 # make the center atom blue
	 if {$crystal_type == "impure"} {
	.atoms itemconfigure [expr $imp_position+1] -fill blue
	 }
}


################# the presetsave procedure ############################
proc presetsave {file} {

	 #global variables
	 foreach s {displaydelay natoms graph_update \
		 imp_position showgrid show_initial} {
	global $s
	puts $file "set $s [set $s]"
	 }

	 #selections
	 foreach s {.bc .initial .display .type} {
	set val [LASSPselection_set $s]
	puts $file "LASSPselection_set $s $val"
	 }

	 #sliders
	 foreach s {.wavevector .waveamplitude .packetwidth \
		 .centerx .impuritymass .quarticconstant .speed} {
	set val [LASSPscale2_configure $s -scrollinc]
	puts $file "LASSPscale2_configure $s -scrollinc $val"
	set val [LASSPscale2_configure $s -scrollmin]
	puts $file "LASSPscale2_configure $s -scrollmin $val"
	set val [LASSPscale2_configure $s -scrollmax]
	puts $file "LASSPscale2_configure $s -scrollmax $val"
	set val [LASSPscale2_configure $s -scrolltype]
	puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in sliders
#	set val [LASSPscale2_configure $s -font]
#	puts $file "LASSPscale2_configure $s -font $val"

	set var [LASSPscale2_configure $s -var]
	global $var
	puts $file "LASSPscale2_set -nocommand $s [set $var]"
	 }

	 #atoms&graph
	 puts $file "atoms_init"
	 puts $file "impurity_toggle"
	 puts $file ".initialize invoke"
}


##################### create a configure window ###################
# configure natoms
proc configure {} {
	 if {[winfo exists .bornconfig]} {
	foreach win [winfo children .bornconfig] {
		 destroy $win
	}
	 } else {
	toplevel .bornconfig
	wm title .bornconfig "born configure"
	 }
	 set w .bornconfig

	 raise .bornconfig
	 frame $w.controls
	 label $w.controls.l -text "born configure"
	 button $w.controls.b -text close -command "destroy .bornconfig"
	 button $w.controls.b2 -text revert -command "configure"
	 pack $w.controls.l -side left -fill x -expand yes
	 pack $w.controls.b2 -side left -fill x -expand yes
	 pack $w.controls.b -side left -fill x -expand yes
	 pack $w.controls -fill x -expand yes -pady 1

	 frame $w.natoms
	 label $w.natoms.l -text "number of atoms:"
	 LASSPentry $w.natoms.e \
		 {expr {[catch {expr -[%W get]}] \
		 || !([%W get]>2) \
		 || !([%W get]<256) \
		 || [catch {set natoms [%W get]}] \
		 || [catch {atoms_init}] \
		 || [catch {tcl_initialize}]}}
	 pack $w.natoms.l  -side left
	 pack $w.natoms.e  -side left -fill x -expand yes
	 pack $w.natoms -fill x -expand yes -pady 1
	 global natoms
	 LASSPentry_set $w.natoms.e $natoms

	 frame $w.graph_update
	 label $w.graph_update.l -text "graph update increments:"
	 LASSPentry $w.graph_update.e \
		 {expr {[catch {expr -[%W get]}] \
		 || !([%W get]>0) \
		 || !([%W get]<32768) \
		 || [catch {set graph_update [%W get]}] }}
	 pack $w.graph_update.l  -side left
	 pack $w.graph_update.e  -side left -fill x -expand yes
	 pack $w.graph_update -fill x -expand yes -pady 1
	 global graph_update
	 LASSPentry_set $w.graph_update.e $graph_update

	 checkbutton $w.showgrid -text "show grid" -var showgrid -command {draw_grid}
	 checkbutton $w.showinitial -text "show continuous function" -var show_initial -command {tcl_initialize}
	 pack $w.showgrid -fill x -expand yes -pady 1
	 pack $w.showinitial -fill x -expand yes -pady 1
#mod rbr
	 global born_config_palette
	 if { $born_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set born_config_palette 1
	 }
}


################################ evolve stuff ###########################
proc evolve {} {
	 global pause displaydelay
	 if {$pause} {
	tkwait variable pause
	 }
# While loop added - rbr
	 while { $pause == 0 } {
		  update
		  born_evolve
	 }
	 born_evolve
	 after idle evolve
}
set pause 1
after 1 evolve


######################### pack menus ##############################

proc packmenus {} {
	  global crystal_type initial
	 pack forget .wavevector .packetwidth .centerx \
		 .impuritymass .quarticconstant


	 if {$initial != "random"} {
	pack .wavevector -in .box2 -fill x -padx 2 -pady 1
	 }
	 if {($initial == "standing_packet") || ($initial == "traveling_packet")} {
	pack .packetwidth .centerx -in .box2 -fill x -padx 2 -pady 1
	 }
	 if {$crystal_type == "impure"} {
	pack .impuritymass  -in .box2 -fill x -padx 2 -pady 1
	 }
	 if {$crystal_type == "anharmonic"} {
	pack .quarticconstant  -in .box2 -fill x -padx 2 -pady 1
	 }


}


### wave_vector_update - changes wavevector to commensurate value #####
proc wave_vector_update {} {
	 global natoms bc initial wavevector

	 if {($initial == "traveling_wave") || ($initial == "standing_wave")} {
	if {$bc == "fixed"} {
		 set val [expr 1.0/($natoms-1) * int($wavevector * ($natoms-1) + .5)]
	} else {
		 set val [expr 2.0/$natoms * int(0.5 * $wavevector * $natoms + .5)]
	}
	if {$val != 1.0*$wavevector} {
		 LASSPscale2_set .wavevector $val
	}
	 }
}



################################# create widgets  #################
frame .atomsf
frame .box1
frame .box2
frame .xygraphf

button .run -text "run" -font $font -width 10 -height 2 -command {
	 .atoms delete withtag initialtag
	 if {$pause} {
	.run configure -text "stop"
	set pause 0
	 } else {
	.run configure -text "run"
	set pause 1
	born_graph
	 }
}
button .initialize -text "initialize" -font $font -command {tcl_initialize}

LASSPselection .bc "boundary:" bc {tcl_initialize} \
	"periodic" "fixed"
LASSPselection_configure .bc -font $font

LASSPselection .initial "initial:" initial {tcl_initialize; packmenus} \
	"standing_packet" "traveling_packet" \
	"standing_wave" "traveling_wave" "random"
LASSPselection_configure .initial -font $font

LASSPselection .type "crystal_type:" crystal_type {tcl_initialize; packmenus}\
	"pure" "impure" "anharmonic"
LASSPselection_configure .type -font $font

LASSPscale2 .wavevector -text "wave vector (pi/a)" -scrollmin 0 -scrollmax 1 \
	-type real -scrollinc .1 -initial .3 -var wavevector  -test {%v>=0.0}\
	-command {wave_vector_update; global pause; if {$pause} {tcl_initialize}}
LASSPscale2_configure .wavevector -font $font

LASSPscale2 .waveamplitude -text "amplitude (arb.)" -scrollmin 0 -scrollmax 1 \
	-type real -scrollinc .1 -initial .5 -var amplitude -command  \
	{global pause; if {$pause} {tcl_initialize}}
LASSPscale2_configure .waveamplitude -font $font

LASSPscale2 .packetwidth -text "packet width (a)" -scrollmin 0 -scrollmax 10 \
	-type real -scrollinc .1 -initial 6 -var sigma -command  \
	{global pause; if {$pause} {tcl_initialize}} -test {%v>0.0}
LASSPscale2_configure .packetwidth -font $font

LASSPscale2 .centerx -text "peak position (a)" -scrollmin 0 -scrollmax 50 \
	-type integer -scrollinc 1 -initial 20 -var centerx -command \
	{global pause; if {$pause} {tcl_initialize}}
LASSPscale2_configure .centerx -font $font

LASSPscale2 .impuritymass -text "imp. mass (m*/m)" -scrollmin 0 \
	-scrollmax 1.0 -type real -scrollinc .01 -initial .5 -var imp_mass -test {%v>0.005}
LASSPscale2_configure .impuritymass -font $font

LASSPscale2 .quarticconstant -text "quartic cnst (rel K)" -scrollmin 0 -scrollmax 1 \
	-type real -scrollinc .01 -initial 0 -var k4 -test {(%v>=0)&&(%v<=30.)}
LASSPscale2_configure .quarticconstant -font $font

LASSPscale2 .speed -text "speed" -scrollmin 1 -scrollmax 10 -test {%v>0} \
	-type integer -scrollinc 1 -initial 7 -var speed
LASSPscale2_configure .speed -font $font

#------------------------------------------------------
#mod spt to add top panel
frame .top_panel -relief sunken -bd 2
#mod spt for display type option
LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font
#------------------------------------------------------


LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

button .config -font $font -text "configure..." -command {configure}
button .help -font $font -text "help..." -command {LASSPhelp2 .t2 [file join $SSS_DIR lib/born/born.htm]}
button .quit -font $font -text "quit" -command {set pause 0; exit 0}


blt_graph .xygraph -bd 2 -relief raised -plotbackground white \
	-height 200 -width 200
#mod rbr moved below
#LASSPgrzoom .xygraph
#LASSPgrcursor .xygraph "format {%.1lf,   %.3lf} "
.xygraph element create data0
.xygraph element create data1
.xygraph element create data2
.xygraph element create data3
.xygraph element create data4
.xygraph element configure data0 -fg blue
.xygraph element configure data1 -fg green
.xygraph element configure data2 -fg red
.xygraph element configure data3 -fg magenta
.xygraph element configure data4 -fg purple

.xygraph legend configure -mapped no
.xygraph xaxis configure -title "time"
.xygraph yaxis configure -title "displacement"
#mod rbr
LASSPgrzoom .xygraph
LASSPgrcursor .xygraph "format {%.1lf,   %.3lf} "
LASSPselection .display display display_type {
    global display_type
    if {$display_type=="single"} {
	.xygraph element show data0
    } elseif {$display_type=="triple"} {
	.xygraph element show {data0 data1 data2}
	 } else {
	.xygraph element show {data0 data1 data2 data3 data4}
    }
} "single" "triple" "quintuple"
LASSPselection_configure .display -font $font
LASSPselection_set .display "single"

button .copygraph -font $font -text "copy graph" -command {
		 if { [llength [lindex [.xygraph element config data0 -data] 4]] > 0 } {
		incr num_graphs 1
		graph_create .graph$num_graphs .xygraph
	 }
}


#label .spacer -width 25 -height 1
#pack .spacer -in .box2

pack .quit .disp_type .config .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top

pack .run .initialize .bc .initial .type   \
	-in .box1 -fill x -expand yes -padx 2 -pady 1
pack .waveamplitude  .wavevector .packetwidth  .centerx \
	.impuritymass .quarticconstant \
	-in .box2 -fill x -padx 2 -pady 1

packmenus

pack .speed -in .box2 -side bottom -fill x -padx 2 -pady 1
pack .xygraph -in .xygraphf -side bottom -expand yes -fill both -padx 2 
pack .display .copygraph -in .xygraphf -side left -fill both -padx 2 

pack .atomsf -side top -fill both -expand yes -padx 2 -pady 2
pack .box1 .box2 -side left -fill both  -padx 2 -pady 2
pack .xygraphf -side bottom -fill both -expand yes -padx 2 -pady 2
wm minsize . 610 472
#mod rbr
tk_setPalette #d9d9d9



############################## special bindings #######################3
bind . <Key-space> {.run invoke}
bind . <Key-i> {.initialize invoke}
bind . <Key-Escape> {.quit invoke}
# mod rbr
bind . <Destroy> {if { ![winfo exists .] } {.quit invoke} }


#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#button
	.run configure -font $font
	.initialize configure -font $font

	#selection
	LASSPselection_configure .bc -font $font
	LASSPselection_configure .type -font $font
	LASSPselection_configure .initial -font $font

	LASSPselection_configure .display -font $font

	LASSPselection_configure .disp_type -font $font

	#scale
	LASSPscale2_configure .wavevector -font $font
	LASSPscale2_configure .waveamplitude -font $font
	LASSPscale2_configure .packetwidth -font $font
	LASSPscale2_configure .centerx -font $font
	LASSPscale2_configure .impuritymass -font $font
	LASSPscale2_configure .quarticconstant -font $font
	LASSPscale2_configure .speed -font $font

	#presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.config configure -font $font
	.help configure -font $font
	.quit configure -font $font
     .copygraph configure -font $font

	#graphs
	.xygraph configure -font $font
	.xygraph xaxis config -font $font -ticklength 6
	.xygraph yaxis config -font $font -ticklength 6
	
	#canvas
	if { ".atoms" == [info commands .atoms] } {
		.atoms configure -width $wdth -height $hght
	}
	#procedures to redraw
        global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}

}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option








