set SSS_PROG "burgers"
#mod  mjb 8/27/97
set burgers_config_palette 0

#mod rbr to initialize
set scalex 20.0
set scaley 20.0

#mod rbr - create globals nx, ny first
set nx 14
set ny 14

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 500
set hght 500
proc startup {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 200
	set hght 200
	set disp_option "small"
	wm minsize . 460 350
	wm maxsize . 750 450
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}

	} elseif {$wd <= 800} {
		set wdth 350
		set hght 350
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 540 380
		wm maxsize . 1000 740
	 } else {
			set wdth 500
			set hght 500
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 750 550
			wm maxsize . 4000 3000
			}
}

proc set_para {} {
global wd ht wdth hght font disp_option nx ny tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 200
	set hght 200
	wm minsize . 460 350
	wm maxsize . 750 450
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}

	} elseif {$disp_option == "medium"} {
		set wdth 350
		set hght 350
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 500 380
		wm maxsize . 1000 740

	 } else {
			set wdth 500
			set hght 500
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 750 550
			wm maxsize . 4000 3000

			}
	# Configuring the font for all the widgets.
	config_all

#	if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}
	
}

#mod spt
startup
#------------------------------------------------------

############################# global variables #######################
set moves_per_display 1

# paused

# scalex
# scaley

# nx, ny
wm minsize . 1 1

set atomcolor0 {}
set atomcolor1 {blue}
set atomcolor2 {yellow}

################################ evolve stuff ###########################
proc evolve {} {
	 global paused moves_per_display
    if {$paused} {
        tkwait variable paused
    }
	 #mod rbr - add while loop
	 while { $paused == 0 } {
	burgers_evolve $moves_per_display
	update
    }
    update idletasks
    after 1 evolve
}
set paused 1
after 1 evolve


#################### general controls #################################
frame .controls

#label .title -text "Burgers" -height 3 
button .run -text "run" -font $font -height 2 -command {
    if {$paused} {
	.run configure -text "stop"
	set paused 0
    } else {
	.run configure -text "run"
	set paused 1
    }
}
button .reset -text "remove dislocations" -font $font -command {burgers_dislocations reset}
LASSPscale2 .alpha -text "alpha (Vo/a^2):" -var alpha -initial 10 -type real \
	-scrollmin 0 -scrollmax 20 -scrollinc .5 -scrolltype linear \
	-test {%v>0}
LASSPscale2_configure .alpha  -font $font
LASSPscale2 .beta -text "beta (Vo/a^2):" -var beta -initial 10 -type real \
	-scrollmin 0 -scrollmax 20 -scrollinc .5 -scrolltype linear  \
	-test {%v>0}
LASSPscale2_configure .beta  -font $font
LASSPscale2 .size1 -text "c/a ratio:" -var size1 -initial 1.0 -type real \
	-scrollmin 0 -scrollmax 2.0 -scrollinc .01 -scrolltype linear \
	-test {%v>0}
LASSPscale2_configure .size1  -font $font
LASSPscale2 .size2 -text "impurity size (a)" -var size2 -initial 0.6 -type real \
	-scrollmin 0 -scrollmax 2.0 -scrollinc .01 -scrolltype linear
LASSPscale2_configure .size2  -font $font
LASSPscale2 .speed -text "speed:" -var moves_per_display -initial 20 \
	-type integer -scrollmin 0 -scrollmax 50 -scrollinc 1 -scrolltype linear \
	-test {%v>0}
LASSPscale2_configure .speed  -font $font

label .vx -text "<delta x> (a) " -font $font

#mod spt to add top panel
frame .top_panel -relief sunken -bd 2

LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font



button .configure -text "configure..." -font $font -command {configure}
button .help -text "help..." -font $font -command {LASSPhelp2 .t2 [file join $SSS_DIR lib/burgers/burgers.htm]}
button .quit -text "quit" -font $font -command {exit}

#mod mjb 8/27/97
	 global burgers_config_palette
    if { $burgers_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set burgers_config_palette 1
    }

#################### shear force scale ################################
proc shearscale_set {} {
    global shearscale
    if {$shearscale=="coarse"} {
	LASSPscale2_configure .shearx -scrollmin -1.0 -scrollmax 1.0 -scrollinc .02
    } elseif {$shearscale=="fine"} {
	LASSPscale2_configure .shearx -scrollmin -0.10 -scrollmax 0.10 -scrollinc .002
    }
}

frame .shear
LASSPselection .shearscale {resolution:} shearscale shearscale_set coarse fine
LASSPselection_configure .shearscale -font $font
LASSPscale2 .shearx -text "x shear stress (Vo/a^3)" -var shearx -initial 0 -type real \
	-scrollmin -1.0 -scrollmax 1.0 -scrollinc .02 -scrolltype linear
LASSPscale2_configure .shearx  -font $font


pack .shearscale -in .shear -side left -fill y -padx [expr ($wdth - 150)/51]
pack .shearx -in .shear -side left -fill both -expand yes -padx [expr ($wdth - 150)/51]


#################### atom display  ################################
proc atomcycle {index} {
    global nx ny 
    set i [expr ($index-1)%($nx-4)]
    set j [expr ($index-1)/($nx-4)]
    if [catch {set temp [burgers_atomset $i $j]}] return
    set type [lindex $temp 2]
    incr type
    if {$type==3} {set type 0}
    eval "burgers_atomset $i $j [lreplace $temp 2 2 $type]"
}

# this procedure should only be called by the burgers_configure procedure.
# It sets up the canvas display.  The atoms are created from within the
# c program.
proc burgers_configure_tcl {} {

	global wdth hght

	 catch {destroy .atoms}

	 canvas .atoms -relief raised -width $wdth -height $hght

	 bind .atoms <Configure> {
    	#mod rbr global
		global scalex scaley nx ny
		.atoms scale all 0 0 [expr %w.0/($nx.0-1.0)/$scalex] \
			[expr %h.0/($ny.0-1.0)/$scaley]
		set scalex [expr %w.0/($nx.0-1.0)]
		set scaley [expr %h.0/($ny.0-1.0)]
	 }


	 #bindings to set atoms to specific types
	 bind .atoms <Button-1> {atomcycle [.atoms find closest %x %y 3]}

	 #bindings to create dislocations
	 bind .atoms <Any-Button-3> {
		.atoms create line %x %y %x %y -tag line -arrow last -width 5
		set x0 %x
		set y0 %y
	 }
	 # mod rbr mac
	 bind .atoms <Any-Control-Button-1> {
		.atoms create line %x %y %x %y -tag line -arrow last -width 5
		set x0 %x
		set y0 %y
	 }
	 bind .atoms <Any-B3-Motion> {
		.atoms coords line $x0 $y0 %x %y
	 }
	 #mod rbr mac
	 bind .atoms <Any-Control-B1-Motion> {
		.atoms coords line $x0 $y0 %x %y
	 }
	 bind .atoms <ButtonRelease-3> {
		.atoms delete line
		burgers_dislocations positive \
			[expr $x0/$scalex]  [expr $y0/$scaley]  \
			[expr %x/$scalex]  [expr %y/$scaley]
	 }
	 #mod rbr mac
	 bind .atoms <Control-ButtonRelease-1> {
		.atoms delete line
		burgers_dislocations positive \
			[expr $x0/$scalex]  [expr $y0/$scaley]  \
			[expr %x/$scalex]  [expr %y/$scaley]
	 }
	 bind .atoms <Shift-ButtonRelease-3> {
		.atoms delete line
		burgers_dislocations negative \
			[expr $x0/$scalex]  [expr $y0/$scaley]  \
			[expr %x/$scalex]  [expr %y/$scaley]
	 }
	 #mod rbr mac
	 bind .atoms <Control-Shift-ButtonRelease-1> {
		.atoms delete line
		burgers_dislocations negative \
			[expr $x0/$scalex]  [expr $y0/$scaley]  \
			[expr %x/$scalex]  [expr %y/$scaley]
	 }

	 pack .atoms -fill both -expand yes -padx 5 -pady 5
}

################Display size options.##########################


LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font


################### Packing and Arrangement ####################

#pack .title -in .controls -side top -fill x -pady 2
#pack .atoms -fill both -expand yes -padx 5 -pady 5 -side left
pack forget .atoms
pack .quit .disp_type .configure .presets .help  -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top
#pack .atoms -fill both -expand yes -padx 5 -pady 5 -side left

pack .run -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
pack .reset -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
pack .alpha -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
pack .beta -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
pack .size1 -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
pack .size2 -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
pack .speed -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
pack .vx -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
#pack .presets -in .controls -side top -fill x -pady 2
#pack .configure -in .controls -side top -fill x -pady 2
#pack .help -in .controls -side top -fill x -pady 2
#pack .quit -in .controls -side top -fill x -pady 2


pack .controls -side right -fill y -padx 3 -pady 3 -expand yes

#spt

pack .shear -side bottom  -padx 3 -pady 3



################################## the presetsave procedure ############
proc presetsave {file} {
	 #global variables
	 foreach s {} {
		  global $s
		  puts $file "set $s [set $s]"
	 }

	 #selections
	 foreach s {.shearscale} {
		  set val [LASSPselection_set $s]
		  puts $file "LASSPselection_set $s \"$val\""
	 }

	 #sliders
	 foreach s {.alpha .beta .size1 .size2 .speed .shearx} {
		  set val [LASSPscale2_configure $s -scrollinc]
		  puts $file "LASSPscale2_configure $s -scrollinc $val"
		  set val [LASSPscale2_configure $s -scrollmin]
		  puts $file "LASSPscale2_configure $s -scrollmin $val"
		  set val [LASSPscale2_configure $s -scrollmax]
		  puts $file "LASSPscale2_configure $s -scrollmax $val"
		  set val [LASSPscale2_configure $s -scrolltype]
		  puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"

	set val [LASSPscale2_get $s]
		  puts $file "LASSPscale2_set -nocommand $s $val"
	 }

	 #atoms
	 global nx ny
	 puts $file "burgers_configure [expr $nx-4] [expr $ny-4]"
	 for {set i 0} {$i<$nx-4} {incr i} {
	for {set j 0} {$j<$ny-4} {incr j} {
		 set list [burgers_atomset $i $j]
		 puts $file "burgers_atomset $i $j $list"
	}
	 }
	 puts $file "burgers_display"
}

################################## create a configure window ############
# configure nx, ny
proc configure {} {
	 set w .burgersconfig
	 #mod rbr globalize outside of if
	 global nx ny STEPFRAC

	 if {[winfo exists $w]} {
#mod rbr
#	set list [winfo children $w]
#	set index [lsearch $list $w.controls]
#	set list [lreplace $list $index $index]
#	foreach win $list  {
#	    destroy $win
#	}
		raise $w
		  LASSPentry_set $w.nx.e [expr $nx-4]
		  LASSPentry_set $w.ny.e [expr $ny -4]
		  LASSPentry_set $w.stepfrac.e  $STEPFRAC
	 } else {
		toplevel $w
		wm title $w "burgers configure"
		frame $w.controls
		label $w.controls.l -text "burgers configure"
		button $w.controls.b -text close -command "destroy $w"
		button $w.controls.b2 -text revert -command "configure"
		pack $w.controls.l -side left -fill x -expand yes
		pack $w.controls.b2 -side left -fill x -expand yes
		pack $w.controls.b -side left -fill x -expand yes
		pack $w.controls -fill x -expand yes -pady 1
	# rbr was end of else here

		frame $w.nx
		label $w.nx.l -text "lattice width:"
		LASSPentry $w.nx.e {expr {[catch {expr ~[%W get]}] || ([%W get]<=0)\
		 || [catch {burgers_configure [%W get] [expr $ny-4]}]}  }

		  pack $w.nx.l  -side left
		  pack $w.nx.e  -side left -fill x -expand yes
		  pack $w.nx -fill x -expand yes -pady 1
		  LASSPentry_set $w.nx.e [expr $nx-4]

		  frame $w.ny
		  label $w.ny.l -text "lattice height:"
		  LASSPentry $w.ny.e  \
		 {expr {[catch {expr ~[%W get]}] || ([%W get]<=0)\
		 || [catch {burgers_configure [expr $nx-4] [%W get]}]}  }
		  pack $w.ny.l  -side left
		  pack $w.ny.e  -side left -fill x -expand yes
		  pack $w.ny -fill x -expand yes -pady 1
		  LASSPentry_set $w.ny.e [expr $ny -4]

		  frame $w.stepfrac
		  label $w.stepfrac.l -text "stepsize fraction:"
		  LASSPentry $w.stepfrac.e  \
				{expr {[catch {expr -[%W get]}] \
						 || !([%W get]>0) \
						 || !([%W get]<=1) \
						 || [catch {set STEPFRAC [%W get]}]  }   }
		  pack $w.stepfrac.l  -side left
		  pack $w.stepfrac.e  -side left -fill x -expand yes
		  pack $w.stepfrac -fill x -expand yes -pady 1
		  LASSPentry_set $w.stepfrac.e  $STEPFRAC
		 }
}


############################## special bindings #######################3
bind . <Key-space> {.run invoke}
bind . <Key-i> {.reset invoke}
bind . <Key-Escape> {.quit invoke}
# mod rbr
bind . <Destroy> { if { ![winfo exists .] } {.quit invoke} }

#------------------------------------------------------
proc config_all {} {

	global font wdth hght nx ny scalex scaley

	#buttons
	.run configure -font $font
	.reset configure -font $font

	# the scales
	LASSPscale2_configure .alpha  -font $font
	LASSPscale2_configure .beta  -font $font
	LASSPscale2_configure .size1  -font $font
	LASSPscale2_configure .size2  -font $font
	LASSPscale2_configure .speed  -font $font

	#label
	.vx configure -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	#canvas
#	.atoms configure -width $wdth -height $hght

	#buttons
	.configure configure -font $font
	.help configure -font $font
	.quit configure -font $font

	#selection
	LASSPselection_configure .shearscale -font $font

	#scale
	LASSPscale2_configure .shearx  -font $font

	#display
	LASSPselection_configure .disp_type -font $font

	#procedures to redraw
	#burgers_configure [expr $nx-4] [expr $ny-4]


	#RHS improving looks
	pack .run -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
	pack .reset -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
	pack .alpha -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
	pack .beta -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
	pack .size1 -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
	pack .size2 -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
	pack .speed -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]
	pack .vx -in .controls -side top -fill x -pady [expr ($wdth - 100)/50]

	pack .shearscale -in .shear -side left -fill y -padx [expr ($wdth - 150)/51]
	pack .shearx -in .shear -side left -fill both -expand yes -padx [expr ($wdth - 150)/51]

	#update
	#procedures to redraw  - moved to end rbr
	burgers_configure [expr $nx-4] [expr $ny-4]
	set wx [winfo width .atoms]
	set wy [winfo height .atoms]
	.atoms scale bottom 0 0 [expr $wx.0/($nx.0-1.0)/20.0] \
			[expr $wy.0/($ny.0-1.0)/20.0]
		set scalex [expr $wx.0/($nx.0-1.0)]
		set scaley [expr $wy.0/($ny.0-1.0)]
	burgers_display

      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}
}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option

