set SSS_PROG "debye"

############################## global variables ##################
set kpoints 5000
set nbins 50

set num_dos_graphs 0
set num_disp_graphs 0


set dos_show "density of modes"
set dispersion_type "symmetry directions"
set A 0

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0

proc startup {} {
global wd ht wdth hght font SCALE disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth [expr 600/3.0]
	set hght [expr 360/1.25]
	set disp_option "small"
	wm minsize . 640 400
	wm maxsize . 850 500
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	set SCALE 75

	} elseif {$wd <= 832} {
		set wdth [expr 700/2.5]
		set hght [expr 500/1.78]
		set disp_option "medium"
 	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 400
		wm maxsize . 1000 650
		set SCALE 130
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 910 510
			wm maxsize . 4000 3000
			set SCALE 200
			}
}

proc set_para {} {
global wd ht wdth hght font SCALE disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth [expr 600/3.0]
	set hght [expr 360/1.25]
	wm minsize . 640 400
	wm maxsize . 850 500
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	set SCALE 75

	} elseif {$disp_option == "medium"} {
		set wdth [expr 700/2.5]
		set hght [expr 500/1.78]
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 400
		wm maxsize . 1000 650
		set SCALE 130
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 910 510
         		wm maxsize . 4000 3000
			set SCALE 200
			}
	# Configuring the font for all the widgets.
	config_all

	#if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
		#wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
	#}

}


#mod spt
startup

################# the presetsave procedure ############################
proc presetsave {file} {
	 puts $file "set changed 0"
	 #global variables
	 foreach s {kpoints simulation debye}  {
		  global $s
		  puts $file "set $s [set $s]"
	 }

	 global nbins
	 #rbr save current nbins
	 puts $file {set pre_nbins $nbins}
	 puts $file "LASSPentry_set .controls.nbins.e $nbins"
	 puts $file "set nbins $nbins"
	 #rbr If nbins changed must run tcl_calculate to realloc density array
	 puts $file {if {$pre_nbins != $nbins} { tcl_calculate } }

	 #selections
	 foreach s {.dispersef.top.show .controls.compare .dosf.top.show \
		 .dosf.top.axes} {
		  set val [LASSPselection_set $s]
		  puts $file "LASSPselection_set $s \"$val\""
	 }
	 #sliders
	 foreach s {.dispersef.index.qx .dispersef.index.qy .dispersef.index.qz \
		 .controls.v_sound .controls.tmax} {
	set val [LASSPscale2_configure $s -scrollinc]
		  puts $file "LASSPscale2_configure $s -scrollinc $val"
		  set val [LASSPscale2_configure $s -scrollmin]
		  puts $file "LASSPscale2_configure $s -scrollmin $val"
		  set val [LASSPscale2_configure $s -scrollmax]
		  puts $file "LASSPscale2_configure $s -scrollmax $val"
		  set val [LASSPscale2_configure $s -scrolltype]
		  puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"
		  set var [LASSPscale2_configure $s -var]
		  global $var
	puts $file "LASSPscale2_set $s [set $var]"
	 }

	 foreach s {.controls.b .controls.lc .controls.mass} {
	set val [LASSPscale2_configure $s -scrollinc]
		  puts $file "LASSPscale2_configure $s -scrollinc $val"
		  set val [LASSPscale2_configure $s -scrollmin]
		  puts $file "LASSPscale2_configure $s -scrollmin $val"
		  set val [LASSPscale2_configure $s -scrollmax]
		  puts $file "LASSPscale2_configure $s -scrollmax $val"
		  set val [LASSPscale2_configure $s -scrolltype]
		  puts $file "LASSPscale2_configure $s -scrolltype $val"
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"
		  set var [LASSPscale2_configure $s -var]

	global $var
	set ins2 {$steps_tag}
	set ins1 [format "\[LASSPscale2_get %s\]" $s]
		  puts $file "if {$ins1 != [set $var]} {set changed 1}"
	puts $file "LASSPscale2_set $s [set $var]"
	 }

  puts $file {if {$changed == 0} {\
	  .dosf.graph tag configure $steps_tag -fg black}}

  #rbr recalculate again with other preset values loaded if nbins changed
  #rbr otherwise do partial calculation as before.
  puts $file {if {$pre_nbins != $nbins} { tcl_calculate } else {dosdebye_calculate; dos_compare; spec_heat_calculate; dos_display; global steps_tag; .dosf.graph tag configure $steps_tag -fg red} }
  #rbr clean up
  puts $file "unset pre_nbins"

}

#################configure window
proc configure {} {
	global font
	 set w .debyeconfig

	 if {[winfo exists $w]} {
		  set list [winfo children $w]
		  set index [lsearch $list $w.controls]
		  set list [lreplace $list $index $index]
		  foreach win $list  {
				destroy $win
		  }
		  raise $w
	 } else {
		  toplevel $w
		  wm title $w "debye configure"

	frame $w.controls
	button $w.controls.b -text close -font $font -command  "destroy .debyeconfig"
	button $w.controls.b2 -text revert -font $font -command "configure"
	pack $w.controls.b2 -side left -fill x -expand yes
	pack $w.controls.b -side left -fill x -expand yes
	pack $w.controls -fill x -expand yes -pady 1
	 }

	 frame $w.kpoints
	 label $w.kpoints.l -font $font -text "number of MC points"
	 LASSPentry $w.kpoints.e \
		 {expr {[catch {expr -[%W get]}] \
		 || !([%W get]>0) \
		 || [catch {set kpoints [%W get]}]}}
	 pack $w.kpoints.l -side left
	 pack $w.kpoints.e -side right
	 pack $w.kpoints

	 global kpoints
	 LASSPentry_set $w.kpoints.e $kpoints



}

################show things in dos graph
proc dos_display {} {
	 global dos_show
	 global comparison
	 global simulation debye
	 set showlist { }
    
    
    if {$dos_show == "density of modes"} {
	if {$simulation} {
	    set showlist [concat $showlist {dos_data}]
	}
	if {$debye} {
	    set  showlist [concat $showlist {dos_debye_data}]
	}
	.dosf.graph xaxis configure -title "frequency (10^12 rad/s)"
	.dosf.graph yaxis configure \
		-title "density of modes (10^9 s/cm^3)"
    } elseif {$dos_show == "heat capacity"} {
	if {$simulation} {
	    set showlist [concat $showlist {heat_data}]
	}
	if {$debye} {
	    set showlist [concat $showlist {heat_debye_data}]
	}
	.dosf.graph xaxis configure -title "temperature (K)"
	.dosf.graph yaxis configure -title "heat capacity (J/(K cm^3))"
    } elseif {$dos_show == "internal energy"} {
	if {$simulation} {
	    set showlist [concat $showlist {energy_data0 energy_data1 \
		    energy_data2 energy_data3 energy_data4 energy_data5 \ 
	    energy_data6 energy_data7 energy_data8 energy_data9 energy_data10}]
	}
	if {$debye} {
	    set showlist [concat $showlist {d_energy_data0 d_energy_data1 \
		    d_energy_data2 d_energy_data3 d_energy_data4 d_energy_data5 \ 
	    d_energy_data6 d_energy_data7 d_energy_data8 d_energy_data9 d_energy_data10}]
	}
	.dosf.graph xaxis configure -title "frequency (10^12 rad/s)"
	.dosf.graph yaxis configure -title "internal energy (10^-14 J s/cm^3)"
    }

    if {($comparison == "copper") && ($dos_show == "heat capacity")} { 
	set showlist [concat $showlist {copper_data}]
    }
    if {($comparison == "lead") && ($dos_show == "heat capacity")} {
	set showlist [concat $showlist {lead_data}]
    } 
    if {($comparison == "aluminum") && ($dos_show == "heat capacity")} {
	set showlist [concat $showlist {aluminum_data}]
    } 

    set shcmd {.dosf.graph element show }
    lappend shcmd $showlist
    eval $shcmd
}

################ show things in dispersion graph #####################
proc dispersion_display {} {
    global dispersion_type
    global comparison
    global bz1 bz2 bz3
    global ind1 ind2 ind3
    global name1 name2 name3
    global lc


    set showlist {}
    if {$dispersion_type == "symmetry directions"} {
	.dispersef.graph xaxis configure -showticks no
	set showlist [concat $showlist {repeated_zone}]
	.dispersef.graph tag coords $bz1\
		"[expr 2*3.1416/$lc] -Inf [expr 2*3.1416/$lc] Inf"
	.dispersef.graph tag coords $ind1 "[expr 2*3.1416/$lc/2.0] -Inf"
	.dispersef.graph tag coords $name1 "[expr 2*3.1416/$lc] -Inf"
	.dispersef.graph tag coords $bz2\
		"[expr (sqrt(2) +1)*2*3.1416/$lc] -Inf \
		[expr (sqrt(2)+1)*2*3.1416/$lc] Inf" 
	.dispersef.graph tag coords $name2 \
		"[expr (3.3)*2*3.1416/$lc] -Inf"
	.dispersef.graph tag coords $ind2 \
		"[expr (2.3/2 -sqrt(2)/2 -1/2 +sqrt(2) +1)*2*3.1416/$lc] -Inf" 
	.dispersef.graph tag coords $bz3\
		"[expr (1+sqrt(2)/4.)*2*3.1416/$lc] -Inf \
		[expr (1+sqrt(2)/4.)*2*3.1416/$lc] Inf" 
	.dispersef.graph tag coords $name3 \
		"[expr (1+sqrt(2)/4.)*2*3.1416/$lc] -Inf"
	.dispersef.graph tag coords $ind3 \
		"[expr (sqrt(2)/2+1)*2*3.1416/$lc] -Inf"


    } elseif {$dispersion_type =="arbitrary direction"} {
	.dispersef.graph xaxis configure -showticks yes
	set showlist [concat $showlist {single_zone}]
    }

    if {$comparison == "copper"} {
	set showlist [concat $showlist {copper_data}]
    }
    if {$comparison == "lead"} { 
	set showlist [concat $showlist {lead_data}]
    }
    if {$comparison == "aluminum"} { 
	set showlist [concat $showlist {aluminum_data}]
    }
    
    set shcmd {.dispersef.graph element show }
    lappend shcmd $showlist
    eval $shcmd

}

################compare with experimental data

proc dos_compare {} {  
    global SSS_DIR comparison Tmax M lc 
   
    if {[lsearch [.dosf.graph element names] copper_data] >= 0} {
	.dosf.graph element configure copper_data -data {}
    } else {
	.dosf.graph element create copper_data -fg orange -linewidth 0 \
		-symbol diamond -data {}
    }
    if {[lsearch [.dosf.graph element names] lead_data] >= 0} {
	.dosf.graph element configure lead_data -data {}
    } else {
	.dosf.graph element create lead_data -fg black\
		-linewidth 0 -symbol diamond -data {} 
    }
    if {[lsearch [.dosf.graph element names] aluminum_data] >= 0} {
	.dosf.graph element configure aluminum_data -data {}
    } else {
	.dosf.graph element create aluminum_data -fg green\
		-linewidth 0 -symbol diamond -data {} 
    }
    
    set lc_cu 3.61
    set M_cu 0.1055
    
    if {$comparison == "copper"} {
	set data_file [open $SSS_DIR/lib/debye/cu_heat.dat]
	set cu_scale [expr 4.*$M_cu*1.e3*4.18/($lc_cu*$lc_cu*$lc_cu) ]
	while {[gets $data_file point] >= 0} {
	    if {[llength $point] > 0} {
		set x_temp [lindex $point 0]
		if {$x_temp < $Tmax} {
		    set y_temp [ expr [lindex $point 1] * $cu_scale]
		    .dosf.graph element append copper_data [list $x_temp $y_temp]
		}
	    }
	}
    }

    set lc_pb 4.95
    set M_pb 0.344
    
    if {$comparison == "lead"} {
	set pb_scale [expr 4.*$M_pb*1.e3*4.18/($lc_pb*$lc_pb*$lc_pb) ]
	set data_file [open $SSS_DIR/lib/debye/pb_heat.dat]
	while {[gets $data_file point] >= 0} {
	    if {[llength $point] > 0} {
		set x_temp [lindex $point 0]
		if {$x_temp < $Tmax} {
		    set y_temp [ expr [lindex $point 1] * $pb_scale]
		    .dosf.graph element append lead_data [list $x_temp $y_temp]
		}
	    }
	}
    }

    set lc_al 4.05
    set M_al 0.0448
    
    if {$comparison == "aluminum"} {
	set al_scale [expr 4.*$M_al*1.e3*4.18/($lc_al*$lc_al*$lc_al) ]
	set data_file [open $SSS_DIR/lib/debye/al_heat.dat]
	while {[gets $data_file point] >= 0} {
	    if {[llength $point] > 0} {
		set x_temp [lindex $point 0]
		if {$x_temp < $Tmax} {
		    set y_temp [ expr [lindex $point 1] * $al_scale]
		    .dosf.graph element append aluminum_data [list $x_temp $y_temp]
		}
	    }
	}
    }


    dos_display
}

#############compare dispersion relations with experiment

proc dispersion_compare {} {
    global qx qy qz
    global comparison
    global SSS_DIR
    global lc
    global dispersion_type
   
    .dispersef.graph element configure copper_data -data {}
    .dispersef.graph element configure lead_data -data {}
    .dispersef.graph element configure aluminum_data -data {}
   
    if {($qx==0) && ($qy==0) && ($qz==0)} {
	return
    }

    if {$dispersion_type == "arbitrary direction"} {
	set qlist [lsort -integer -decreasing \
		"[expr abs($qx)] [expr abs($qy)] [expr abs($qz)]"]
	
	set a [lindex $qlist 0]; set b [lindex $qlist 1]
	set c [lindex $qlist 2]
	if {$c !=0} {
	    set a [expr $a/(1.*$c)]; set b [expr $b/(1.*$c)]
	    set c [expr $c/(1.*$c)]
	} elseif {$b !=0} {
	    set a [expr $a/(1.*$b)]; set b [expr $b/(1.*$b)]
	    set c [expr 1.0*$c]
	} else {
	    set a [expr $a/(1.*$a)]; set b [expr 1.0*$b]
	    set c [expr 1.0*$c]
	}
	set show [expr int($a)][expr int($b)][expr int($c)]
	
	set factor [expr sqrt(abs($a) + abs($b) + abs($c))*2*3.1416]
	if {(($show == 111) || ($show == 110) || ($show == 100)) && \
	    ([expr ceil($a)] == $a) && [expr ceil($b) == $b] && \
	    [expr ceil($c)] == $c} {
	  
	set lc_cu 3.61
	if {$comparison == "copper"} {
		set data_file [open $SSS_DIR/lib/debye/cu${show}.dat]
		while {[gets $data_file point] >= 0} {
		    if {[llength $point] > 0} {
			set y_temp [expr 2*3.1416*[lindex $point 1]]
			set x_temp [ expr \
				[lindex $point 0]*$factor/$lc]
			.dispersef.graph element append \
				copper_data [list $x_temp $y_temp]
		    }
		}
		close $data_file
		
	    }
	    
	    set lc_pb 4.95
	    if {$comparison == "lead"} {
		set data_file [open $SSS_DIR/lib/debye/pb${show}.dat]
		while {[gets $data_file point] >= 0} {
		    if {[llength $point] > 0} {
			set y_temp [expr 2*3.1416*[lindex $point 1]]
			set x_temp [ expr \
				[lindex $point 0]*$factor/$lc]
			.dispersef.graph element append \
				lead_data [list $x_temp $y_temp]
		    }
		}   
	    
		close $data_file
	    }
	    
	    set lc_al 4.05
	    if {$comparison == "aluminum"} {
		set data_file [open $SSS_DIR/lib/debye/al${show}.dat]
		while {[gets $data_file point] >= 0} {
		    if {[llength $point] > 0} {
			set y_temp [expr 2*3.1416*[lindex $point 1]]
			set x_temp [ expr \
				[lindex $point 0]*$factor/$lc]
			.dispersef.graph element append \
				aluminum_data [list $x_temp $y_temp]
		    }
		}   
	    
		close $data_file
	    }
	}
    }  elseif {$dispersion_type == "symmetry directions"} {
	
	    if {$comparison != "nothing"} {
		if {$comparison == "copper"} {
		    set name cu
		} elseif {$comparison == "lead"} {
		    set name pb
		} elseif {$comparison == "aluminum"} {
		    set name al
		}
		set ys [expr 2.*3.1416]
		set data_file [open $SSS_DIR/lib/debye/${name}100.dat]
		set tp [expr 2.*3.14]
		while {[gets $data_file point] >= 0} {
		    if {[llength $point] > 0} {
			set x_temp [expr [lindex $point 0]*$tp/$lc]
			set y_temp [expr [lindex $point 1]*$ys]
			.dispersef.graph element append ${comparison}_data [list $x_temp $y_temp]
		    }
		}
		close $data_file
		set data_file [open $SSS_DIR/lib/debye/${name}110.dat]
		set tp [expr 2*3.1416*sqrt(2)]
		set temp_add [expr 2*3.1416/$lc]
		# [expr 2*3.14*(1+sqrt(2))]
		while {[gets $data_file point] >= 0} {
		    if {[llength $point] > 0} {
			set x_temp [expr ((1-[lindex $point 0])*$tp/$lc +$temp_add)]
			set y_temp [expr [lindex $point 1]*$ys]
			.dispersef.graph element append ${comparison}_data [list $x_temp $y_temp]
		    }
		}
		close $data_file
		set data_file [open $SSS_DIR/lib/debye/${name}111.dat]
		set tp [expr 2*3.14*sqrt(3)]
		set temp_add [expr (1+sqrt(2))*2*3.1416/$lc]
		while {[gets $data_file point] >= 0} {
		    if {[llength $point] > 0} {
			set x_temp [expr [lindex $point 0]*$tp/$lc +$temp_add]
			set y_temp [expr [lindex $point 1]*$ys]
			.dispersef.graph element append ${comparison}_data [list $x_temp $y_temp]
		    }
		}
		close $data_file

	    }
	    
	
	
    }
    

    dispersion_display
}

#########################################################


proc do_dispersion {} {
    global dispersion_type qx qy qz
    if {$dispersion_type == "arbitrary direction"} { 
	if {($qx!=0) || ($qy!=0) || ($qz!=0)} {
	    dispersion_calculate
	    dispersion_compare
	}
    }
}

######################################################
proc tcl_calculate {} {

    global add

#mod rbr cursor watch, update without idletasks for mac
    . config -cursor watch; update;	
    set add 0; dos_calculate; 
    dosdebye_calculate; 
    energy_calculate; spec_heat_calculate;
    dos_display; dispersion_display; 
    global steps_tag; global sum_kpoints; 
    .dosf.graph tag configure \
	    $steps_tag -text "MC steps:  $sum_kpoints" -fg black;
    . config -cursor {}
}

##################frames, graphs

frame .dispersef 
blt_graph .dispersef.graph -width $wdth -height $hght -relief raised -bd 2\
	-plotbackground white
.dispersef.graph element create repeated_zone -linewidth 0 -symbol diamond -scale 0.5
set bz1 [.dispersef.graph tag create line "" -element repeated_zone -fg red] 
set bz2 [.dispersef.graph tag create line "" -element repeated_zone -fg red]
set bz3 [.dispersef.graph tag create line "" -element repeated_zone \
	-dashes 10 -fg red]
set ind1 [.dispersef.graph tag create text "" -anchor s \
	-element repeated_zone -text 100] 
set ind2  [.dispersef.graph tag create text "" -anchor s \
	-element repeated_zone -text 111] 
set ind3  [.dispersef.graph tag create text "" -anchor s \
	-element repeated_zone -text 110] 
set name1  [.dispersef.graph tag create text "" -anchor s \
	-element repeated_zone -text X] 
set name2  [.dispersef.graph tag create text "" -anchor s \
	-element repeated_zone -text L] 
set name3  [.dispersef.graph tag create text "" -anchor s \
	-element repeated_zone -text K] 

.dispersef.graph element create single_zone -linewidth 0 -symbol diamond -scale 0.5
.dispersef.graph element create copper_data -linewidth 0 -fg orange \
	-symbol diamond
.dispersef.graph element create lead_data -linewidth 0 -fg black \
	-symbol diamond 
.dispersef.graph element create aluminum_data -linewidth 0 -fg green \
	-symbol diamond 
.dispersef.graph legend configure -mapped no
LASSPgrzoom .dispersef.graph
LASSPgrcursor .dispersef.graph "format {%.3lf,   %.3lf} "

.dispersef.graph xaxis configure -title "wave vector (1/A)"
.dispersef.graph yaxis configure -title "frequency (10^12 rad/s)"

frame .dispersef.top

LASSPselection .dispersef.top.show "show: " dispersion_type \
	{dispersion_display; dispersion_calculate; dispersion_compare} \
	"symmetry directions" "arbitrary direction"
LASSPselection_configure .dispersef.top.show -font $font

button .dispersef.top.copygraph -font $font -text "copy graph" -command {
    incr num_disp_graphs 1
    graph_create .dispersegraph$num_disp_graphs .dispersef.graph 
    
}


frame .dispersef.index

LASSPscale2 .dispersef.index.qx -var qx -text "q_x" -type integer \
	-scrollmin 0 -scrollmax 5 -initial 1 \
	-command do_dispersion
LASSPscale2_configure .dispersef.index.qx  -font $font

LASSPscale2 .dispersef.index.qy -var qy -text "q_y" -type integer \
	-scrollmin 0 -scrollmax 5 -initial 1 \
	-command do_dispersion
LASSPscale2_configure .dispersef.index.qy  -font $font

LASSPscale2 .dispersef.index.qz -var qz -text "q_z" -type integer \
		 -scrollmin 0 -scrollmax 5 -initial 1 \
		 -command do_dispersion
LASSPscale2_configure .dispersef.index.qz  -font $font


frame .controls
button .controls.calc -font $font -height 2 -text "calculate" \
	-command {tcl_calculate}
#mod rbr cursor watch, update without idletasks for mac
button .controls.add -font $font -text "double MC steps" -height 2 \
	-command {. config -cursor watch; update; \
	set add 1; dos_calculate; \
	energy_calculate; spec_heat_calculate;\
	dos_display; dispersion_display; \
	global steps_tag; global sumpoints; \
	.dosf.graph tag configure $steps_tag -text "MC steps: $sum_kpoints"; \
	. config -cursor {}}


	 frame .controls.nbins
	 label .controls.nbins.l -font $font -text "number of bins"
	 #mod rbr - add tcl_calculate to change of nbins
	 LASSPentry .controls.nbins.e \
		 {expr {[catch {expr -[%W get]}] \
		 || !([%W get]>0) \
		 || [catch {set holdit $nbins; set nbins [%W get]; if {$nbins != $holdit} {tcl_calculate}}]}} -width 4
	 pack .controls.nbins.l -side left
	 pack .controls.nbins.e -side right

	 global nbins
	 LASSPentry_set .controls.nbins.e $nbins



checkbutton .controls.sim -font $font -text "simulation" -var simulation \
	-command dos_display -relief raised -height [expr $SCALE/100]
checkbutton .controls.debye -font $font -text "Debye" -var debye \
	-command dos_display -relief raised -height [expr $SCALE/100]
#menubutton .controls.model -menu .controls.model.menu -relief raised\
	-text "model"
#menu .controls.model.menu
#.controls.model.menu add checkbutton -label "simulation" -var simulation \
	-command dos_display
#.controls.model.menu add checkbutton -label "Einstein" -var einstein \
	-command dos_display
#.controls.model.menu add checkbutton -label "Debye" -var debye \
	-command dos_display
set simulation 1


LASSPselection .controls.compare "compare with: " comparison \
	{dos_compare; dispersion_compare} \
	"nothing" "lead" "copper" "aluminum"
set comparison "nothing"
LASSPselection_configure .controls.compare -font $font

#menubutton .controls.compare -menu .controls.compare.menu -relief raised\
	-text "compare with"
#menu .controls.compare.menu
#.controls.compare.menu add checkbutton -label "lead" -var lead \
	-command {dos_compare; dispersion_compare}
#.controls.compare.menu add checkbutton -label "copper" -var copper \
	-command {dos_compare; dispersion_compare}

#LASSPscale2 .controls.a -var A -text "A (N/m)" \
#	-scrollmin 0 -scrollmax 10 -initial 0 \
#	-command {dispersion_calculate; dispersion_compare; \
#	global steps_tag; .dosf.graph tag configure $steps_tag -fg red }
LASSPscale2 .controls.b -var B -text "force const B (N/m)" \
	-scrollmin 0 -scrollmax 10 -initial 10  -test {%v > 0.0} \
	-command {dispersion_calculate; dispersion_compare; \
	global steps_tag; .dosf.graph tag configure $steps_tag -fg red }
LASSPscale2_configure .controls.b  -font $font
    
LASSPscale2 .controls.v_sound -var v_sound -text "v_s (10^6 cm/s)" \
	-scrollmin 0 -scrollmax 1 -initial 0.13  -test {%v > .00} \
	-command {dosdebye_calculate; spec_heat_calculate; energy_calculate; \
	dos_display}
LASSPscale2_configure .controls.v_sound  -font $font

LASSPscale2 .controls.tmax -var Tmax -text "Tmax (K)" \
	-scrollmin 0 -scrollmax 300 -initial 100 -test {%v >= 10.0} \
	-command {spec_heat_calculate; energy_calculate; dos_compare}
LASSPscale2_configure .controls.tmax  -font $font

LASSPscale2 .controls.lc -text "lattice const (A)" -scrollmin 0 \
	-scrollmax 10 -initial 4.95 -var lc -test {%v > 0.0} \
	-command {dispersion_calculate; dispersion_compare;\
	global steps_tag; .dosf.graph tag configure $steps_tag -fg red }
LASSPscale2_configure .controls.lc  -font $font

LASSPscale2 .controls.mass -text "mass (10^-24 kg)" -var M -scrollmin 0 \
	-scrollmax 1 -initial 0.344 -test {%v > 0.0}\
	-command {dispersion_calculate; dispersion_compare; \
	global steps_tag; .dosf.graph tag configure $steps_tag -fg red }
LASSPscale2_configure .controls.mass  -font $font

#mod spt to add top panel
frame .top_panel -relief sunken -bd 2

LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

frame .dosf 
blt_graph .dosf.graph -width $wdth -height $hght -relief raised -bd 2\
	-plotbackground white
.dosf.graph element create dos_data -fg blue
.dosf.graph element create dos_debye_data -fg red
.dosf.graph element create heat_data -fg blue
.dosf.graph element create heat_debye_data -fg red
LASSPgrzoom .dosf.graph
LASSPgrcursor .dosf.graph "format {%.4lg,   %.4lg} "

.dosf.graph legend configure -mapped no
set steps_tag [.dosf.graph tag create text "Inf Inf" -text "MC steps:     0" \
	-anchor ne]

frame .dosf.top
LASSPselection .dosf.top.show "show: " dos_show {dos_display} \
	"density of modes" "heat capacity" "internal energy"
LASSPselection_configure .dosf.top.show -font $font

LASSPselection .dosf.top.axes " " axes \
	{if {$axes=="log/log"} { \
	.dosf.graph xaxis configure -min .1; \
	.dosf.graph xaxis configure -logscale 1; \
	.dosf.graph yaxis configure -logscale 1;} else { \
	.dosf.graph xaxis configure -logscale 0; \
	.dosf.graph yaxis configure -logscale 0; \
	.dosf.graph xaxis configure -min 0}} \
	"linear" "log/log"
LASSPselection_configure .dosf.top.axes -font $font

# mod rbr - to fix crash from copying an empty graph
button .dosf.top.copygraph -text "copy graph" -font $font -command {
    if { (($simulation != 0) || ($debye != 0)) && ($sum_kpoints != 0) } {
	incr num_dos_graphs 1
	graph_create .dosgraph$num_dos_graphs .dosf.graph
    } 
    
}


frame .dosf.bottom

button .configure -text "configure..." -font $font -command {configure} -width 10
button .help -text "help..." -font $font -command {LASSPhelp2 .t2 [file join $SSS_DIR lib/debye/debye.htm]} -width 10
button .quit -text quit -font $font -command {exit}

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font


###########packing

pack .quit .disp_type .configure .presets .help -in .top_panel -side left \
	-fill x -padx 10
pack .top_panel -side top

pack .dispersef.index.qx -side left -expand 1 -fill x 
pack .dispersef.index.qy -side left -expand 1 -fill x 
pack .dispersef.index.qz -side left -expand 1 -fill x 

pack .dispersef.top.show -side left -expand 1
pack .dispersef.top.copygraph -side right -expand 1


pack .dispersef.top -pady 2 -fill x
pack .dispersef.index  -fill x -expand no -pady 2
pack .dispersef.graph -fill both -expand no -pady 2
pack .dispersef -side left -expand 0 -fill x

pack .controls.calc -fill x
pack .controls.add -fill x
pack .controls.nbins
#pack .controls.model -fill x
pack .controls.sim -fill x
pack .controls.debye -fill x
pack .controls.compare -fill x
#pack .controls.a -fill x
pack .controls.b -fill x
pack .controls.v_sound -fill x
pack .controls.tmax -fill x
pack .controls.lc -fill x
pack .controls.mass -fill x
pack .controls -side left -fill x

pack .dosf.top.show -side top -pady 2
pack .dosf.top.axes -side left -expand 1
pack .dosf.top.copygraph -side left -expand 1

pack .dosf.top -fill x
pack .dosf.graph -fill both -expand yes -pady 2
pack .dosf.bottom -side bottom
pack .dosf -expand 1 -fill x

#mod rbr for color
tk_setPalette #d9d9d9



############################## special bindings #######################3
#mod rbr update without idletasks
bind . <KeyPress-space> {
    .controls.calc configure -relief sunken
    update
    .controls.calc invoke
    .controls.calc configure -relief raised
}
bind . <KeyPress-d> {
    .controls.add configure -relief sunken
    update
    .controls.add invoke
    .controls.add configure -relief raised
}
bind . <Key-Escape> {.dosf.bottom.quit invoke}



proc config_all {} {

global font wdth hght SCALE

# graph
.dispersef.graph configure -width $wdth -height $hght
.dosf.graph configure -width $wdth -height $hght
.dispersef.graph configure -font $font
.dispersef.graph xaxis config -font $font -ticklength 6
.dispersef.graph yaxis config -font $font -ticklength 6
.dosf.graph configure -font $font
.dosf.graph xaxis config -font $font -ticklength 6
.dosf.graph yaxis config -font $font -ticklength 6
	

# selection
LASSPselection_configure .dispersef.top.show -font $font

#button
.dispersef.top.copygraph configure -font $font 

#scales
LASSPscale2_configure .dispersef.index.qx  -font $font
LASSPscale2_configure .dispersef.index.qy  -font $font
LASSPscale2_configure .dispersef.index.qz  -font $font

#button
.controls.calc configure -font $font
.controls.add configure -font $font

#label
.controls.nbins.l configure -font $font

#checkbuttons
.controls.sim configure -font $font  -height [expr $SCALE/100]
.controls.debye configure -font $font  -height [expr $SCALE/100]

#selection
LASSPselection_configure .controls.compare -font $font

#scales
LASSPscale2_configure .controls.b  -font $font
LASSPscale2_configure .controls.v_sound  -font $font
LASSPscale2_configure .controls.tmax  -font $font
LASSPscale2_configure .controls.lc  -font $font
LASSPscale2_configure .controls.mass  -font $font

#presets
LASSPpresets_configure .presets -font $font

#selection
LASSPselection_configure .dosf.top.show -font $font
LASSPselection_configure .dosf.top.axes -font $font

#buttons
.dosf.top.copygraph configure -font $font
.configure configure -font $font
.help configure -font $font
.quit configure -font $font

#selection
LASSPselection_configure .disp_type -font $font

#redraw
      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}

}


# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option

