set SSS_PROG "drude"
set drude_config_palette 0

## TO DO:  modify Motion binds to canvas_hw etc !!!!!

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set canvas_hw 0

proc startup {} {
global wd ht canvas_hw font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set canvas_hw 112
	wm minsize . 630 430
	wm maxsize . 750 480
	set disp_option "small"
	if { $tcl_platform(platform) == "unix" } {
	    set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
	    set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
        } elseif {$wd <= 832} {
		set canvas_hw 150
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 730 430
		wm maxsize . 870 480
		set disp_option "medium"
	 } else {
		set canvas_hw 200
		set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
		wm minsize . 930 510
		wm maxsize . 4000 3000
		set disp_option "large"
		}
}

proc set_para {} {
global wd ht canvas_hw font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set canvas_hw 112
	wm minsize . 630 430
	wm maxsize . 750 480
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}

        } elseif {$disp_option == "medium"} {
		set canvas_hw 150
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 730 430
		wm maxsize . 870 480
	 } else {
			set canvas_hw 200
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 930 510
			wm maxsize . 4000 3000
			}
	# Configuring the font for all the widgets.
	config_all

	
#	if {[winfo reqwidth .] > $wd } {
#		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}

}


#mod spt
startup

#########set two arrays for the data for the graph to go into
set data_xv {}
set data_yv {}
set data_xv2 {}
set data_yv2 {}
set data_e {}
set data_e2 {}
set data_x {}
set data_y {}
set data_x2 {}
set data_y2 {}

set n_e 32
set num_graphs 0

#########set the delay between updates of the graph
set graph_update_delay 10

################## tcl initialize ############################
proc tcl_initialize {} {
    
    # get the time step
    get_time_step

    # initialize positions and wave vectors 
    drude_initialize

	 # reset graph

	 #mod rbr
    draw_e_field

}


##update the reciprocal space graph, with a guard against 0-length data arrays
proc graph_update {} {
    global data_xv data_yv
    global data_xv2 data_yv2
    global data_e


    if {[llength $data_xv] > 0} {
	.graph_window.graph element append x_velocity $data_xv
	set data_xv {}
	.graph_window.graph element append x_velocity2 $data_xv2
	set data_xv2 {}
	.graph_window.graph element append y_velocity $data_yv
	set data_yv {}
	.graph_window.graph element append y_velocity2 $data_yv2
	set data_yv2 {}

    }

    if {[llength $data_e] > 0} {
	.graph_window.graph element append e_field $data_e
	set data_e {}           
    }
    graph_display
}

# update the real space graph, with a guard against 0-length data arrays
proc graph2_update {} {
    global data_x data_y
    global data_x2 data_y2
    global data_e2
    
    if {[llength $data_x] > 0} {
	.graph2_window.graph element append x_pos $data_x
	set data_x {}
	.graph2_window.graph element append x_pos2 $data_x2
	set data_x2 {}
	.graph2_window.graph element append y_pos $data_y
	set data_y {}
	.graph2_window.graph element append y_pos2 $data_y2
	set data_y2 {}
	 }
    if {[llength $data_e2] > 0} {
	.graph2_window.graph element append e_field $data_e2
	set data_e2 {}
    }
    graph2_display
}


###################### draw e-field in canvas #################
proc draw_e_field {} {
	 global E_x E_y phi canvas_hw omega

    #mod rbr
	 if { [expr abs($omega)]  < 0.001 } {
		set omega 0.0
		set phi 0.0
		LASSPscale2_set -nocommand .control.variables.phi 0.0
		}

	 .recipf.can coords e_fieldbar [expr $canvas_hw] [expr $canvas_hw/4.] [expr $canvas_hw+$E_x*10.0] \
	[expr $canvas_hw/4.-$E_y*cos($phi)*10.0] 
# size of e_fieldbar needs to be changed in tcl and C part
}

######################### tcl wrapper to get time step - mod rbr ########
proc get_time_step_tcl {} {
	global omega phi
	if { [expr abs($omega)] < .001 } {
		set omega 0.0
		set phi 0.0
      LASSPscale2_set -nocommand .control.variables.phi 0.0
		}
	get_time_step
}

 
####find the highest number in a list
proc get_highest {num_list} {
    set highest 0
    foreach i $num_list {
	if {$i > $highest} {
	    set highest $i
	}
    }
    return $highest
}

####while running, do the Runge-Kutta integration for one time step
proc tcl_evolve {} {
    global running
    while {$running == 1} {
	drude_evolve
	update
    }
}


#######show the graph of v_x and E_x vs time (toggle on and off)
proc graph_toggle {} {
	 global show_graph font
    global B_z
    if {$show_graph} {
	toplevel .graph_window
 #	wm minsize .graph_window 1 1 
	wm title .graph_window "velocity space"
	global num_graphs
	
	frame .graph_window.menu
	
	#mod rbr
	bind .graph_window <Destroy> {
	    if { [string compare %W ".graph_window"] == 0 } {
		global show_graph
		if { $show_graph == 1 } {
		    set show_graph 0
		    update
		}
	    }
	}

	button .graph_window.menu.configure  -font $font -text configure \
		-command "graph_config .graph_window.graph"
	# mod rbr - make sure destroy toggles graph
	#bind .graph_window <Destroy> "if { [winfo exists .graph_window] } {.recipf.top.graph invoke}"
	# end mod
	button .graph_window.menu.close -font $font -text "close"\
		-command ".recipf.top.graph invoke"
	blt_graph .graph_window.graph -width 400 -height 300 \
		-plotbackground white
	.graph_window.graph legend configure -mapped yes
	.graph_window.graph xaxis configure -title "time (ps)" 
	.graph_window.graph configure -leftmargin 0
	LASSPgrzoom .graph_window.graph
	LASSPgrcursor .graph_window.graph "format {%.3lf %.3lf}"
	.graph_window.graph element create e_field
	.graph_window.graph element configure e_field -fg red
	.graph_window.graph element configure e_field -label "E_x"
	.graph_window.graph element create x_velocity
	.graph_window.graph element configure x_velocity -fg blue
	.graph_window.graph element configure x_velocity -label "x"
	.graph_window.graph element create x_velocity2
	.graph_window.graph element configure x_velocity2 -fg blue
	.graph_window.graph element configure x_velocity2 -label "x"
	.graph_window.graph element create y_velocity
	.graph_window.graph element configure y_velocity -label "y"
	.graph_window.graph element configure y_velocity -fg green
	.graph_window.graph element create y_velocity2
	.graph_window.graph element configure y_velocity2 -label "y"
	.graph_window.graph element configure y_velocity2 -fg green
	graph_display
	
	button .graph_window.menu.copygraph -text "copy graph" -font $font -command {
	    global num_graphs
	    incr num_graphs 1
	    graph_create .graph$num_graphs .graph_window.graph 
	}
	

	pack .graph_window.menu.copygraph -side right
	pack .graph_window.menu.configure -side right
	pack .graph_window.menu.close -side right
	pack .graph_window.menu 
	pack .graph_window.graph -expand yes -fill both
# mod rbr
# One must have at least one data point under windows and some X stations
# in order for the graph to draw at all. If the graph doesn't draw anything
# until the program has run long enough to generate some data points, then
# under windows, clicking in the graph will crash the program!
# dummy legend looks bad
	.graph_window.graph element create dummy
# mod rbr - not needed	.graph_window.graph legend configure -mapped no
	.graph_window.graph element append dummy {0.0 0.0}
	update
	graph_display
#	.graph_window.graph element delete dummy
#	.graph_window.graph legend configure -mapped yes
#	update

# end mod rbr
    } else {
	destroy .graph_window
	 }

#mod mjb 8/27/97
	 global drude_config_palette
	 if { $drude_config_palette == 0 } {
		tk_setPalette #d9d9d9
		set drude_config_palette 1
	 }



}

#######show the graph of real space position vs time
proc graph2_toggle {} {
    global show_graph2 font
    if {$show_graph2} {
	toplevel .graph2_window
	#wm minsize .graph2_window 1 1
	wm title .graph2_window "position space"
	global num_graphs
	
	frame .graph2_window.menu
	
	#mod rbr
	bind .graph2_window <Destroy> {
	    if { [string compare %W ".graph2_window"] == 0 } {
		global show_graph2
		if { $show_graph2 == 1 } {
		    set show_graph2 0
		    update
		}
	    }
	}

	button .graph2_window.menu.configure -font $font -text configure \
		-command "graph_config .graph2_window.graph"
	#mod rbr - make sure destroy toggles graph
	#bind .graph2_window <Destroy> "if { [winfo exists .graph2_window] } {.realf.top.graph invoke}"
	#end mod 
	button .graph2_window.menu.close -font $font -text "close"\
		-command ".realf.top.graph invoke"
	blt_graph .graph2_window.graph -width 400 -height 300 \
		-plotbackground white
	.graph2_window.graph legend configure -mapped yes
	.graph2_window.graph xaxis configure -title "time (ps)"  
	.graph2_window.graph configure -leftmargin 0
	LASSPgrzoom .graph2_window.graph
      LASSPgrcursor .graph2_window.graph "format {%.3lf %.3lf}"
	.graph2_window.graph element create e_field
	.graph2_window.graph element configure e_field -fg red
	.graph2_window.graph element configure e_field -label "E_x"
	.graph2_window.graph element create x_pos
	.graph2_window.graph element configure x_pos -fg blue
	.graph2_window.graph element configure x_pos -label "x"
	.graph2_window.graph element create x_pos2
	.graph2_window.graph element configure x_pos2 -fg blue
	.graph2_window.graph element configure x_pos2 -label "x"
	.graph2_window.graph element create y_pos
	.graph2_window.graph element configure y_pos -label "y"
	.graph2_window.graph element configure y_pos -fg green
	.graph2_window.graph element create y_pos2
	.graph2_window.graph element configure y_pos2 -label "y"
	.graph2_window.graph element configure y_pos2 -fg green
	graph2_display

	button .graph2_window.menu.copygraph -text "copy graph" -font $font -command {
	    global num_graphs
	    incr num_graphs 1
	    graph_create .graph$num_graphs .graph2_window.graph 
	}

	pack .graph2_window.menu.copygraph -side right
	pack .graph2_window.menu.configure -side right
        pack .graph2_window.menu.close -side right
	pack .graph2_window.menu 
	pack .graph2_window.graph -expand yes -fill both

# mod rbr
# One must have at least one data point under windows and some X stations
# in order for the graph to draw at all. If the graph doesn't draw anything
# until the program has run long enough to generate some data points, then
# under windows, clicking in the graph will crash the program!
# dummy legend looks bad
	.graph2_window.graph element create dummy
# mod rbr - not needed	.graph2_window.graph legend configure -mapped no
	.graph2_window.graph element append dummy {0.0 0.0}
	update
	graph2_display
#	.graph2_window.graph element delete dummy
#	.graph2_window.graph legend configure -mapped yes
#	update
# end mod rbr
    } else {
	destroy .graph2_window
	 }
}


proc graph_display {} {
    global recip_graphtype

    if { 0 != [llength [lindex [.graph_window.graph element config e_field -data] 4 ] ] } {
# There is real data
# turn on legends
	.graph_window.graph legend configure -mapped yes
#show appropriate data
	if {$recip_graphtype == "average"} {
	    .graph_window.graph element show {x_velocity y_velocity e_field}
	    .graph_window.graph yaxis configure -title "mean velocity (10^4 m/s)"
	} else {
	    .graph_window.graph element show {x_velocity2 y_velocity2 e_field}
	    .graph_window.graph yaxis configure -title "mean square deviation (10^8 \[m/s\]^2)"
	}
    } else {
# No real data
# turn off legends
	.graph_window.graph legend configure -mapped no
# turn on dummy point
	.graph_window.graph element show dummy
# change y axis title appropriately
	if {$recip_graphtype == "average"} {
	    .graph_window.graph yaxis configure -title "mean velocity (10^4 m/s)"
    	} else {
	    .graph_window.graph yaxis configure -title "mean square deviation (10^8 \[m/s\]^2)"
    	}
    }
    update

}

proc graph2_display {} {
    global real_graphtype omega

    if { 0 != [llength [lindex [.graph2_window.graph element config e_field -data] 4 ] ] } {
# There is real data
# turn on legends
	.graph2_window.graph legend configure -mapped yes
#show appropriate data
	if {$real_graphtype == "average"} {
	    .graph2_window.graph element show {x_pos y_pos e_field}
	    .graph2_window.graph yaxis configure -title "mean position (10^-6 m)"
	} else {
	    .graph2_window.graph element show {x_pos2 y_pos2 e_field}
	    .graph2_window.graph yaxis configure -title "mean square deviation (10^-12 m^2)"
	}
    } else {
# No real data
# turn off legends
	.graph2_window.graph legend configure -mapped no
# turn on dummy point
	.graph2_window.graph element show dummy
# change y axis title appropriately
	if {$real_graphtype == "average"} {
	    .graph2_window.graph yaxis configure -title "mean position (10^-6 m)"
	} else {
	    .graph2_window.graph yaxis configure -title "mean square deviation (10^-12 m^2)"
	}
    }
    update
}


################# the presetsave procedure ############################
proc presetsave {file} {
    
    #selections
    foreach s {.realf.top.graphtype .recipf.top.graphtype} {
	set val [LASSPselection_set $s]
	puts $file "LASSPselection_set $s \"$val\""
    }

    #global variables & checkbuttons
    foreach s {n_e graph_update_delay} {
	global $s
	puts $file "set $s [set $s]"
    }
    
    #sliders
    foreach s {.control.variables.ex .control.variables.ey \
	    .control.variables.bz .control.variables.tau \
	    .control.variables.temperature  .control.variables.omega \
	    .control.variables.phi .control.speed } {
	set val [LASSPscale2_configure $s -scrollinc]
	puts $file "LASSPscale2_configure $s -scrollinc $val"
	set val [LASSPscale2_configure $s -scrollmin]
	puts $file "LASSPscale2_configure $s -scrollmin $val"
	set val [LASSPscale2_configure $s -scrollmax]
	puts $file "LASSPscale2_configure $s -scrollmax $val"
	set val [LASSPscale2_configure $s -scrolltype]
	puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"

	set var [LASSPscale2_configure $s -var]
	global $var
	puts $file "LASSPscale2_set -nocommand $s [set $var]"
    } 
    puts $file "recreate_electrons $n_e"
    puts $file "tcl_initialize; get_time_step; draw_e_field"
}

############################### create a configure window ############
####configure number of electons and delay between updates of graph

proc configure {} {
    if {[winfo exists .drudeconfig]} {
	foreach win [winfo children .drudeconfig] {
	    destroy $win
	}
    } else {
	toplevel .drudeconfig
	wm title .drudeconfig "drude configure"
    }
    set w .drudeconfig
    frame $w.controls
    label $w.controls.l -text "drude configure"
    button $w.controls.b -text close -command "destroy .drudeconfig"
    button $w.controls.b2 -text revert -command "configure"
    pack $w.controls.l -side left -fill x -expand yes
    pack $w.controls.b2 -side left -fill x -expand yes
    pack $w.controls.b -side left -fill x -expand yes
    pack $w.controls -fill x -expand yes -pady 1
    
    global n_e
    global graph_update_delay
    frame $w.nelec 
    label $w.nelec.l -text "number of electrons"
    #mod rbr - must use ~[%W get] not -[%W get]
    LASSPentry $w.nelec.e  {expr {[catch {expr ~[%W get]}] \
	    || !([%W get]>0) \
	    || !([%W get]<256) \
	    || ([expr [catch {recreate_electrons [eval %W get]}]])} }
    
    frame $w.speed
    label $w.speed.l -text "graph update increments"
    #mod rbr as above
    LASSPentry $w.speed.e  {expr {[catch {expr ~[%W get]}] \
	    || !([%W get]>0) \
	    || !([%W get]<256) \
	    || ([expr [catch {set graph_update_delay [%W get]}]]) } }   
    
    pack $w.nelec.l -side left
    pack $w.nelec.e -side left -fill x -expand yes
    pack $w.nelec -fill x -expand yes
    LASSPentry_set $w.nelec.e $n_e

    pack $w.speed.l -side left
    pack $w.speed.e -side left -fill x -expand yes
    pack $w.speed -fill x -expand yes
    LASSPentry_set $w.speed.e $graph_update_delay
    #mod rbr
    raise $w


}

##################create frames, buttons, etc
#real space
frame .realf
canvas .realf.can -height [expr 2*$canvas_hw] -width [expr 2*$canvas_hw] -relief raised -bd 2
label .realf.pos -font $font -text "position: (0,0) 10^-6 m"
bind .realf.can <Motion> {
    set a [expr ( %x - $canvas_hw)*0.02] 
    set b [expr (-%y + $canvas_hw)*0.02] 
    .realf.pos configure -text "position: ($a, $b) 10^-6 m"
}  

frame .realf.top
checkbutton .realf.top.graph -font $font -text "show graph" -width 10 -variable show_graph2 -command graph2_toggle
LASSPselection .realf.top.graphtype "show" real_graphtype {if {$show_graph2} {graph2_display}} \
	"average" "deviation"
LASSPselection_configure  .realf.top.graphtype -font $font
set real_graphtype average

#reciprocal space
frame .recipf
canvas .recipf.can -height [expr 2*$canvas_hw] -width [expr 2*$canvas_hw] -relief raised -background black -bd 2
label .recipf.pos -font $font -text "velocity: (0,0) 10^4 m/s"
bind .recipf.can <Motion> {
    set a [expr (%x -$canvas_hw)/5.0] 
    set b [expr (-%y + $canvas_hw)/5.0] 
    .recipf.pos configure -text "velocity: ($a, $b) 10^4 m/s"
}  

#frame for all controls
frame .control -relief flat -bd 3
frame .control.variables 

#variable controls
LASSPscale2 .control.variables.ex -text "E_x (10^4 V/m): " -var E_x \
	-scrollmin 0 -scrollmax 10 -scrollinc .1 -initial 10 \
	-command {get_time_step; draw_e_field}
LASSPscale2_configure .control.variables.ex -font $font

LASSPscale2 .control.variables.ey -text "E_y (10^4 V/m): " -var E_y \
	-scrollmin 0 -scrollmax 10 -scrollinc .1 -initial 10 \
	-command {get_time_step; draw_e_field}
LASSPscale2_configure .control.variables.ey -font $font
  
LASSPscale2 .control.variables.bz -text "B_z (T): " -var B_z \
	-scrollmin 0 -scrollmax 10  -scrollinc 0.1 -initial 2 -command {get_time_step}
LASSPscale2_configure .control.variables.bz -font $font

LASSPscale2 .control.variables.tau -text "tau (ps):" -var tau \
	-scrollmin 1e-1 -scrollmax 1e5 -initial 1e-0 -scrollinc 1e-1 \
	-type real -scrolltype log -command {get_time_step} -test {%v > 0.0}
LASSPscale2_configure .control.variables.tau -font $font

LASSPscale2 .control.variables.temperature -text "temperature (K): " \
	-var temperature -scrollmin 0 -scrollmax 500 -scrollinc 5 -initial 300 \
	-test {%v>0} -command {get_time_step}
LASSPscale2_configure .control.variables.temperature -font $font

LASSPscale2 .control.variables.omega -text "omega (10^12/sec): " \
	-var omega -scrollmin 0 -scrollmax 1 -scrollinc 0.01  \
	-initial 0 -command {get_time_step_tcl}
LASSPscale2_configure .control.variables.omega -font $font

LASSPscale2 .control.variables.phi -text "phase (radians): " \
	-var phi -scrollmin -2.5 -scrollmax 2.5 -scrollinc 0.05 \
	-initial 0 -command {draw_e_field}
LASSPscale2_configure .control.variables.phi -font $font


#other controls-speed, run, configure, quit, help

LASSPscale2 .control.speed -text "speed" -var speed -scrollmin 0 \
	-scrollmax 50 -initial 2 -scrollinc 1 -test {%v>0} -command get_time_step
LASSPscale2_configure .control.speed -font $font

#added by spt
#frame .topcontrol

set running 0
button .control.run -font $font -text "run" -height [expr $canvas_hw/100] -command {
    global running show_graph show_graph2
    if {$running} {
	set running 0
	.control.run configure -text "run"
	if {$show_graph} {
	    graph_update
	}
	if {$show_graph2} {
	    graph2_update
	}
    } else {
	set running 1
	.control.run configure -text "stop"
	tcl_evolve
    } 
}

button .control.initialize -font $font -text "initialize" -height \
	[expr $canvas_hw/100] -command {tcl_initialize}

frame .recipf.top
checkbutton .recipf.top.graph -font $font -text "show graph" -width 10 -variable show_graph -command graph_toggle

LASSPselection .recipf.top.graphtype "show" recip_graphtype {if {$show_graph} {graph_display}} \
	"average" "deviation"
LASSPselection_configure .recipf.top.graphtype -font $font
set recip_graphtype "average"


#show number of timesteps
#label .control.time -text "timestep 0"


frame .bottom
pack .bottom -side bottom  -fill x -expand yes

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font

frame .bottom.controls
LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

button .quit -font $font -text "quit" -command "exit 0" -width 10
button .config -font $font -text "configure..." \
	-command configure -width 10
button .help -font $font -text "help..."  -width 10 \
	-command {LASSPhelp2 .t2 [file join $SSS_DIR lib/drude/drude.htm]}

#############packing

#spt
pack .quit .disp_type .config .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top

#pack .topcontrol.run -side left
#pack .topcontrol.initialize -side left
#pack .topcontrol -side top

pack .recipf.top.graph  -side left -pady 10 -expand 1
pack .recipf.top.graphtype -side right -pady 10 -expand 1
pack .recipf.top -fill x

pack .recipf.can
pack .recipf.pos


pack .recipf -side right -expand 1

pack .control.run -fill x
pack .control.initialize  -fill x

pack .control.variables.ex -fill x
pack .control.variables.ey -fill x
pack .control.variables.bz -fill x
pack .control.variables.tau -fill x
pack .control.variables.temperature -fill x
pack .control.variables.omega -fill x
pack .control.variables.phi -fill x
pack .control.variables -side top -fill x

pack .control.speed -fill x

pack .control -side right


pack .realf.top.graph -side left -pady 10 -expand 1
pack .realf.top.graphtype -side right -pady 10 -expand 1
pack .realf.top -side top -fill x 

pack .realf.can
pack .realf.pos 
pack .realf -side left -expand 1

############################## special bindings #######################3
bind . <Key-space> {.control.run invoke}
bind . <Key-i> {.control.initialize invoke}
bind . <Key-Escape> {.bottom.controls.quit invoke}

#mod mjb 8/27/97
	 global drude_config_palette
	 if { $drude_config_palette == 0 } {
		tk_setPalette #d9d9d9
		set drude_config_palette 1
	 }

#------------------------------------------------------
proc config_all {} {

	global font canvas_hw

	# button
	.realf.pos configure -font $font
	.realf.top.graph configure -font $font
	
	.recipf.top.graph configure -font $font

	#selection
	LASSPselection_configure  .realf.top.graphtype -font $font

	#label
	.recipf.pos configure -font $font

	#scales
	LASSPscale2_configure .control.variables.ex -font $font
	LASSPscale2_configure .control.variables.ey -font $font
	LASSPscale2_configure .control.variables.bz -font $font
	LASSPscale2_configure .control.variables.tau -font $font
	LASSPscale2_configure .control.variables.temperature -font $font
	LASSPscale2_configure .control.variables.omega -font $font
	LASSPscale2_configure .control.variables.phi -font $font

	LASSPscale2_configure .control.speed -font $font

	#button
	.control.run configure -font $font -height [expr $canvas_hw/100]

	.control.initialize configure -font $font -height [expr $canvas_hw/100]

	#selection
	LASSPselection_configure .recipf.top.graphtype -font $font

	LASSPselection_configure .disp_type -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.config configure -font $font
	.help configure -font $font
	.quit configure -font $font

	#displays
	.realf.can configure -height [expr 2*$canvas_hw] -width [expr 2*$canvas_hw]
	.recipf.can configure -height [expr 2*$canvas_hw] -width [expr 2*$canvas_hw]

	#procedures to redraw
      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}
	tcl_initialize
	
}

# Setting the size option as per the correct value.
#LASSPselection_set .disp_type $disp_option




