set SSS_PROG fermi
set fermi_config_palette 0

############################# global variable are: ######################
# num_graphs - used for the LASSPgraph routines
set num_graphs 0
set T_low 40.0
set T_high 1000.0
set npoints 50

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0
proc startup {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 300
	set hght 220
	set disp_option "small"
	wm minsize . 400 430
	wm maxsize . 600 650
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}

	} elseif {$wd <= 800} {
		set wdth 340
		set hght 340
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 520 550
		wm maxsize . 600 710
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 470 630
			wm maxsize . 4000 3000
			}
}

proc set_para {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 300
	set hght 220
	wm minsize . 400 430
	wm maxsize . 600 650
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}

	} elseif {$disp_option == "medium"} {
		set wdth 350
		set hght 340
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 520 550
		wm maxsize . 600 710
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 470 630
			wm maxsize . 4000 3000
			}
	# Configuring the font for all the widgets.
	config_all

#	if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}

}


#mod spt
startup

################################## graphs   ############
blt_graph .density -width $wdth -height [expr $hght/1.1] -relief raised -bd 2 \
	-plotbackground white
.density element create n -fg red
.density element create p -fg blue
.density yaxis configure -title "particle densities (1/cm^3)" -logscale yes
.density element show {p n}
proc densityfmt {x y} {
    global xaxis
    if {$xaxis=="T"} {
	set T $x
    } else {
	set T [expr 1.0/$x]
    }
    return [format "T=%.1lf (K),   %.2le" $T $y]
}
LASSPgrcursor .density "densityfmt "
LASSPgrzoom .density

blt_graph .mu -width $wdth -height [expr $hght/1.7] -relief raised -bd 2 \
	-plotbackground white
.mu element create Ec -fg red 
.mu element create Ed -fg black -bg white -dashes 5
.mu element create Ea -fg black -bg white -dashes 5  
.mu element create Ev -fg blue 
.mu element create mu  -fg green -linewidth 2
#.mu element create mu2  -fg red
.mu yaxis configure -title "mu (eV)"
#mod rbr mapped yes 
.mu legend configure -mapped yes
proc mufmt {x y} {
    global xaxis
    if {$xaxis=="T"} {
	set T $x
    } else {
	set T [expr 1.0/$x]
    }
    return [format "T=%.1lf (K),    %.3lf" $T $y]
}
LASSPgrcursor .mu "mufmt "
LASSPgrzoom .mu


################################## center panel  ############
proc xaxisflip {} {
    global xaxislast xaxis font
    if {$xaxis==$xaxislast} return
    set xaxislast $xaxis
    foreach g {.density .mu} {
	foreach e [$g element names] {
	    set xvalues {}
	    foreach x [lindex [$g element configure $e -xdata] 4]  {
		lappend xvalues [expr 1./$x]
	    }
	    $g element configure $e -xdata $xvalues
	}
	$g xaxis configure -title $xaxis
    }
}
frame .center
LASSPselection .xaxis {} xaxis {xaxisflip} "T" "1/T" 
set xaxislast "1/T"
LASSPselection_set .xaxis "1/T"
LASSPselection .yaxis {} yaxis {
    if {[lindex [.density yaxis configure -min] 4] <= 0} {
	.density yaxis configure -min {} 
    }
    .density yaxis configure -logscale [expr {$yaxis=="log"}]
} "lin" "log" 
LASSPselection_set .yaxis "log"
.xaxis configure -bd 2
.yaxis configure -bd 2

button .copygraph1 -font $font -text "copy densities" -command {
    incr num_graphs 1
    graph_create .graph$num_graphs .density 
}
button .copygraph2 -font $font -text "copy mu" -command {
    incr num_graphs 1
    graph_create .graph$num_graphs .mu 
}


pack .xaxis -in .center -side left -fill both
pack .yaxis -in .center -side left -fill both
pack .copygraph1 -in .center -side left -fill both
pack .copygraph2 -in .center -side left -fill both


################################## right panel  ############
frame .right
#label .title -font $font -text "fermi" -bd 2 -relief flat
LASSPscale2 .mc -text "m_e (m)" -scrollmin 0.00 -scrollmax 2  \
	-initial 1 -scrollinc .05 -type real -var Mc \
	-command "calculate_density" -test {%v>0.001}
LASSPscale2_configure .mc -font $font

LASSPscale2 .mv -text "m_h (m)" -scrollmin 0.00 -scrollmax 2  \
	-initial 1  -scrollinc .05 -type real -var Mv \
	-command "calculate_density" -test {%v>0.001}
LASSPscale2_configure .mv -font $font

LASSPscale2 .nd -text "Nd (1/cm^3)" -scrollmin 1e11 -scrollmax 1e19  \
	-initial 1e14 -scrollinc 1e11 -type real -var Nd  \
	-scrolltype log -command "calculate_density" \
	-test {%v>0.0}
LASSPscale2_configure .nd -font $font

LASSPscale2 .na -text "Na (1/cm^3)" -scrollmin 1e11 -scrollmax 1e19  \
	-initial 1e11 -scrollinc 1e11 -type real -var Na \
	-scrolltype log -command "calculate_density"  \
	-test {%v>0.0}
LASSPscale2_configure .na -font $font

LASSPscale2 .eg0 -text "Eg0 (eV)" -scrollmin 0 -scrollmax 2  \
	-initial 1 -scrollinc .02 -type real -var Eg0 \
	-command "calculate_density" \
	-test {%v>=0}
LASSPscale2_configure .eg0 -font $font

LASSPscale2 .deg0dt -text "dEg/dT (eV/K)" -scrollmin 0 -scrollmax 0.001  \
	-initial 0.0 -scrollinc .0001 -type real -var dEg_dT \
	-command "calculate_density"
LASSPscale2_configure .deg0dt -font $font

LASSPscale2 .ed -text "(Ec-Ed) (eV)" -scrollmin 0 -scrollmax .1  \
	-initial .05 -scrollinc .005 -type real -var Ed \
	-command "calculate_density" \
	-test {%v>=0}
LASSPscale2_configure .ed -font $font

LASSPscale2 .ea -text "(Ea-Ev) (eV)" -scrollmin 0 -scrollmax .1  \
	-initial .05 -scrollinc .005 -type real -var Ea \
	-command "calculate_density" \
	-test {%v>=0}
LASSPscale2_configure .ea -font $font

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font



LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

button .configure -font $font -text "configure..." -command {configure}
button .help -font $font -text "help..." -command {LASSPhelp2 .t2 [file join $SSS_DIR lib/fermi/fermi.htm]}
button .quit -font $font -text quit -command {exit}

#spt
pack .quit .disp_type .configure .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top

#pack .title -in .right -fill both
#pack .calc -in .right -pady 2 -expand yes
pack .mc -in .right -pady [expr ($wdth - 250)/25] -fill x
pack .mv -in .right -pady [expr ($wdth - 250)/25] -fill x
pack .nd -in .right -pady [expr ($wdth - 250)/25] -fill x
pack .na -in .right -pady [expr ($wdth - 250)/25] -fill x
pack .eg0 -in .right -pady [expr ($wdth - 250)/25] -fill x
pack .deg0dt -in .right -pady [expr ($wdth - 250)/25] -fill x
pack .ed -in .right -pady [expr ($wdth - 250)/25] -fill x
pack .ea -in .right -pady [expr ($wdth - 250)/25] -fill x

#pack .presets -in .right -fill both -padx 2
#pack .configure -in .right -fill both
#pack .help -in .right -fill both
#pack .quit -in .right -fill both


################################ set up the toplevel window #############

wm minsize . 200 200
pack .right -side right -expand no
pack .density -fill both -expand yes
pack .center 
pack .mu -fill both -expand yes

calculate_density


################################## the presetsave procedure ############
proc presetsave {file} {
    #global variables
    foreach s {T_low T_high npoints} {
        global $s
        puts $file "set $s [set $s]"
    }

    #selections
    foreach s {.xaxis .yaxis} {
        set val [LASSPselection_set $s]
        puts $file "LASSPselection_set $s \"$val\""
    }

    #sliders
    foreach s {.mc .mv .nd .na .eg0 .deg0dt .ed .ea} {
        set val [LASSPscale2_configure $s -scrollinc]
        puts $file "LASSPscale2_configure $s -scrollinc $val"
        set val [LASSPscale2_configure $s -scrollmin]
        puts $file "LASSPscale2_configure $s -scrollmin $val"
        set val [LASSPscale2_configure $s -scrollmax]
        puts $file "LASSPscale2_configure $s -scrollmax $val"
        set val [LASSPscale2_configure $s -scrolltype]
        puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"

	set val [LASSPscale2_get $s]
        puts $file "LASSPscale2_set -nocommand $s $val"
    } 
    
    puts $file "calculate_density"
}


############################ create a configure window ############
proc configure {} {
    set w .fermiconfig

    if {[winfo exists $w]} {
	set list [winfo children $w]
	set index [lsearch $list $w.controls]
	set list [lreplace $list $index $index]
	foreach win $list  {
	    destroy $win
	}
	raise $w
    } else {
	toplevel $w
	wm title $w "fermi configure"
	frame $w.controls
	label $w.controls.l -text "fermi configure"
	button $w.controls.b -text close -command "destroy $w"
	button $w.controls.b2 -text revert -command "configure"
	pack $w.controls.l -side left -fill x -expand yes
	pack $w.controls.b2 -side left -fill x -expand yes
	pack $w.controls.b -side left -fill x -expand yes
	pack $w.controls -fill x -expand yes -pady 1
    }    

    global T_low T_high npoints


    frame $w.t_low
    label $w.t_low.l -text "min temperature (K):"
    LASSPentry $w.t_low.e \
	    {expr { [catch {expr -[%W get]}] || ([%W get]<=0.0) || ([%W get]>=$T_high)\
	    || [catch {set T_low [%W get]}] || [catch {calculate_density}]  }}
    pack $w.t_low.l  -side left
    pack $w.t_low.e  -side left -fill x -expand yes
    pack $w.t_low -fill x -expand yes -pady 1
    LASSPentry_set $w.t_low.e $T_low
    
    frame $w.t_high
    label $w.t_high.l -text "max temperature (K):"
    LASSPentry $w.t_high.e \
	    {expr {[catch {expr -[%W get]}] || ([%W get]<=$T_low) \
	    || [catch {set T_high [%W get]}] || [catch {calculate_density}] }}
    pack $w.t_high.l  -side left
    pack $w.t_high.e  -side left -fill x -expand yes
    pack $w.t_high -fill x -expand yes -pady 1
    LASSPentry_set $w.t_high.e $T_high
    
    frame $w.npoints
    label $w.npoints.l -text  "points in graph:"
    LASSPentry $w.npoints.e \
	    {expr {[catch {expr -[%W get]}] \
	    || !([%W get]>0) || ([%W get]>512)\
	    || [catch {set npoints [%W get]}]  \
	    || [catch {calculate_density}]  }   }
    pack $w.npoints.l  -side left
    pack $w.npoints.e  -side left -fill x -expand yes
    pack $w.npoints -fill x -expand yes -pady 1
    LASSPentry_set $w.npoints.e $npoints

}



bind . <Key-Escape> {.quit invoke}

#mod mjb 8/27/97
	 global fermi_config_palette
	 if { $fermi_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set fermi_config_palette 1
    }


#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#graph
	.density configure -width $wdth -height $hght
	.mu configure -width $wdth -height [expr $hght/2.0]

	#label
	#.title configure -font $font

	#scale
	LASSPscale2_configure .mc -font $font
	LASSPscale2_configure .mv -font $font
	LASSPscale2_configure .nd -font $font
	LASSPscale2_configure .na -font $font
	LASSPscale2_configure .eg0 -font $font
	LASSPscale2_configure .deg0dt -font $font
	LASSPscale2_configure .ed -font $font
	LASSPscale2_configure .ea -font $font


	# the selections
	LASSPselection_configure .disp_type -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.configure configure -font $font
	.help configure -font $font
	.quit configure -font $font

	.copygraph1 configure -font $font
	.copygraph2 configure -font $font

	#RHS cosmetics
	pack .mc -in .right  -pady [expr ($wdth - 250)/25] -fill x
	pack .mv -in .right -pady [expr ($wdth - 250)/25] -fill x
	pack .nd -in .right -pady [expr ($wdth - 250)/25] -fill x
	pack .na -in .right -pady [expr ($wdth - 250)/25] -fill x
	pack .eg0 -in .right -pady [expr ($wdth - 250)/25] -fill x
	pack .deg0dt -in .right -pady [expr ($wdth - 250)/25] -fill x
	pack .ed -in .right -pady [expr ($wdth - 250)/25] -fill x
	pack .ea -in .right -pady [expr ($wdth - 250)/25] -fill x

	#mod rbr 
	.xaxis.b configure -font $font
	.xaxis.b.m configure -font $font
	.yaxis.b configure -font $font
	.yaxis.b.m configure -font $font

	#mod rbr - blt graphs
	.density configure -font $font
	.density xaxis config -font $font -ticklength 6
	.density yaxis config -font $font -ticklength 6
	.density legend config -font $font -padx 2
	.mu configure -font $font
	.mu xaxis config -font $font -ticklength 6
	.mu yaxis config -font $font -ticklength 6
	.mu legend config -font $font -padx 2

	#procedures to redraw
      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}

}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option








