
# add optional default filename
# multiple selections 

################################## create a popup fileselect window ##########
proc LASSPfileselect_cd {w dir} {
    if [catch {cd $dir}] {
	tk_dialog .error {} "Directory doesn't exist." {} 0 "Ok"
    }
    set tail [file tail [$w.filt.e get]]
    set dir [pwd]
    if {$dir=="/"} {set dir {}}
# Use file join instead of format - rbr
#    LASSPentry_set $w.filt.e [format {%s/%s} $dir $tail]
    LASSPentry_set $w.filt.e [file join $dir $tail]

    $w.dir.lb delete 0 end
    $w.file.lb delete 0 end
    set filter [file tail [$w.filt.e get]]
# rbr
    global tcl_platform    
    if { $tcl_platform(platform) == "macintosh" } {
    	$w.dir.lb insert end :
    	if {[file exist ::]} {
    		$w.dir.lb insert end ::
    	}
    }
#end mod rbr
     foreach f [lsort [glob * .*]] {
	if {[file isdirectory $f]} {
	    $w.dir.lb insert end $f
	} else {
	    # mod rbr - ignore case in filter for NT
            set ufilter [string toupper $filter]
	    set uf [string toupper $f]
	    if {[string match $ufilter $uf]} {
		$w.file.lb insert end $f
	    }
	}
    }
    return 0
}

proc LASSPfileselect_get {w} {
    set files {}
    foreach f [$w.file.lb curselection] {
	lappend files [$w.file.lb get $f]
    }
    return $files
}


proc LASSPfileselect {filter default} {
    #find an unused window name ".fileselectn"
    set n 0
    while {[catch {toplevel [set w .fileselect$n]}]} {
	incr n 1
    }

    wm minsize $w 300 200
    wm title $w "LASSP File Select"
    global $w

    frame $w.filt
    label $w.filt.l -text "Filter:"
    LASSPentry $w.filt.e "LASSPfileselect_cd $w \[file dirname \[%W get]]" \
	    -relief sunken 
    pack $w.filt.l -side left
    pack $w.filt.e -fill x -side left -expand yes
    
    frame $w.dir
    label $w.dir.l -text Directories
    listbox $w.dir.lb -relief sunken -yscrollcommand "$w.dir.s set " \
	    -width 10 -height 10
    bind $w.dir.lb <Double-Button-1> \
	    "LASSPfileselect_cd $w \[%W get \[%W nearest %y]] " 
    scrollbar $w.dir.s -command "$w.dir.lb yview "
    pack $w.dir.l -anchor w -side top
    pack $w.dir.s -side right -fill y
    pack $w.dir.lb -side right -fill both -expand yes
    
    frame $w.file
    label $w.file.l -text Files
    listbox $w.file.lb -relief sunken -yscrollcommand "$w.file.s set " \
	    -width 10 -height 10 -selectmode extended
    foreach event {<Button-1>  <B1-Motion>} {
	bind $w.file.lb $event \
		"LASSPentry_set $w.sel.e \[LASSPfileselect_get $w]"
    }
    bind $w.file.lb <Double-Button-1> \
	    "LASSPentry_set $w.sel.e \[LASSPfileselect_get $w];  \
	    set $w \[$w.sel.e get]" 
    bindtags $w.file.lb "Listbox $w.file.lb"
    scrollbar $w.file.s -command "$w.file.lb yview "
    pack $w.file.l -anchor w -side top
    pack $w.file.s -side right -fill y
    pack $w.file.lb -side right -fill both -expand yes

    frame $w.sel
    label $w.sel.l -text "Selection:"
    LASSPentry $w.sel.e "$w.but.ok invoke; expr 0" -relief sunken 
    pack $w.sel.l -side left
    pack $w.sel.e -side left -fill x -expand yes
 
    frame $w.but
    button $w.but.ok -text Ok -command "set $w \[$w.sel.e get]"
    button $w.but.cancel -text Cancel -command "set $w {}"
    pack $w.but.ok $w.but.cancel -side left -fill x -expand yes
    
    if {""!=[file dirname $default]} {
	cd [file dirname $default]
    } elseif {""!=[file dirname $filter]} {
	cd [file dirname $filter]
    }
    LASSPentry_set $w.filt.e $filter
    LASSPentry_set $w.sel.e $default
    LASSPfileselect_cd $w .

    pack $w.filt -side top -fill x -padx 5 -pady 5
    pack $w.but -side bottom -fill x -padx 5 -pady 5
    pack $w.sel -side bottom -fill x -padx 5 -pady 5
    pack $w.dir -side left -fill both -expand yes -padx 5 -pady 5
    pack $w.file -side right -fill both -expand yes -padx 5 -pady 5

    set oldFocus [focus]
#    grab $w
    focus $w.sel.e
    # mod rbr - must set $w if window destroyed to kill background tkwait
    bind $w <Destroy> "set $w {}"
    tkwait variable $w
    focus $oldFocus

    #mod rbr - must unbind destroy if $w was changed by a file selection
    # otherwise, the selection gets replaced by null. But, can't change 
    # bindings on or destroy what isn't there.
    if { [winfo exists $w] } {
	bind $w <Destroy> {}
	destroy $w
    }
    if {[set $w]==""} {
	return {}
    } else {
	set files {}
	foreach file [set $w] {
	    set c [string index [string trim $file] 0]
	    if {$c!="/" && $c!="~"} {
		set dir [pwd]
		if {$dir=="/"} {set dir {}}
# Use file join - rbr
# was		set file [format {%s/%s} $dir $file]
		set file [file join $dir $file]
	    }
	    lappend files $file
	}
	return $files
    }
}
