

############################ create a popup interpreter window #######
proc LASSPinterp {w} {
    if {[winfo exists $w]} {
	raise $w
	return 
    }

    toplevel $w 
    wm title $w "interpreter"
    wm minsize $w 100 100
    text $w.text -yscrollcommand "$w.scroll set" -width 80 -wrap word
    scrollbar $w.scroll -relief flat -command "$w.text yview"
    frame $w.f
    button $w.exit -relief raised -text "close" -width 10 \
	    -command "destroy $w"
    button $w.clear -relief raised -text "clear" -width 10 \
	    -command "$w.text delete 0.0 {cmdline-1line}"
    pack $w.f  -side top -fill x
    pack $w.exit -in $w.f -side left
    pack $w.clear -in $w.f -side left
    pack $w.scroll -side right -fill y
    pack $w.text -side left -expand yes -fill both
    
    $w.text insert insert "% "
    $w.text mark set cmdline {insert-1chars}
    set tcl_interactive 1
    focus $w.text
    set $w.text [history nextid]

    bind $w.text  <Key-BackSpace> {
	if {[%W compare insert <= cmdline]} {
	    break
	}
    }
    bind $w.text  <Key-Delete> [bind $w.text <Key-BackSpace>]

    bind $w.text <Key-Return>  {
	if [info complete [%W get cmdline end]] {
	    %W mark set insert end
	    %W insert insert "\n"
	    catch {history add [%W get cmdline {end - 1 chars}] exec} %W
	    if {0 != [string length ${%W}]} {
		%W insert insert ${%W}
		%W insert insert "\n"
	    }
	    %W insert insert "%% "
	    %W mark set cmdline {insert - 1 chars}
	    set %W [history nextid]
	} else {
	    %W insert insert "\n"
	}
	%W yview -pickplace insert
	break
    }
    bind $w.text <Key-KP_Enter> [bind $w.text <Key-Return>]
    
    bind $w.text <Button-1> {
	if {[%W compare @%x,%y <= cmdline]} {
	    catch {%W tag remove sel sel.first sel.last} 
	    %W mark set anchor @%x,%y
	    break;
	}
    }
    bind $w.text <Double-Button-1> {
	if {[%W compare @%x,%y > cmdline]} {
	    %W mark set insert @%x,%y
	}
	%W mark set anchor "@%x,%y wordstart"
	%W tag add sel anchor "@%x,%y wordend"
	break
    }
    bind $w.text <Triple-Button-1> {
	if {[%W compare @%x,%y > cmdline]} {
	    %W mark set insert @%x,%y 
	}
	%W mark set anchor "@%x,%y linestart"
	%W tag add sel anchor "@%x,%y lineend"
	break
    }
    bind $w.text <Button-2> {
	if {[%W compare @%x,%y > cmdline]} {
	    %W mark set insert @%x,%y 
	}
	catch {
	    %W insert insert [selection get]
	    %W yview -pickplace insert
	}
	break
    }
#duplicate b2 bindings for Shift-b1 for mac and windows - rbr
    bind $w.text <Shift-Button-1> {
	if {[%W compare @%x,%y > cmdline]} {
	    %W mark set insert @%x,%y 
	}
	catch {
	    %W insert insert [selection get]
	    %W yview -pickplace insert
	}
	break
    }
    bind $w.text <Button-3> {
	%W scan mark %x %y
    }
    bind $w.text <B3-Motion> {
	%W scan dragto %x %y
    }
#duplicate b3 bindings for control-b1 for mac - rbr
    bind $w.text <Control-Button-1> {
	%W scan mark %x %y
    }
    bind $w.text <Control-B1-Motion> {
	%W scan dragto %x %y
    }

    bind $w.text <Key-Up> {
	if {![catch {history event [expr ${%W}-1]}]} {
	    %W delete "cmdline+1chars" end
	    set %W [expr ${%W}-1]
	    %W mark set insert "cmdline+1chars"
	    %W insert insert [history event ${%W}]
	    %W yview -pickplace insert
	}
	break
    }
    bind $w.text <Key-Down> {
	if {![catch {history event [expr ${%W}+1]}]} {
	    %W delete "cmdline+1chars" end
	    set %W [expr ${%W}+1]
	    %W mark set insert "cmdline+1chars"
	    %W insert insert [history event ${%W}]
	} else {
	    set %W [history nextid]
	    %W delete "cmdline+1chars" end
	    %W mark set insert "cmdline+1chars"
	}
	%W yview -pickplace insert
	break
    }

}
