############################# scale functions #######################
proc scale_create {s name from to init prec type} {
    upvar #0 $s t
    set t(-name) $name
    set t(-from) $from
    set t(-to) $to
    set t(-init) $init
    set t(-prec) $prec
    set t(-type) $type
    set t(-value) $init

    frame $s -borderw 2 -relief raised 
    frame $s.f
    label $s.l -text "$name"
    entry $s.e -relief sunken -width 6
    scale $s.s  -from 0 -to 1000 -orient horizontal  -showvalue no \
	    -length 100 -background #ffe4c4 -width 10 -borderw 0 \
	    -command "scale_drag $s "

    pack $s.f -fill x
    pack $s.l -in $s.f -side left
    pack $s.e -in $s.f -side right
    pack $s.s -fill x 
    
    bind $s.e <KeyPress-Return> "scale_set $s "
    bind $s.e <Double-Button-1> "$s.e delete 0 end"
    
    $s.e insert 0 $init
    scale_set $s
}

proc scale_drag {s x} {
    upvar #0 $s t

    if {0==[string compare $t(-type) "linear"]} {
	set t(-value) [expr $t(-from) + 1.0*$x/1000 * ($t(-to)-$t(-from))]
    } elseif {0==[string compare $t(-type) "log"]} {
	set t(-value) [expr $t(-from) \
		* pow(1.0*$t(-to)/$t(-from),1.0*$x/1000)]
    }
    set t(-value) [expr round(1.0*$t(-value)/$t(-prec)) * $t(-prec)]
    $s.e delete 0 end
    $s.e insert 0 $t(-value)
}

proc scale_set {s} {
    upvar #0 $s t

    set t(-value) [expr round(1.0*[$s.e get]/$t(-prec)) * $t(-prec)]

    if {0==[string compare $t(-type) "linear"]} {
	set val [expr 1.0 * 1000 * \
		($t(-value)-$t(-from)) / ($t(-to)-$t(-from))]
    } elseif {0==[string compare $t(-type) "log"]} {
	set val [expr 1000 * log(1.0*$t(-value)/$t(-from)) / log($t(-to))]
    }
    set val [expr round($val)]
    if {[expr $t(-value)>$t(-from) && $t(-value)<$t(-to)]} {
	$s.s set $val
    }
}

