
proc LASSPselection {s label var cmd args} {

    frame $s -bd 2 -relief raised
    menubutton $s.b -menu $s.b.m -text [lindex $args 0] -relief sunken 
    menu $s.b.m -tearoff 0

    set width 0
    foreach ele $args {
	set len [string length "$ele"]
	if {$width<$len} {set width $len}
	$s.b.m add command -label "$ele" -command "\
		$s.b configure -text \"$ele\"; \
		set $var \"$ele\"; $cmd"
    }
    $s.b configure -width $width

    if {$label!=""} {
	label $s.l -text $label
	pack $s.l -side left -fill y
	pack $s.b -side right -padx 2 -pady 2 -fill y
    } else {
	$s configure -relief flat -bd 0
	$s.b configure -relief raised -bd 2
	pack $s.b -fill both -expand yes
    }
}


proc LASSPselection_set {s args} {
    if {[llength $args]==0} {
	return [lindex [$s.b configure -text] 4]
    } elseif {[llength $args]==1} {
	set n [$s.b.m index last]
	set l [lindex $args 0]
	for {set i 0} {$i<=$n} {incr i 1} {
	    if {![string compare $l [lindex [$s.b.m entryconfigure $i -label] 4]]} {
		$s.b.m invoke $i
		return $i;
	    }
	}
	return
	 } else {
	return {}
	 }
}

# Added by spt
proc LASSPselection_configure {name args} {
	# upvar #0 $name s

	 set len [llength $args]
	 for {set i 0} {$i<$len} {incr i +2} {
		set var [lindex $args $i]
		if {$i+1 < $len} {
			set val [lindex $args [expr $i+1]]
			if {$var=="-font"} {
				if { -1 != [lsearch [info commands $name.*] $name.l] } {
					$name.l configure -font $val
					}
									  $name.b configure -font $val
									  set ind_end [$name.b.m index end]
									  for {set j 0} {$j <= $ind_end} {incr j +1} {
											$name.b.m entryconfigure $j -font $val
									  }
			}
		 }
	}
}

