set SSS_PROG "laue"

#LASSPinterp .interp

############################## global variables ##################3
set num_graphs 0
set natoms 64
set points_atom 64
set cutoff 0.5
set laue_config_palette 0

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0

proc startup {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth [expr 640/3.0]
	set hght [expr 360/2.5]
	set disp_option "small"
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 640 420
	wm maxsize . 800 500
	set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"

	} elseif {$wd <= 800} {
		set wdth [expr 740/2.5]
		set hght [expr 500/1.75]
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 650 420
		wm maxsize . 1000 650
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set disp_option "large"
	                set font "-*-helvetica-bold-r-normal-*-*120-*-*-*-*-*-*"
			wm minsize . 975 450
			wm maxsize . 4000 3000
		}
}

proc set_para {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth [expr 640/3.0]
	set hght [expr 360/2.5]
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 640 420
	wm maxsize . 800 500

	} elseif {$disp_option == "medium"} {
		set wdth [expr 740/2.5]
		set hght [expr 500/1.75]
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 650 420
		wm maxsize . 1000 650
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 975 450
			wm maxsize . 4000 3000
		}
	# Configuring the font for all the widgets.
	config_all

	#if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
	#	wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
	#}

}


#mod spt
startup
################# the presetsave procedure ############################
proc presetsave {file} {
    #global variables
    foreach s {natoms points_atom cutoff} {
	global $s
	puts $file "set $s [set $s]"
    }
    #selections
    foreach s {.menu.mat .menu.m_mod .menu.d_mod .menu.q_mod .shape} {
	set val [LASSPselection_set $s]
	puts $file "LASSPselection_set $s \"$val\""
    }
    #sliders
    foreach s {.a .size1 .size2 .charge2 .wave_vector .amplitude \
	    .sigma_thermal .sigma_liquid .order_parameter \
	    .ic_ratio .a1_a2_displace } {
	set val [LASSPscale2_configure $s -scrollinc]
	puts $file "LASSPscale2_configure $s -scrollinc $val"
	set val [LASSPscale2_configure $s -scrollmin]
	puts $file "LASSPscale2_configure $s -scrollmin $val"
	set val [LASSPscale2_configure $s -scrollmax]
	puts $file "LASSPscale2_configure $s -scrollmax $val"
	set val [LASSPscale2_configure $s -scrolltype]
	puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#	set val [LASSPscale2_configure $s -font]
#	puts $file "LASSPscale2_configure $s -font $val"
	set var [LASSPscale2_configure $s -var]
	global $var
	puts $file "LASSPscale2_set $s [set $var]"
    } 
    #graphs
    puts $file ".calc invoke"
}


################################## create a configure window ############
# configure natoms
proc configure {} {
    set w .laueconfig

    if {[winfo exists $w]} {
	foreach win [winfo children $w] {
	    destroy $win
	}
    } else {
	toplevel $w
	wm title $w "laue configure"
    }
    
    raise $w
    frame $w.controls
    label $w.controls.l -text "laue configure"
    button $w.controls.b -text close -command "destroy .laueconfig"
    button $w.controls.b2 -text revert -command "configure"
    pack $w.controls.l -side left -fill x -expand yes
    pack $w.controls.b2 -side left -fill x -expand yes
    pack $w.controls.b -side left -fill x -expand yes
    pack $w.controls -fill x -expand yes -pady 1
    
    frame $w.natoms
    label $w.natoms.l -text "number of cells:"
    LASSPentry $w.natoms.e \
	    {expr {[catch {expr -[%W get]}] \
	    || !([%W get]>0) \
	    || ![expr $points_atom * [%W get] <= 32768] \
	    || ![expr log([%W get])/log(2) == round( log([%W get])/log(2) )]  \
	    || [catch {set natoms [%W get]}] }}
    pack $w.natoms.l  -side left
    pack $w.natoms.e  -side left -fill x -expand yes
    pack $w.natoms -fill x -expand yes -pady 1
    global natoms
    LASSPentry_set $w.natoms.e $natoms

    frame $w.points_atom
    label $w.points_atom.l -text "points sampled per atom:"
    LASSPentry $w.points_atom.e \
	    {expr {[catch {expr -[%W get]}] \
	    || !([%W get]>0) \
	    || ![expr $natoms * [%W get] <= 32768] \
	    || ![expr log([%W get])/log(2) == round( log([%W get])/log(2) )]  \
	    || [catch {set points_atom [%W get]}] }}
    pack $w.points_atom.l  -side left
    pack $w.points_atom.e  -side left -fill x -expand yes
    pack $w.points_atom -fill x -expand yes -pady 1
    global points_atom
    LASSPentry_set $w.points_atom.e $points_atom

    frame $w.cutoff
    label $w.cutoff.l -text "cutoff:"
    LASSPentry $w.cutoff.e \
	    {expr {[catch {expr -[%W get]}] \
	    || !([%W get]>0) \
	    || [catch {set cutoff [%W get]}] }}
    pack $w.cutoff.l  -side left
    pack $w.cutoff.e  -side left -fill x -expand yes
    pack $w.cutoff -fill x -expand yes -pady 1
    global cutoff
    LASSPentry_set $w.cutoff.e $cutoff

}

################ pack menus - does the context-dependent packing of the menus #
## depending on the variables  material and m_mod, d_mod, and q_mod
proc packmenus {} {
    global material m_mod d_mod q_mod
    pack forget .menu.m_mod .menu.d_mod .menu.q_mod 
    pack forget .size2 .charge2 .wave_vector .amplitude .sigma_thermal .a1_a2_displace 
    pack forget .sigma_liquid .order_parameter .ic_ratio 

    if {$material=="monatomic crystal"} {
	pack .menu.m_mod -in .menu  -side left -padx 10
	if {$m_mod=="none"} {
	} elseif {$m_mod=="phonon"} {
	    pack .wave_vector -in .scales -before .shape -side top -pady 1 -fill x
	    pack .amplitude -in .scales -before .shape -side top -pady 1 -fill x    
	} elseif {$m_mod=="random"} {
	    pack .sigma_thermal -in .scales -before .shape -side top -pady 1 -fill x
	}

    } elseif {$material=="diatomic crystal"} {
	pack .menu.d_mod -in .menu  -side left -padx 10
	if {$d_mod=="none"} {
	    pack .size2 -in .scales -before .shape -side top -pady 1 -fill x
	    pack .charge2 -in .scales -before .shape -side top -pady 1 -fill x
	    pack .a1_a2_displace -in .scales -before .shape -side top -pady 1 -fill x
	} elseif {$d_mod=="order/disorder"} {
	    pack .size2 -in .scales -before .shape -side top -pady 1 -fill x
	    pack .charge2 -in .scales -before .shape -side top -pady 1 -fill x
	    pack .a1_a2_displace -in .scales -before .shape -side top -pady 1 -fill x
	    pack .order_parameter -in .scales -before .shape -side top -pady 1 -fill x
	}

    } elseif {$material=="single atom"} {


    } elseif {$material=="pair of atoms"} {
	pack .size2 -in .scales -before .shape -side top -pady 1 -fill x
	pack .charge2 -in .scales -before .shape -side top -pady 1 -fill x
	pack .a1_a2_displace -in .scales -before .shape -side top -pady 1 -fill x


    } elseif {$material=="liquid"} {
	pack .sigma_liquid -in .scales -before .shape -side top -pady 1 -fill x

    } elseif {$material=="quasicrystal"} {
	pack .menu.q_mod -in .menu  -side left -padx 10
	if {$q_mod=="displacement"} {
	    pack .ic_ratio -in .scales -before .shape -side top -pady 1 -fill x
	} elseif {$q_mod=="type"} {
	    pack .size2 -in .scales -before .shape -side top -pady 1 -fill x
	    pack .charge2 -in .scales -before .shape -side top -pady 1 -fill x
	}
    }
}


################  menus ######################################
frame .menu -bd 2 -rel flat

LASSPselection .menu.mat "material:" material packmenus \
	"monatomic crystal" "diatomic crystal" "single atom" \
	"pair of atoms" "liquid" "quasicrystal"
LASSPselection_configure .menu.mat -font $font

LASSPselection .menu.m_mod "modulation:" m_mod packmenus \
	"none" "phonon" "random"
LASSPselection_configure .menu.m_mod -font $font

LASSPselection .menu.d_mod "modulation:" d_mod packmenus \
	"none" "order/disorder"
LASSPselection_configure .menu.d_mod -font $font

LASSPselection .menu.q_mod "modulation:" q_mod packmenus \
	"displacement" "type" 
LASSPselection_configure .menu.q_mod -font $font


#######copy graph buttons
button .menu.copy_crystal -font $font -text "copy crystal" -command { 
		incr num_graphs 1
    		graph_create .graph$num_graphs .real
}  
pack .menu.copy_crystal -side left -padx [expr ($wdth - 120)/3]

button .menu.copy_diffraction -font $font -text "copy diffraction" -command { 
		incr num_graphs 1
    		graph_create .graph$num_graphs .recip
}
pack .menu.copy_diffraction -side right -padx [expr ($wdth - 120)/3]


pack .menu.mat  -side left -fill both -padx 5


################ preset menus (preset scales to fun places) ###########



############################ LASSPscales ############################
frame .scales -bd 2 
LASSPscale2 .a -text "lattice constant (A)" -scrollmin 3.0 -scrollmax 8.0 -initial 4.0 -scrollinc .1 -var a -test {%v>0}
LASSPscale2_configure .a -font $font
LASSPscale2 .size1 -text "size of atom A (A)" -scrollmin 0  -scrollmax 1.0 -initial .1 -scrollinc .01 -var size1 -test {%v>0}
LASSPscale2_configure .size1 -font $font
LASSPscale2 .size2 -text "size of atom B (A)" -scrollmin 0 -scrollmax 1.0 -initial .1 -scrollinc .01 -var size2 -test {%v>0}
LASSPscale2_configure .size2 -font $font
# LASSPscale2 .charge2 -text "atomic nr ZB/ZA" -type real -scrollmin 0 -scrollmax 10 -initial 1 -scrollinc .1 -var rel_charge -test {%v>=0}
LASSPscale2 .charge2 -text "atomic nr ZB/ZA" -type real -scrollmin 0 -scrollmax 10 -initial 1 -scrollinc .1 -var rel_charge
LASSPscale2_configure .charge2 -font $font
LASSPscale2 .wave_vector -text "wave vector (pi/a)" -scrollmin 0 -scrollmax 1.0 -initial .01 -var wave_vector 
LASSPscale2_configure .wave_vector -font $font
LASSPscale2 .amplitude -text "wave amplitude (a)" -scrollmin 0 -scrollmax 1.0 -initial .3 -scrollinc .01 -var amplitude -test {%v>0}
LASSPscale2_configure .amplitude -font $font
LASSPscale2 .sigma_thermal -text "sigma thermal (a)" -scrollmin 0 -scrollmax .5 -initial .1 -scrollinc .01 -var sigma_thermal -test {%v>0}
LASSPscale2_configure .sigma_thermal -font $font
LASSPscale2 .sigma_liquid -text "sigma liquid (a)" -scrollmin 0 -scrollmax .5 -initial .1 -scrollinc .01 -var sigma_liquid -test {%v>0}
LASSPscale2_configure .sigma_liquid -font $font
LASSPscale2 .order_parameter -text "order parameter" -scrollmin 0 -scrollmax 1.0 -initial .5 -scrollinc .01 -var order_parameter -test {{%v>=-1.0} && {%v<=1.0}}
LASSPscale2_configure .order_parameter -font $font
LASSPscale2 .ic_ratio -text "spacing ratio" -scrollmin 0 -scrollmax 2.0 -initial 1.618 -scrollinc .02 -var ic_ratio -test {%v>0}
LASSPscale2_configure .ic_ratio -font $font
LASSPscale2 .a1_a2_displace -text "atom separation (a)" -scrollmin 0 -scrollmax 1.0 -initial 0.5 -scrollinc .01 -var atom1_atom2_displacement
LASSPscale2_configure .a1_a2_displace -font $font

LASSPselection .shape "atom shape:" shape {} \
	"gaussian" "exponential" "triangular" "pseudo atom" 
LASSPselection_configure .shape -font $font

#mod rbr - {clock red white} -> watch, update idletasks -> update
button .calc -font $font -text "calculate" -height 2 -command {. config -cursor watch; update; laue_calculate; . config -cursor {}}

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font

LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

button .config -font $font -text "configure..." -command {configure}
button .help -font $font -text "help..." -command {LASSPhelp2 .t2 [file join $SSS_DIR lib/laue/laue.htm]}
button .quit -font $font -text "quit" -command {destroy .}


blt_graph .real -bd 2 -relief raised -plotbackground white -width $wdth -height $hght
blt_graph .recip -bd 2 -relief raised -plotbackground white -width $wdth -height $hght
.real element create data
.recip element create data
.real element configure data -fg blue
.real legend configure -mapped no
.recip element configure data -fg blue
.recip legend configure -mapped no
.real yaxis configure -title "electron density"
.real xaxis configure -title "x (A)"
.recip yaxis configure -title "diffraction intensity"
.recip xaxis configure -title "delta k (1/A)"
LASSPgrzoom .real
LASSPgrcursor .real "format {%.3lf,   %.3lf} "
LASSPgrzoom .recip
LASSPgrcursor .recip "format {%.4lg,   %.4lg} "

bind . <KeyPress-space> {
    .calc configure -relief sunken
    update idletasks
    .calc invoke
    .calc configure -relief raised
}
bind . <Key-Escape> {.quit invoke}


################ do packing, etc... to create screen layout ###########
#spt
pack .quit .disp_type .config .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top


pack .menu -side top -pady 3 -fill x
pack .real -side left -fill both -expand yes -padx 2 -pady 2
pack .recip -side right -fill both -expand yes -padx 2 -pady 2
pack .calc -side top -fill x 

pack .scales -side top -fill y -pady 2
pack .a -in .scales -side top -fill x -pady 1
pack .size1 -in .scales -side top -fill x -pady 1
pack .shape -in .scales -side top -fill x -pady 1

#pack .quit -side bottom -fill x 
#pack .help -side bottom -fill x 
#pack .config -side bottom -fill x 
#pack .presets -side bottom -fill x 

LASSPselection_set .menu.mat "monatomic crystal"
LASSPselection_set .menu.m_mod "none"
LASSPselection_set .menu.d_mod "none"
LASSPselection_set .menu.q_mod "displacement"
LASSPselection_set .shape "gaussian"
packmenus

#mod mjb 8/27/97
	 global laue_config_palette
	 if { $laue_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set laue_config_palette 1
	 }

#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#button
	.menu.copy_crystal configure -font $font
	.menu.copy_diffraction  configure -font $font
	.calc configure -font $font


	#selection
	LASSPselection_configure .menu.mat -font $font
	LASSPselection_configure .menu.m_mod -font $font
	LASSPselection_configure .menu.d_mod -font $font
	LASSPselection_configure .menu.q_mod -font $font

	LASSPselection_configure .shape -font $font
	LASSPselection_configure .disp_type -font $font

	#scale
	LASSPscale2_configure .a -font $font
	LASSPscale2_configure .size1 -font $font
	LASSPscale2_configure .size2 -font $font
	LASSPscale2_configure .charge2 -font $font
	LASSPscale2_configure .wave_vector -font $font
	LASSPscale2_configure .amplitude -font $font
	LASSPscale2_configure .sigma_thermal -font $font
	LASSPscale2_configure .sigma_liquid -font $font
	LASSPscale2_configure .order_parameter -font $font
	LASSPscale2_configure .ic_ratio -font $font
	LASSPscale2_configure .a1_a2_displace -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.config configure -font $font
	.help configure -font $font
	.quit configure -font $font
   
	#graphs
	.real configure -width $wdth -height $hght
	.recip configure -width $wdth -height $hght
	.real  configure -font $font
	.real  xaxis config -font $font -ticklength 6
	.real  yaxis config -font $font -ticklength 6
	.recip configure -font $font
	.recip xaxis config -font $font -ticklength 6
	.recip yaxis config -font $font -ticklength 6
	
#RHS to improve format
	pack .menu.copy_crystal -side left -padx [expr ($wdth - 120)/3]
	pack .menu.copy_diffraction -side right -padx [expr ($wdth - 120)/3]
	
	#procedures to redraw
        global tcl_platform
		if { $tcl_platform(platform) != "windows" } {
        wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
        }
	wm geometry . {}
}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option
