set SSS_PROG "neel"

wm minsize . 200 200

############################# global variable are: ######################
# xy, color  - used for drawing in the lattice
# num_graphs - used for the LASSPgraph routines
# sweepactive - whether or not a sweep is currently in progress
# sweepinc - does this # of sweeps between each display
# graphtype - Magnetization, Power Spectrum, or Autocorrelation?
# storedlattice - contains latest stored lattice 
# Mdata - store magnetization versus time
# Pdata - power spectrum
# Rdata - autocorrelation 
# i,j - counting variables

set xy {0 0}
set color 1

set num_graphs 0
set graphtype magnetization
set init_cond "T=inf"
set sweepactive 0
set T 2.4
set Hext 0
set sweepinc 1
set av_int 1

set storedlattice {}
set NX 60
set NY 30

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0

proc startup {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 360
	set hght 180
	set disp_option "small"
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}

	wm minsize . 550 440
	wm maxsize . 800 600

	} elseif {$wd <= 800} {
		set wdth 480
		set hght 240
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 590 480
		wm maxsize . 1000 740
	 } else {
			set wdth 600
			set hght 300
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 700 550
			wm maxsize . 4000 3000
			}
}

proc set_para {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 360
	set hght 180
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 550 440
	wm maxsize . 800 600

	} elseif {$disp_option == "medium"} {
		set wdth 480
		set hght 240
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 590 480
		wm maxsize . 1000 740
	 } else {
			set wdth 600
			set hght 300
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 700 550
			wm maxsize . 4000 3000
			}
	# Configuring the font for all the widgets.
	config_all

#	if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}

}


#mod spt
startup

################################## center controls  ############
frame .controls
set sweepactive 0

button .controls.sweep -font $font -text "run" -height [expr $wdth/240] -command {
    if {$sweepactive} {
        .controls.sweep configure -text "run"
        set sweepactive 0
    } else {
        .controls.sweep configure -text "stop"
        set sweepactive 1
        set temp $nsweeps
        for {set i $nsweeps} {$i>$sweepinc && $sweepactive} \
                {set i [expr $i-$sweepinc]} {
            set averages [neel_sweep $T $Hext $sweepinc]
            neel_display lattice
            LASSPscale2_set .controls.n $i
            update
        }
        if $sweepactive {
	    set tempint [expr int($i)]
            set averages [neel_sweep $T $Hext $tempint]
        }
        .controls.averages1 configure \
		-text [format "<M>=%4.2e  \n   <(M-<M>)^2>=%4.2e" \
                [lindex $averages 0] [lindex $averages 1] ]
        .controls.averages2 configure \
		-text [format "<E>=%4.2e  \n   <(E-<E>)^2>=%4.2e" \
                [lindex $averages 2] [lindex $averages 3] ]
        neel_display both
        .controls.sweep configure -text "run" -rel raised
        set sweepactive 0
        LASSPscale2_set .controls.n $temp
    }
}
#button .controls.reset -text "update local field" -command change_local

LASSPscale2 .controls.temp -text "temperature:" \
	-scrollmin 0 -scrollmax 10  \
        -initial 0.4 -scrollinc .1 -type real -var T
LASSPscale2_configure .controls.temp -font $font

LASSPscale2 .controls.hext -text "external field:" \
	-scrollmin -5 -scrollmax 5 \
        -initial 0 -scrollinc .1 -type real -var Hext
LASSPscale2_configure .controls.hext -font $font

LASSPscale2 .controls.ising -text "exchange J:" -var J \
	-scrollmin -1 -scrollmax 1 -scrollinc .1 -initial 1
LASSPscale2_configure .controls.ising -font $font

LASSPscale2 .controls.dipole -text "dipole D:" -var K \
	-scrollmin 0  -scrollmax 1 -scrollinc .01 -initial 1
LASSPscale2_configure .controls.dipole -font $font

LASSPscale2 .controls.sigma -text "sigma:" -var sigma -initial 0 \
	-scrollmin 0 -scrollmax 5 -scrollinc .1 \
	-command {Hrandominit}
LASSPscale2_configure .controls.sigma -font $font

LASSPselection .controls.axis "easy axis: " axis {change_interaction; change_local} \
	"perpendicular" "vertical" "horizontal"
LASSPselection_configure .controls.axis -font $font

set axis perpendicular

LASSPselection .controls.power "power law 1/r^n:" int_power \
	{change_interaction; change_local} \
	"2" "3"
LASSPselection_configure .controls.power -font $font
set int_power 2

LASSPscale2 .controls.n -text "number of sweeps: " \
	-scrollmin 1 -scrollmax 10000  \
        -initial 1000 -scrollinc 1 -type real -var nsweeps  \
        -scrolltype log -test {%v>0}
LASSPscale2_configure .controls.n -font $font

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font


LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font
button .configure -font $font -text "configure..." -command {configure}
button .help -font $font -text "help..." -command {LASSPhelp2 .t2 [file join $SSS_DIR lib/neel/neel.htm]}
button .quit -font $font -text quit -command {exit}

#spt
pack .quit .disp_type .configure .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top


pack .controls.sweep -fill x -pady [expr ($wdth - 340)/40]
pack .controls.temp -fill x -pady [expr ($wdth - 340)/40]
pack .controls.hext -fill x -pady [expr ($wdth - 340)/40]
pack .controls.ising -fill x -pady [expr ($wdth - 340)/40]
pack .controls.dipole -fill x -pady [expr ($wdth - 340)/40] 
pack .controls.sigma -fill x -pady [expr ($wdth - 340)/40]
pack .controls.axis -fill x -pady [expr ($wdth - 340)/40]
pack .controls.power -fill x -pady [expr ($wdth - 340)/40]
pack .controls.n -fill x -pady [expr ($wdth - 340)/40]
#pack .controls.presets -fill x -pady 1
#pack .controls.configure -fill x -pady 1
#pack .controls.help -fill x -pady 1
#pack .controls.quit -fill x -pady 1

label .controls.averages1
label .controls.averages2

pack .controls.averages1 .controls.averages2 -side top -fill x


#graph and its associated controls

frame .graphf
frame .graphf.menu
frame .graphf.menu.m1 -bd 2 -relief sunken
button .graphf.menu.m1.resetdata -font $font -text "reset" -command {
    .controls.averages1 configure -text {}
    .controls.averages2 configure -text {}
    neel_reset data
}
button .graphf.menu.m1.copygraph -font $font -text "copy graph" -command {
    incr num_graphs 1
    graph_create .graph$num_graphs .graphf.graph 
}

LASSPselection .graphf.menu.m1.graphtype {} graphtype {neel_display data} \
        "magnetization" "power spectrum" "autocorrelation"


blt_graph .graphf.graph -relief raised -bd 2 \
        -plotbackground white -height $hght -width $wdth
.graphf.graph element create data
.graphf.graph element configure data -fg blue
.graphf.graph legend configure -mapped no
.graphf.graph yaxis configure -title Magnetization
.graphf.graph xaxis configure -title "sweep #"
LASSPgrzoom .graphf.graph
LASSPgrcursor .graphf.graph "format {%.4lf,   %.4lf} "

pack .graphf.menu.m1.resetdata -side left -padx 2
pack .graphf.menu.m1.copygraph -side left -padx 2

# power spectrum and autocorrelation function commented out.  They did not
# quite seem to work properly ?? but definetely neel is  too slow to get good
# data.  Delete comment from the next line, and the choices are back.
#pack .graphf.menu.m1.graphtype -side left -padx 2

pack .graphf.menu.m1 -side right
pack .graphf.menu -side top -fill x -pady 1
pack .graphf.graph -side top -fill both -expand yes



################### lattice########################################
frame .latticef
frame .graphf.menu.m2 -bd 2 -relief sunken

LASSPselection .graphf.menu.m2.init_cond {initial conditions} \
	init_cond {set_init} "T=inf" "M=1" "aferro" "recall" "store"
LASSPselection_configure .graphf.menu.m2.init_cond  -font $font

button .graphf.menu.m2.init -font $font -text "init." -command {set_init}




proc set_init {} {
    global init_cond

    if {$init_cond == "T=inf"} {
	neel_reset lattice inf
	neel_display lattice
    } elseif {$init_cond == "M=1"} {
	neel_reset lattice ferro
	neel_display lattice
    } elseif {$init_cond == "aferro"} {
	neel_reset lattice aferro
	neel_display lattice
    } elseif {$init_cond == "recall"} {
	global storedlattice
	set NX [lindex [.latticef.lattice configure -nx] 4]
	set NY [lindex [.latticef.lattice configure -ny] 4]
	for {set j 0} {$j<$NY} {incr j} {
	    for {set i 0} {$i<$NX} {incr i} {
		neel_flipspin $i $j [string index $storedlattice [expr $i+$NX*$j]]
	    }
	}
	neel_display lattice
    } elseif {$init_cond == "store"} {
	global storedlattice
	set storedlattice [.latticef.lattice load]
    }
}

#frame .graphf.menu.m3
#label .graphf.menu.m3.space -width 3 


lattice .latticef.lattice -nx $NX -ny $NY -width $wdth -height $hght \
        -upColor red -downColor white

### these bindings allow one to draw in the lattice with the mouse button
bind .latticef.lattice <Button-1> {         
    set xy [.latticef.lattice locate %x %y]
    if {0!=[string compare $xy "points not in lattice"]} {
        set color [expr 1 - [.latticef.lattice flip [lindex $xy 0] [lindex $xy 1]]]
        .latticef.lattice flip [lindex $xy 0] [lindex $xy 1] $color
        neel_flipspin [lindex $xy 0] [lindex $xy 1] $color
    }
}
bind .latticef.lattice <B1-Motion> {
    set xy [.latticef.lattice locate %x %y]
    if {0!=[string compare $xy "points not in lattice"]} {
        .latticef.lattice flip [lindex $xy 0] [lindex $xy 1] $color
        neel_flipspin [lindex $xy 0] [lindex $xy 1] $color
    }
}

pack .latticef.lattice 
pack .graphf.menu.m2.init_cond .graphf.menu.m2.init -side left -padx 2

#pack .graphf.menu.m3.space
#pack .graphf.menu.m3 -side right

pack .graphf.menu.m2 -side left
pack .graphf.menu  -side top -fill x



############pack controls
pack .controls -side left  -padx 5 -pady 5

#spt/rhs
#pack .quit .disp_type .configure .presets .help -in .top_panel -side left -fill x -padx 10
#pack .top_panel -side top


pack .latticef -side top

pack .graphf -side bottom -fill both -expand yes -padx 5 -pady 5



################################## the presetsave procedure ############
proc presetsave {file} {
    #global variables
    foreach s {sweepinc NX NY} {
        global $s
        puts $file "set $s [set $s]"
    }
    global storedlattice
    if {[string length $storedlattice] != 0} {
        puts $file "set storedlattice $storedlattice"
    }

    #selections
    foreach s {.graphf.menu.m1.graphtype .graphf.menu.m2.init_cond .controls.axis .controls.power} {
        set val [LASSPselection_set $s]
        puts $file "LASSPselection_set $s \"$val\""
    }

    #sliders
    foreach s {.controls.temp .controls.hext .controls.n .controls.ising \
	.controls.dipole .controls.sigma} {
        set val [LASSPscale2_configure $s -scrollinc]
        puts $file "LASSPscale2_configure $s -scrollinc $val"
        set val [LASSPscale2_configure $s -scrollmin]
        puts $file "LASSPscale2_configure $s -scrollmin $val"
        set val [LASSPscale2_configure $s -scrollmax]
        puts $file "LASSPscale2_configure $s -scrollmax $val"
        set val [LASSPscale2_configure $s -scrolltype]
        puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"

        set val [LASSPscale2_get $s]
        puts $file "LASSPscale2_set -nocommand $s $val"
    } 
   #lattice
    puts $file ".latticef.lattice configure -upColor [lindex [.latticef.lattice configure -upColor] 4]"
    puts $file ".latticef.lattice configure -downColor [lindex [.latticef.lattice configure -downColor] 4]"
    set nx [lindex [.latticef.lattice configure -nx] 4]
    set ny [lindex [.latticef.lattice configure -ny] 4]
    puts $file ".latticef.lattice configure -nx $nx -ny $ny"
    puts $file "neel_configure -nx $nx -ny $ny"

    set lattice [.latticef.lattice load]
    puts $file "set lattice $lattice"

    puts $file "set nx [lindex [.latticef.lattice configure -nx] 4]"
    puts $file "set ny [lindex [.latticef.lattice configure -ny] 4]"
    puts $file {
        for {set j 0} {$j<$ny} {incr j} {
            for {set i 0} {$i<$nx} {incr i} {
                neel_flipspin $i $j [string index $lattice [expr $i+$nx*$j]]
            }
        }
    }
    puts $file "neel_display lattice"

    #graph
    puts $file ".graphf.menu.m1.resetdata invoke"
}



################################## create a configure window ############
# configure NX, NY, colors, font, displayspeed, sweepincrement
proc configure {} {
    set w .neelconfig

    if {[winfo exists $w]} {
        set list [winfo children $w]
        set index [lsearch $list $w.controls]
        set list [lreplace $list $index $index]
        foreach win $list  {
            destroy $win
        }
        raise $w
    } else {
        toplevel $w
        wm title $w "neel configure"
        frame $w.controls
        label $w.controls.l -text "neel configure"
        button $w.controls.b -text close -command "destroy .neelconfig"
        button $w.controls.b2 -text revert -command "configure"
        pack $w.controls.l -side left -fill x -expand yes
        pack $w.controls.b2 -side left -fill x -expand yes
        pack $w.controls.b -side left -fill x -expand yes
        pack $w.controls -fill x -expand yes -pady 1
    }    

   frame $w.nx
    label $w.nx.l -text "lattice width:"
    LASSPentry $w.nx.e \
            {expr {[catch {neel_configure -nx [%W get]}] \
            || [catch {.latticef.lattice configure -nx [%W get]}] \
            || [catch {neel_display both}] }}
#    pack $w.nx.l  -side left
#    pack $w.nx.e  -side left -fill x -expand yes
#    pack $w.nx -fill x -expand yes -pady 1
#    LASSPentry_set $w.nx.e [lindex [.latticef.lattice configure -nx] 4]
    
    frame $w.ny
    label $w.ny.l -text "lattice height:"
    LASSPentry $w.ny.e  \
            {expr {[catch {neel_configure -ny [%W get]}] \
            || [catch {.latticef.lattice configure -ny [%W get]}] \
            || [catch {neel_display both}]  }}
#    pack $w.ny.l  -side left
#    pack $w.ny.e  -side left -fill x -expand yes
#    pack $w.ny -fill x -expand yes -pady 1
#    LASSPentry_set $w.ny.e [lindex [.latticef.lattice configure -ny] 4]
    
    frame $w.upcolor
    label $w.upcolor.l -text "spin up color:"
    LASSPentry $w.upcolor.e \
            {catch {.latticef.lattice configure -upColor [%W get]}}
    pack $w.upcolor.l  -side left
    pack $w.upcolor.e  -side left -fill x -expand yes
    pack $w.upcolor -fill x -expand yes -pady 1
    LASSPentry_set $w.upcolor.e [lindex [.latticef.lattice configure -upColor] 4]

    frame $w.downcolor
    label $w.downcolor.l -text "spin down color:"
    LASSPentry $w.downcolor.e \
            {catch {.latticef.lattice configure -downColor [%W get]}}
    pack $w.downcolor.l  -side left
    pack $w.downcolor.e  -side left -fill x -expand yes
    pack $w.downcolor -fill x -expand yes -pady 1
    LASSPentry_set $w.downcolor.e [lindex [.latticef.lattice configure -downColor] 4]

    frame $w.sweepinc
    label $w.sweepinc.l -text "speed:"
    LASSPentry $w.sweepinc.e \
            {expr {[catch {expr ~[%W get]}] \
            || !([%W get]>0) \
            || [catch {set sweepinc [%W get]}] }}
    pack $w.sweepinc.l  -side left
    pack $w.sweepinc.e  -side left -fill x -expand yes
    pack $w.sweepinc -fill x -expand yes -pady 1
    global sweepinc
    LASSPentry_set $w.sweepinc.e $sweepinc


#    frame $w.av_int
#   label $w.av_int.l -text "average length:"
#    LASSPentry $w.av_int.e \
#	    {expr {[catch {expr -[%W get]}] \
#	    || !([%W get]>0) \
#	    || ![expr 1.0*([%W get]/2) != 0.5*([%W get])] \
#	    || [catch {set av_int [%W get]}] }}
#    pack $w.av_int.l  -side left
#    pack $w.av_int.e  -side left -fill x -expand yes
#    pack $w.av_int -fill x -expand yes -pady 1
#    global av_int
#    LASSPentry_set $w.av_int.e $av_int
#}

bind . <KeyPress-space> ".controls.sweep invoke"
bind . <Key-i> {.graphf.menu.m2.init invoke}
bind . <Key-Escape> {.controls.quit invoke}

#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#buttons
	.controls.sweep configure -font $font -height [expr $wdth/240]
	.graphf.menu.m1.copygraph configure -font $font
	.graphf.menu.m2.init configure -font $font
	.graphf.menu.m1.resetdata configure -font $font

	#scale
	LASSPscale2_configure .controls.temp -font $font
	LASSPscale2_configure .controls.temp -font $font
	LASSPscale2_configure .controls.hext -font $font 
	LASSPscale2_configure .controls.ising -font $font
	LASSPscale2_configure .controls.dipole -font $font
	LASSPscale2_configure .controls.sigma -font $font
	LASSPscale2_configure .controls.n -font $font

	#selection
	LASSPselection_configure .controls.axis -font $font
	LASSPselection_configure .controls.power -font $font
	LASSPselection_configure .graphf.menu.m2.init_cond  -font $font

	#graph
	.graphf.graph configure -height $hght -width $wdth
	.latticef.lattice configure -height $hght -width $wdth
	.graphf.graph configure -font $font
	.graphf.graph xaxis config -font $font -ticklength 6
	.graphf.graph yaxis config -font $font -ticklength 6

	
	# the selections
	LASSPselection_configure .disp_type -font $font

	#text
	.controls.averages1 configure -font $font
	.controls.averages2 configure -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.configure configure -font $font
	.help configure -font $font
	.quit configure -font $font
   
	#RHS games
	pack .controls.sweep -fill x -pady [expr ($wdth - 340)/40]
	pack .controls.temp -fill x -pady [expr ($wdth - 340)/40]
	pack .controls.hext -fill x -pady [expr ($wdth - 340)/40]
	pack .controls.ising -fill x -pady [expr ($wdth - 340)/40]
	pack .controls.dipole -fill x -pady [expr ($wdth - 340)/40] 
	pack .controls.sigma -fill x -pady [expr ($wdth - 340)/40]
	pack .controls.axis -fill x -pady [expr ($wdth - 340)/40]
	pack .controls.power -fill x -pady [expr ($wdth - 340)/40]
	pack .controls.n -fill x -pady [expr ($wdth - 340)/40]

	#redraw
       global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}
}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option
