set SSS_PROG "peierls"

wm  minsize . 900 400
set peierls_config_palette 0

#########set two arrays for the data for the graph to go into
set data_xv {}
set data_yv {}

set lc 2.0  
set scale 100.0
set CENTER 200.0
set KSCALE 100.0
set radius 3.5
set nmax 14
set tail 3
set center 200.0
#########set the delay between updates of the graph
set graph_update_delay 10

###################################################################
#mod spt
#getting the screen size and using it for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0
proc startup {} {
global wd ht wdth hght font disp_option CENTER scale tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 220
	set hght 220
	set CENTER 110.0
	set scale 55.0
	set disp_option "small"
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 600 410
	wm maxsize . 750 450
	
	} elseif {$wd <= 832} {
		set wdth 300
		set hght 300
		set CENTER 150.0
		set scale 75.0
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 770 420
		wm maxsize . 900 550
	 } else {
			set wdth 400
			set hght 400
			set CENTER 200.0
			set scale 100.0
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 1000 450
			wm maxsize . 4000 3000
			}
}

proc set_para {} {
global wd ht wdth hght font disp_option CENTER scale radius tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 220
	set hght 220
	set CENTER 110.0
	set scale 55.0
	set radius 2.0
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 600 410
	wm maxsize . 750 450

	} elseif {$disp_option == "medium"} {
		set wdth 300
		set hght 300
		set CENTER 150.0
		set scale 75.0
		set radius 2.5
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 770 420
		wm maxsize . 900 550
	 } else {
			set wdth 400
			set hght 400
			set CENTER 200.0
			set scale 100.0
			set radius 3.5
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 1000 450
			wm maxsize . 4000 3000
		}
	# Configuring the font for all the widgets.
	config_all

#	if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}

}


#mod spt
startup

################## tcl initialize ############################
proc tcl_initialize {} {
	 global x_velocity y_velocity xh_velocity yh_velocity CENTER


    # get the time step
    time_step

    # initialize positions and wave vectors 
    initialize
    
    # mod rbr, redraw origins
    .electronsf.can coords origin [expr $CENTER-5] [expr $CENTER-5] [expr $CENTER+5] [expr $CENTER+5]
    .holesf.can coords origin [expr $CENTER-5] [expr $CENTER-5] [expr $CENTER+5] [expr $CENTER+5]
    .holesf.can raise origin all
    .holesf.can raise average all

    # reset graph, done in initialize in C code
}


#########update the graph, with a guard against 0-length data arrays
proc graph_update {} {
    global data_xv data_yv data_xhv data_yhv
    
    if {[llength $data_xv] > 0} {
	.graph_window.graph element append x_velocity $data_xv
	.graph_window.graph element append xh_velocity $data_xhv
	set data_xv {}
	set data_xhv {}
	if {[llength $data_yv] > 0} {
	    .graph_window.graph element append y_velocity $data_yv
	    set data_yv {}
	    .graph_window.graph element append yh_velocity $data_yhv
	    set data_yhv {}
	}
    }
#mod rbr - call graph update if new data
	global show_graph
    	if { $show_graph == 1 } {
		graph_display
	}

}


##################### draw the brillouin zone boundarys  #######
proc draw_bz {} {
    global lc
    global scale
    global shift

    .electronsf.can delete bz
    .holesf.can delete bz
    set width  [lindex [.electronsf.can config -width] 4]
    set height  [lindex [.electronsf.can config -height] 4]
    set woffset [expr $width/2. - 3.14159/$lc*$scale]
    set hoffset [expr $height/2. - 3.14159/$lc*$scale]
    .electronsf.can create line $woffset 0 $woffset $height \
	    -fill blue -width 4 -tag bz  
    .electronsf.can create line \
	    [expr $width-$woffset] 0 [ expr $width-$woffset] $height \
	    -fill blue -width 4 -tag bz
    .electronsf.can create line 0 $hoffset $width $hoffset  \
	    -fill blue -width 4 -tag bz
    .electronsf.can create line\
	    0 [expr $height-$hoffset] $width  [expr $height-$hoffset]\
	    -fill blue -width 4 -tag bz  

    set width  [lindex [.holesf.can config -width] 4]
    set height  [lindex [.holesf.can config -height] 4]
    set woffset [expr $width/2. - 3.14159/$lc*$scale]
    set hoffset [expr $height/2. - 3.14159/$lc*$scale]
    if {$shift==0} {
	.holesf.can create line $woffset 0 $woffset $height \
		-fill blue -width 4 -tag bz
	.holesf.can create line \
		[expr $width-$woffset] 0 [ expr $width-$woffset] $height\
		-fill blue -width 4 -tag bz
	.holesf.can create line 0 $hoffset $width $hoffset  \
		-fill blue -width 4 -tag bz 
	.holesf.can create line 0 [expr $height-$hoffset] $width \
		[expr $height-$hoffset] -fill blue -width 4 -tag bz 
    } else {
	.holesf.can create line [expr $width/2] 0 [expr $width/2] $height\
		-fill blue -width 4 -tag bz
	.holesf.can create line 0 [expr $height/2]  $width [expr $height/2] \
		-fill blue -width 4 -tag bz
    }
   
}

 
####find the highest number in a list
proc get_highest {num_list} {
    set highest 0
    foreach i $num_list {
	if {$i > $highest} {
	    set highest $i
	}
    }
    return $highest
}
####while running, do the Runge-Kutta integration for one time step
proc tcl_evolve {} {
    global running
    while {$running == 1} {
	evolve
	update
    }
}
 
#######show the graph of v_x and v_y vs time (toggle on and off)
proc graph_toggle {} {
    global show_graph font
    if {$show_graph} {
	toplevel .graph_window
	wm minsize .graph_window 1 1 
	global num_graphs
	set num_graphs 0
	
	frame .graph_window.menu
	
	#mod rbr
	bind .graph_window <Destroy> {
	    if { [string compare %W ".graph_window"] == 0 } {
		global show_graph
		if { $show_graph == 1 } {
		    set show_graph 0
		    update
		}
	    }
	}

	button .graph_window.menu.configure -font $font -text configure \
		-command "graph_config .graph_window.graph"
#RHS replaced this line, 3/23/97  button .graph_window.menu.close -text "close"\
		-command ".control.graph invoke"
	button .graph_window.menu.close -font $font -text "close"\
		-command ".electronsf.top.graph invoke"
	blt_graph .graph_window.graph -width 400 -height 300 -plotbackground white
	.graph_window.graph legend configure -mapped yes
	.graph_window.graph xaxis configure -title "time (ps)"
	.graph_window.graph configure -leftmargin 0
	LASSPgrzoom .graph_window.graph
        LASSPgrcursor .graph_window.graph "format {%.3lf,   %.4lf} "

	.graph_window.graph element create x_velocity
	.graph_window.graph element configure x_velocity -fg blue
	.graph_window.graph element configure x_velocity -label "v_x (e)"
	.graph_window.graph element create y_velocity
	.graph_window.graph element configure y_velocity -label "v_y (e)"
	.graph_window.graph element configure y_velocity -fg red

	.graph_window.graph element create xh_velocity
	.graph_window.graph element configure xh_velocity -fg blue
	.graph_window.graph element configure xh_velocity -label "v_x (h)"
	.graph_window.graph element create yh_velocity
	.graph_window.graph element configure yh_velocity -label "v_y (h)"
	.graph_window.graph element configure yh_velocity -fg red
	.graph_window.graph yaxis configure -font $font
	.graph_window.graph xaxis configure -font $font
	.graph_window.graph configure -font $font

	graph_display

	button .graph_window.menu.copygraph -font $font -text "copy graph" -command {
	    global num_graphs
	    incr num_graphs 1
	    graph_create .graph$num_graphs .graph_window.graph 
	}
	

	pack .graph_window.menu.copygraph -side right
	pack .graph_window.menu.configure -side right
        pack .graph_window.menu.close -side right
	pack .graph_window.menu 
	pack .graph_window.graph -expand yes -fill both
# mod rbr
# One must have at least one data point under windows and some X stations
# in order for the graph to draw at all. If the graph doesn't draw anything
# until the program has run long enough to generate some data points, then
# under windows, clicking in the graph will crash the program!
# dummy legend looks bad
	.graph_window.graph element create dummy
#	.graph_window.graph legend configure -mapped no
	.graph_window.graph element append dummy {0.0 0.0}
	update
	graph_display
#	.graph_window.graph element delete dummy
#	.graph_window.graph legend configure -mapped yes
#	update
# end mod rbr
    } else {
	destroy .graph_window
    }
}

proc graph_display {} {
    global holes

#mod rbr    
if { 0 != [llength [lindex [.graph_window.graph element config x_velocity -data] 4 ] ] } {
# there is real data
#	.graph_window.graph element delete dummy
	.graph_window.graph legend configure -mapped yes
	if {$holes} {
		.graph_window.graph yaxis configure -title "average v_h (10^6 m/s)"
		.graph_window.graph element show {xh_velocity yh_velocity}
	} else {
		.graph_window.graph yaxis configure -title "average v_e (10^6 m/s)"
		.graph_window.graph element show {x_velocity y_velocity}
	}
	update
} else {
# no real data
	.graph_window.graph legend configure -mapped no
	.graph_window.graph element show {dummy}
	if {$holes} {
		.graph_window.graph yaxis configure -title "average v_h (10^6 m/s)"
	} else {
		.graph_window.graph yaxis configure -title "average v_e (10^6 m/s)"
 	}
}
}







################# the presetsave procedure ############################
proc presetsave {file} {
    
    #global variables & checkbuttons
    # mod rbr rhs remove show_graph from list of saved vars
    foreach s { graph_update_delay holes electrons shift nmax tail} {
        global $s
        puts $file "set $s [set $s]"
    }
    #selections
    foreach s {} {
        set val [LASSPselection_set $s]
	puts $file "LASSPselection_set $s $val"
    }
    
    #sliders
    foreach s {.control.variables.ex .control.variables.ey \
	    .control.variables.bz .control.variables.tau \
	    .control.variables.fermi .control.variables.anis \
	    .control.speed } {
        set val [LASSPscale2_configure $s -scrollinc]
        puts $file "LASSPscale2_configure $s -scrollinc $val"
        set val [LASSPscale2_configure $s -scrollmin]
        puts $file "LASSPscale2_configure $s -scrollmin $val"
        set val [LASSPscale2_configure $s -scrollmax]
        puts $file "LASSPscale2_configure $s -scrollmax $val"
        set val [LASSPscale2_configure $s -scrolltype]
        puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"

        set var [LASSPscale2_configure $s -var]
        global $var
        puts $file "LASSPscale2_set -nocommand $s [set $var]"
    } 
    
    puts $file "tcl_initialize"
# put all in tcl_initialize ??
    puts $file "draw_bz"

}

############################### create a configure window ############
####configure number of electons and delay between updates of graph


proc configure {} {
    if {[winfo exists .peierlsconfig]} {
        foreach win [winfo children .peierlsconfig] {
            destroy $win
        }
    } else {
        toplevel .peierlsconfig
        wm title .peierlsconfig "peierls configure"
    }
    set w .peierlsconfig
    frame $w.controls
    label $w.controls.l -text "peierls configure"
    button $w.controls.b -text close -command "destroy .peierlsconfig"
    button $w.controls.b2 -text revert -command "configure"
  
    global nmax
    frame $w.nmax 
    label $w.nmax.l -text "k-space grid"
    LASSPentry $w.nmax.e  \
	    {expr {[catch {expr -[%W get]}] \
            || !([%W get]>0) \
            || ([expr [catch {set nmax [%W get]}]]) \
	    || ([expr [catch {initialize}]])} }

    LASSPentry_set $w.nmax.e $nmax

    global tail
    frame $w.tail 
    label $w.tail.l -text "worm length"
    LASSPentry $w.tail.e  \
	    {expr {[catch {expr -[%W get]}] \
            || !([%W get]>0) \
            || ([expr [catch {set tail [%W get]}]]) \
	    || ([expr [catch {initialize}]])} }

    LASSPentry_set $w.tail.e $tail

    global graph_update_delay
    frame $w.graph_update_delay 
    label $w.graph_update_delay.l -text "graph update increments"
    LASSPentry $w.graph_update_delay.e  \
	    {expr {[catch {expr -[%W get]}] \
            || !([%W get]>0) \
            || ([expr [catch {set graph_update_delay [%W get]}]]) \
	    || ([expr [catch {initialize}]])} }

    LASSPentry_set $w.graph_update_delay.e $graph_update_delay

    pack $w.controls.l -side left -fill x -expand yes
    pack $w.controls.b2 -side left -fill x -expand yes
    pack $w.controls.b -side left -fill x -expand yes
    pack $w.controls -fill x -expand yes -pady 1

    pack $w.nmax.l -side left
    pack $w.nmax.e -side left
    pack $w.nmax
   
    pack $w.tail.l -side left
    pack $w.tail.e -side left
    pack $w.tail

    pack $w.graph_update_delay.l -side left
    pack $w.graph_update_delay.e -side left
    pack $w.graph_update_delay
    #mod rbr
    raise $w
}

##################create frames, buttons, etc
#hole positions
frame .holesf
frame .holesf.top
canvas .holesf.can -height $hght -width $wdth -relief raised -bg black
#.holesf.can create text 200 0 -anchor n -text "time (ps) 0" -fill white -tag clock
label .holesf.pos -font $font -text "wave vector: (0,0) 1/A"
bind .holesf.can <Motion> {
    set width  [lindex [.electronsf.can config -width] 4]
    set height  [lindex [.electronsf.can config -height] 4]
    set woffset [expr $width/2. - 3.14159/$lc*$scale]
    set hoffset [expr $height/2. + 3.14159/$lc*$scale]

    if {$shift == 0} {
	set a [expr ( %x - $center)/$scale]
	set b [expr (-%y + $center)/$scale]
    } else {
	set a [expr ( %x - $woffset)/$scale]
	set b [expr (-%y + $hoffset)/$scale]
    }
    .holesf.pos configure -text "wave vector: ($a, $b) 1/A" 
}  
checkbutton .holesf.top.show -font $font -text "show holes" -var holes \
	-command  {if {$show_graph} graph_display; if {$holes} {
    .holesf.can itemconfigure particle -fill white -outline black
    .holesf.can itemconfigure surface -fill red -outline red
    .holesf.can itemconfigure average -fill green -outline black
    .holesf.can itemconfigure origin -fill red -outline black
} else {
    .holesf.can itemconfigure particle -fill "" -outline ""
    .holesf.can itemconfigure surface -fill "" -outline ""
    .holesf.can itemconfigure average -fill "" -outline ""
    .holesf.can itemconfigure origin -fill "" -outline ""
}

}
.holesf.top.show invoke
label .holesf.top.clock -font $font -text "time (ps) 0.0"

#electron positions
frame .electronsf
frame .electronsf.top
canvas .electronsf.can -height $hght -width $wdth -relief raised -background black
label .electronsf.pos -font $font -text "wave vector: (0,0) 1/A"
bind .electronsf.can <Motion> {
set a [expr ( %x - $center)/$scale]
set b [expr (-%y + $center)/$scale]
    .electronsf.pos configure -text "wave vector: ($a, $b) 1/A"
}  
label .electronsf.top.elecnr -font $font -text "number of electrons"


#frame for all controls
frame .control -relief flat -bd 3
frame .control.variables 

#variable controls
LASSPscale2 .control.variables.ex -text "E_x (10^6 V/m): " -var E_x \
	-scrollmin 0 -scrollmax 10 -scrollinc .1 -initial 2 -command {time_step}
LASSPscale2_configure .control.variables.ex -font $font

LASSPscale2 .control.variables.ey -text "E_y (10^6 V/m): " -var E_y \
	-scrollmin 0 -scrollmax 10 -scrollinc .1 -initial 0 -command {time_step}
LASSPscale2_configure .control.variables.ey -font $font
  
LASSPscale2 .control.variables.bz -text "B_z (T): " -var B_z \
	-scrollmin 0 -scrollmax 10 -scrollinc .1 -initial 3 -command {time_step} 
LASSPscale2_configure .control.variables.bz -font $font

LASSPscale2 .control.variables.tau -text "tau (ps):" -var tau \
	-scrollmin 1e-1 -scrollmax 1e5 -initial 1e0 -scrollinc 1e-1 \
	-type real -scrolltype log -command {time_step} -test {%v>0}
LASSPscale2_configure .control.variables.tau -font $font

LASSPscale2 .control.variables.fermi -text "Fermi energy (eV)" \
	-var fermi -scrollmin 0 -scrollmax 10 -scrollinc .1 -initial 5 \
	-test {%v>0} -command {initialize}
LASSPscale2_configure .control.variables.fermi -font $font

LASSPscale2 .control.variables.anis -text "anisotropy" \
	-var anis -scrollmin 0 -scrollmax 5 -scrollinc .1 -initial 1 \
	-test {%v>0} -command {initialize}
LASSPscale2_configure .control.variables.anis -font $font


#other controls-speed, run, configure, quit, help

checkbutton .holesf.top.shift -font $font -text "shift origin" -var shift \
	-command {draw_bz; update; shift_draw}
LASSPscale2 .control.speed -text "speed" -var speed -scrollmin 0 \
	-scrollmax 50 -scrollinc 1 -initial 2 -test {%v>0} -command time_step
LASSPscale2_configure .control.speed -font $font

#spt
#frame .topcontrol

set running 0
button .control.run -font $font -text "run" -height 2 -command {
    global running show_graph
    if {$running} {
	set running 0
	.control.run configure -text "run"
	if {$show_graph} {
	    graph_update
	}
    } else {
	set running 1
	.control.run configure -text "stop"
	tcl_evolve
    } 
}



button .control.initialize -font $font -text "initialize" -height 2 \
	-command {tcl_initialize}

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small" 
LASSPselection_configure .disp_type -font $font


button .quit -font $font -text "quit" -command "exit 0" -width 10
button .config -font $font -text "configure..."  -command configure -width 10
button .help -font $font -text "help..."  -width 10 \
	-command {LASSPhelp2 .t2 [file join $SSS_DIR lib/peierls/peierls.htm]}

LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

#RHS replaced this line, 3/23/97  checkbutton .control.graph -font $font -text "show graph" -width 10 -variable show_graph -command graph_toggle
checkbutton .electronsf.top.graph -font $font -text "show graph" -width 10 -variable show_graph -command graph_toggle
#LASSPselection  .control.graph "show graph" show_graph {graph_toggle} \
#	"none" "electrons" "holes"
#set show_graph none


#############packing
#spt
pack .quit .disp_type .config .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top

#pack .topcontrol.run -side left
#pack .topcontrol.initialize -side left
#pack .topcontrol -side top

#pack .electronsf.show -side top 
label .electronsf.fill
pack .electronsf.fill -side top
pack .electronsf.top.elecnr -side left -padx 10
#RHS added following line, 3/23/97
pack .electronsf.top.graph -side left -padx 10
pack .electronsf.top -side top
pack .electronsf.can
pack .electronsf.pos -side bottom

pack .electronsf -side right -fill x -expand yes


pack .control.run -fill x
pack .control.initialize -fill x

pack .control.variables.ex -fill x
pack .control.variables.ey -fill x
pack .control.variables.bz -fill x
pack .control.variables.tau -fill x
pack .control.variables.fermi -fill x
pack .control.variables.anis -fill x
pack .control.variables -side top 

pack .control.speed -fill x
#pack .control.presets -fill x 
#pack .control.config -fill x
#pack .control.help  -fill x 
#pack .control.quit -fill x 
#RHS deleted this line, 3/23/97  pack .control.graph -fill x
#pack .control.time 

pack .control -side right -fill x -expand yes

pack .holesf.top.shift -side right
pack .holesf.top.show -side right 
pack .holesf.top.clock -side left -padx 10
pack .holesf.top -side top
pack .holesf.can
pack .holesf.pos -side bottom
pack .holesf -side left -fill x -expand yes

 
draw_bz

bind . <Key-space> {.control.run invoke}
bind . <Key-i> {.control.initialize invoke}
bind . <Key-Escape> {.control.quit invoke}

#mod mjb 8/27/97
	 global peierls_config_palette
	 if { $peierls_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set peierls_config_palette 1
	 }

#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#button
	.control.initialize configure -font $font
	.control.run configure -font $font

	#graph
	.holesf.can configure -height $hght -width $wdth 
	.electronsf.can configure -height $hght -width $wdth 

	#label
	.holesf.pos configure -font $font
	.electronsf.pos configure -font $font
	.electronsf.top.elecnr configure -font $font
	.holesf.top.clock configure -font $font

	#scale
	LASSPscale2_configure .control.variables.ex -font $font
	LASSPscale2_configure .control.variables.ey -font $font
	LASSPscale2_configure .control.variables.bz -font $font
	LASSPscale2_configure .control.variables.tau -font $font
	LASSPscale2_configure .control.variables.fermi -font $font
	LASSPscale2_configure .control.variables.anis -font $font
	LASSPscale2_configure .control.speed -font $font


	#checkbutton
	.holesf.top.show configure -font $font
	.holesf.top.shift configure -font $font
#RHS	replaced this line, 3/23/97  .control.graph configure -font $font
	.electronsf.top.graph configure -font $font


	# the selections
	LASSPselection_configure .disp_type -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.config configure -font $font
	.help configure -font $font
	.quit configure -font $font
   
	#procedures to redraw
	draw_bz
	tcl_initialize
      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}
}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option

