set SSS_PROG poisson

####################### global variable are: ######################
# num_graphs - used for the LASSPgraph routines
set num_graphs 0
set Ametal 3.0
set Asemi 2.0
set poisson_config_palette 0

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0
proc startup {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth [expr 600/3.0]
	set hght 250
	set disp_option "small"
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 580 450
	wm maxsize . 950 750

	} elseif {$wd <= 800} {
		set wdth [expr 700/2.5]
		set hght [expr 500/1.75]
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 640 480
		wm maxsize . 1050 800
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set disp_option "large"
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 750 550
			wm maxsize . 4000 3000
			}
}

proc set_para {} {
global wd ht wdth hght font disp_option tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth [expr 600/3.0]
	set hght 250
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 580 450
	wm maxsize . 950 750

	} elseif {$disp_option == "medium"} {
		set wdth [expr 700/2.5]
		set hght [expr 500/1.75]
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}

		wm minsize . 640 480
		wm maxsize . 1050 800
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 750 550
			wm maxsize . 4000 3000
			}
	# Configuring the font for all the widgets.
	config_all

#	if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}

}


#mod spt
startup

################################## graphs   ############
blt_graph .density -width $wdth -height [expr $hght/2.0] -relief raised -bd 2 \
	-plotbackground white
.density element create rho -fg black -linewidth 2  -bg white -label "rho/e"
.density element create n -fg red
.density element create p -fg blue
.density xaxis configure -title "x (cm)"
.density yaxis configure -title "densities (1/cm^3)"
LASSPgrcursor .density "format {%.3le,   %.2le} "
LASSPgrzoom .density

blt_graph .energy -width $wdth -height [expr $hght/2.0] -relief raised -bd 2 \
	-plotbackground white
.energy element create mu1 -fg green  -bg white -dashes 10 -linewidth 2
.energy element create mu2 -fg green -bg white -dashes 10 -linewidth 2
.energy element create Ea -fg black -bg white -dashes 5
.energy element create Ed -fg black -bg white -dashes 5
.energy element create Ev -fg blue 
.energy element create Ec -fg red 
.energy xaxis configure -title "x (cm)"
.energy yaxis configure -title "band energies (eV)" 
#mod rbr mapped yes
.energy legend configure -mapped yes
LASSPgrcursor .energy "format {%.3le,    %.2le} "
LASSPgrzoom .energy

##########################################################3
### packright procedure - handles packing of LASSPscales
proc packright {} {
    global device
    pack forget .nd .na .n .nptype .egap .va \
	    .dins .ssdensity .approx
    if {$device=="pn junction"} {
	pack .approx .nd .na .egap .va -in .right -after .device -fill both
    } elseif {$device=="MIS diode"} {
	pack .n .nptype .egap .va .ssdensity .dins \
		-in .right -after .device -fill both
    }
    pn_update
}

################################## right panel  ############
### general controls ###
frame .right

button .copydensities -font $font -text "copy densities" -command {
    incr num_graphs 1
    graph_create .graph$num_graphs .density 
}
button .copyenergies -font $font -text "copy energies" -command {
    incr num_graphs 1
    graph_create .graph$num_graphs .energy 
}

#menubutton .copygraph -menu .copygraph.m -text "copy graph" -relief raised
#menu .copygraph.m -tearoff no 
#.copygraph.m add command -label "densities" -command {
#    incr num_graphs 1
#    graph_create .graph$num_graphs .density 
#}
#.copygraph.m add command -label "energies" -command {
#    incr num_graphs 1
#    graph_create .graph$num_graphs .energy 
#}

label .readout -relief flat 


LASSPselection .device "device" device {packright; pn_update} \
	"pn junction" "MIS diode" 
set device "pn junction"
LASSPselection_configure .device -font $font

LASSPselection .approx "solution:" approximate {pn_update} \
	{'exact'}  {approx.} 
set approximate {'exact'}
LASSPselection_configure .approx -font $font

set autoscale 1
checkbutton .autoscale -font $font -text autoscale -var autoscale  \
	-relief raised -command {
    if {!$autoscale} {
	set %W [.density xaxis limits]
	.density xaxis configure -min [lindex ${%W} 0] \
		-max [lindex ${%W} 1]	
	set %W [.density yaxis limits]
	.density yaxis configure -min [lindex ${%W} 0] \
		-max [lindex ${%W} 1] 
	set %W [.energy xaxis limits]
	.energy xaxis configure -min [lindex ${%W} 0] \
		-max [lindex ${%W} 1]
	set %W [.energy yaxis limits]
	.energy yaxis configure -min [lindex ${%W} 0] \
		-max [lindex ${%W} 1] 
    } else {
	.density xaxis configure -min {} -max {}
	.density yaxis configure -min {} -max {}
	.energy xaxis configure -min {} -max {}
	.energy yaxis configure -min {} -max {}
    }
}

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font

LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

button .configure -font $font -text "configure..." -command {configure}
button .help -font $font -text "help..." -command {LASSPhelp2 .t2 [file join $SSS_DIR lib/poisson/poisson.htm]}
button .quit -font $font -text "quit" -command {exit}


### parameter sliders ###
# doping densities
LASSPscale2 .nd -text "Nd (1/cm^3)" -scrollmin 1e16 -scrollmax 1e24  \
	-initial 1e17 -scrollinc 1e16 -type real -var Nd  \
	-scrolltype log -command {pn_update} -test {%v>0}
LASSPscale2_configure .nd -font $font

LASSPscale2 .na -text "Na (1/cm^3)" -scrollmin 1e16 -scrollmax 1e24  \
	-initial 1e17 -scrollinc 1e16 -type real -var Na \
	-scrolltype log -command {pn_update} -test {%v>0}
LASSPscale2_configure .na -font $font

LASSPscale2 .n -text "Ni (1/cm^3)" -scrollmin 1e16 -scrollmax 1e24  \
	-initial 1e18 -scrollinc 1e16 -type real -var N \
	-scrolltype log -command {pn_update}  -test {%v>0}
LASSPscale2_configure .n -font $font

# band gap
LASSPscale2 .egap -text "Egap (eV)" -scrollmin 0 -scrollmax 5  \
	-initial 1 -scrollinc .05 -type real -var Egap \
	-command {pn_update} -test {%v>0}
LASSPscale2_configure .egap -font $font

#applied voltage
LASSPscale2 .va -text "Vapplied (V)" -scrollmin -5 -scrollmax 5  \
	-initial 0 -scrollinc .05 -type real -var Va -command {pn_update} \
	-test {[global device Egap] {"$device"!="pn junction"} || %v<[expr $Egap/2.0]}
LASSPscale2_configure .va -font $font
 
# for mosfets: insulator width
LASSPscale2 .dins -text "Dins (cm)" -scrollmin 1e-8 -scrollmax 1e-4  \
	-initial 1e-6 -scrollinc 1e-8 -scrolltype log \
	-type real -var Dins -command {pn_update} -test {%v>0}
LASSPscale2_configure .dins -font $font

# interface density of states (for mosfets)
LASSPscale2 .ssdensity -text "N_int (1/eV cm^2)" -scrollmin 1e9 \
	-scrollmax 1e14 -scrolltype log -type real -test {%v>0} \
	-initial 1e8 -scrollinc 1e9 -var ssdensity  -command {pn_update}
LASSPscale2_configure .ssdensity -font $font

# for mosfets...
button .nptype -font $font -text "n-type" -command {
    if {$nptype=="1"} {
	.nptype configure -text "p-type"
	set nptype "-1"
    } else {
	.nptype configure -text "n-type"
	set nptype "1"
    }
    pn_update
}

#spt
pack .quit .disp_type .configure .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top

pack .device -in .right -fill both
pack .approx -in .right -fill both -pady 2

pack .nd -in .right -fill both -padx 2 -pady 2
pack .na -in .right -fill both -padx 2 -pady 2
pack .egap -in .right -fill both -padx 2 -pady 2
pack .va -in .right -fill both -padx 2 -pady 2

#pack .quit -in .right -side bottom -fill both
#pack .help -in .right -side bottom -fill both
#pack .configure -in .right -side bottom -fill both
#pack .presets -in .right -side bottom -fill both -padx 2
pack .autoscale -in .right -side bottom -fill both -padx 2 -pady 2
pack .copyenergies -in .right -side bottom -fill both 
pack .copydensities -in .right -side bottom -fill both 
#pack .copygraph -in .right -side bottom -fill both 
pack .readout -in .right -side bottom -fill both -pady 4 -expand yes


############################ set up the toplevel window #############

wm minsize . 200 200
pack .right -side right -fill both 
pack .density -fill both -expand yes
pack .energy -fill both -expand yes
pn_update



################################## the presetsave procedure ############
proc presetsave {file} {
    #global variables
    #mod rbr - remove autoscale
    foreach s {Mc Mv Ed Ea T Ametal Asemi nptype STEPSIZE ENERGYCUTOFF\
	    SPIKEWIDTH EPSILON_INS EPSILON_SEMI} {
        global $s
        puts $file "set $s [set $s]"
    }
    
    #mod rbr - nptype button
    if { $nptype == -1 } {
	puts $file {.nptype configure -text {p-type} } 
    } else {
	puts $file { .nptype configure -text {n-type} }
    }

    #selections
    foreach s {.device .approx} {
        set val [LASSPselection_set $s]
        puts $file "LASSPselection_set $s \"$val\""
    }

    #sliders
    foreach s {.nd .na .n .egap .va .dins .ssdensity } {
        set val [LASSPscale2_configure $s -scrollinc]
        puts $file "LASSPscale2_configure $s -scrollinc $val"
        set val [LASSPscale2_configure $s -scrollmin]
        puts $file "LASSPscale2_configure $s -scrollmin $val"
        set val [LASSPscale2_configure $s -scrollmax]
        puts $file "LASSPscale2_configure $s -scrollmax $val"
        set val [LASSPscale2_configure $s -scrolltype]
        puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"

	set val [LASSPscale2_get $s]
        puts $file "LASSPscale2_set -nocommand $s $val"
    } 
    
    puts $file "pn_update"
}


############################ create a configure window ############
proc configure {} {
    set w .poissonconfig

    if {[winfo exists $w]} {
	set list [winfo children $w]
	set index [lsearch $list $w.controls]
	set list [lreplace $list $index $index]
	foreach win $list  {
	    destroy $win
	}
	raise $w
    } else {
	toplevel $w
	wm title $w "poisson configure"
	frame $w.controls
	label $w.controls.l -text "poisson configure"
	button $w.controls.b -text close -command "destroy $w"
	button $w.controls.b2 -text revert -command "configure"
	pack $w.controls.l -side left -fill x -expand yes
	pack $w.controls.b2 -side left -fill x -expand yes
	pack $w.controls.b -side left -fill x -expand yes
	pack $w.controls -fill x -expand yes -pady 1
    }    

    global Mc Mv Ed Ea T Ametal Asemi \
	    STEPSIZE ENERGYCUTOFF SPIKEWIDTH EPSILON_INS EPSILON_SEMI

#    frame $w.mc
#   label $w.mc.l -text "electron effective mass (m):"
#   LASSPentry $w.mc.e \
#	    {expr {[catch {expr -[%W get]}] \
#                   || !([%W get]>0) \
#                   || [catch {set Mc [%W get]}] \
#	           || [catch {pn_update}]   }   }
#    pack $w.mc.l  -side left
#    pack $w.mc.e  -side left -fill x -expand yes
#    pack $w.mc -fill x -expand yes -pady 1
#    LASSPentry_set $w.mc.e $Mc
 
#    frame $w.mv
#    label $w.mv.l -text "hole effective mass (m):"
#    LASSPentry $w.mv.e \
#	    {expr {[catch {expr -[%W get]}] \
#                   || !([%W get]>0) \
#                   || [catch {set Mv [%W get]}]\
#	           || [catch {pn_update}]  }}
#    pack $w.mv.l  -side left
#    pack $w.mv.e  -side left -fill x -expand yes
#    pack $w.mv -fill x -expand yes -pady 1
#    LASSPentry_set $w.mv.e $Mv
    
#    frame $w.ed
#    label $w.ed.l -text  "(Ec-Ed) (eV):"
#    LASSPentry $w.ed.e \
#	    {expr {[catch {expr -[%W get]}] \
#                   || !([%W get]>0) \
#                   || [catch {set Ed [%W get]}]  \
#	           || [catch {pn_update}]  }   }
#    pack $w.ed.l  -side left
#    pack $w.ed.e  -side left -fill x -expand yes
#    pack $w.ed -fill x -expand yes -pady 1
#    LASSPentry_set $w.ed.e $Ed

#    frame $w.ea
#    label $w.ea.l -text  "(Ea-Ev) (eV):"
#    LASSPentry $w.ea.e \
#	    {expr {[catch {expr -[%W get]}]\
#                   || !([%W get]>0)  \
#                   || [catch {set Ea [%W get]}] \
#	           || [catch {pn_update}] }}
#    pack $w.ea.l  -side left
#    pack $w.ea.e  -side left -fill x -expand yes
#    pack $w.ea -fill x -expand yes -pady 1
#    LASSPentry_set $w.ea.e $Ea
     
#    frame $w.t
#    label $w.t.l -text  "temperature (K):"
#    LASSPentry $w.t.e \
#            {expr {[catch {expr -[%W get]}] \
#                   || !([%W get]>0) \
#                   || [catch {set T [%W get]}]  \
#	           || [catch {pn_update}] }   }
#    pack $w.t.l  -side left
#    pack $w.t.e  -side left -fill x -expand yes
#    pack $w.t -fill x -expand yes -pady 1
#    LASSPentry_set $w.t.e $T

    frame $w.ametal
    label $w.ametal.l -text  "A_metal (eV):"
    LASSPentry $w.ametal.e \
	    {expr {[catch {expr -[%W get]}] \
                   || !([%W get]>0) \
		   || [catch {set Ametal [%W get]}] \
	           || [catch {pn_update}] }   }
    pack $w.ametal.l  -side left
    pack $w.ametal.e  -side left -fill x -expand yes
    pack $w.ametal -fill x -expand yes -pady 1
    LASSPentry_set $w.ametal.e $Ametal
     
    frame $w.asemi
    label $w.asemi.l -text  "A_semi (eV):"
    LASSPentry $w.asemi.e \
	    {expr {[catch {expr -[%W get]}] \
                   || !([%W get]>0) \
		   || [catch {set Asemi [%W get]}] \
	           || [catch {pn_update}] }}
    pack $w.asemi.l  -side left
    pack $w.asemi.e  -side left -fill x -expand yes
    pack $w.asemi -fill x -expand yes -pady 1
    LASSPentry_set $w.asemi.e $Asemi
     
    frame $w.stepsize
    label $w.stepsize.l -text  "step size (%):"
    LASSPentry $w.stepsize.e \
	    {expr {[catch {expr -[%W get]}]\
                   || !([%W get]>0) \
		   || [catch {set STEPSIZE [%W get]}] \
	           || [catch {pn_update}] }}
    pack $w.stepsize.l  -side left
    pack $w.stepsize.e  -side left -fill x -expand yes
    pack $w.stepsize -fill x -expand yes -pady 1
    LASSPentry_set $w.stepsize.e $STEPSIZE
     
    frame $w.energycutoff
    label $w.energycutoff.l -text  "energy cutoff (eV):"
    LASSPentry $w.energycutoff.e \
	    {expr {[catch {expr -[%W get]}]\
                   || !([%W get]>0)  \
		   || [catch {set ENERGYCUTOFF [%W get]}] \
	           || [catch {pn_update}] }}
    pack $w.energycutoff.l  -side left
    pack $w.energycutoff.e  -side left -fill x -expand yes
    pack $w.energycutoff -fill x -expand yes -pady 1
    LASSPentry_set $w.energycutoff.e $ENERGYCUTOFF

    frame $w.spikewidth
    label $w.spikewidth.l -text  "spike width (cm):"
    LASSPentry $w.spikewidth.e \
	    {expr {[catch {expr -[%W get]}]\
                   || !([%W get]>0)  \
		   || [catch {set SPIKEWIDTH [%W get]}] \
	           || [catch {pn_update}] }}
    pack $w.spikewidth.l  -side left
    pack $w.spikewidth.e  -side left -fill x -expand yes
    pack $w.spikewidth -fill x -expand yes -pady 1
    LASSPentry_set $w.spikewidth.e $SPIKEWIDTH     

    frame $w.epsilon_ins
    label $w.epsilon_ins.l -text  "dielectric constant - insulator:"
    LASSPentry $w.epsilon_ins.e \
	    {expr {[catch {expr -[%W get]}]\
                   || !([%W get]>0)  \
		   || [catch {set EPSILON_INS [%W get]}] \
	           || [catch {pn_update}] }}
    pack $w.epsilon_ins.l  -side left
    pack $w.epsilon_ins.e  -side left -fill x -expand yes
    pack $w.epsilon_ins -fill x -expand yes -pady 1
    LASSPentry_set $w.epsilon_ins.e $EPSILON_INS     

    frame $w.epsilon_semi
    label $w.epsilon_semi.l -text  "dielectric constant - semiconductor:"
    LASSPentry $w.epsilon_semi.e \
	    {expr {[catch {expr -[%W get]}]\
                   || !([%W get]>0)  \
		   || [catch {set EPSILON_SEMI [%W get]}] \
	           || [catch {pn_update}] }}
    pack $w.epsilon_semi.l  -side left
    pack $w.epsilon_semi.e  -side left -fill x -expand yes
    pack $w.epsilon_semi -fill x -expand yes -pady 1
    LASSPentry_set $w.epsilon_semi.e $EPSILON_SEMI     
}

bind . <Key-Escape> {.quit invoke}

#mod mjb 8/27/97
	 global poisson_config_palette
	 if { $poisson_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set poisson_config_palette 1
    }

#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#graph
	.density configure -width $wdth -height [expr $hght/2.0] 
	.energy configure -width $wdth -height [expr $hght/2.0] 	
	.density configure -font $font
	.density xaxis config -font $font -ticklength 6
	.density yaxis config -font $font -ticklength 6
	.density legend config -font $font -padx 2
	.energy configure -font $font
	.energy xaxis config -font $font -ticklength 6
	.energy yaxis config -font $font -ticklength 6
	.energy legend config -font $font -padx 2


	#button
	.copydensities configure -font $font
	.copyenergies configure -font $font
	.nptype configure -font $font

	#selection
	LASSPselection_configure .device -font $font
	LASSPselection_configure .approx -font $font

	#checkbutton
	.autoscale configure -font $font

	#scale
	LASSPscale2_configure .nd -font $font
	LASSPscale2_configure .na -font $font
	LASSPscale2_configure .n -font $font
	LASSPscale2_configure .egap -font $font
	LASSPscale2_configure .va -font $font
	LASSPscale2_configure .dins -font $font
	LASSPscale2_configure .ssdensity -font $font

	# the selections
	LASSPselection_configure .disp_type -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.configure configure -font $font
	.help configure -font $font
	.quit configure -font $font
   
	.readout configure -font $font 

	#procedures to redraw
      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}
}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option


