set SSS_PROG "sommer"

set running 0
set kscale 100.0
set center 200.0
set size 60
set graph_incr 10
set num_graphs 0
set deltaE 2.0
set sommer_config_palette 0

###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0
	
set radius 2.5

proc startup {} {
global wd ht wdth hght font disp_option kscale center radius tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 240
	set hght 240
	set kscale 60.0
	set center 120.0
	set radius 2.0
	set disp_option "small"
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 640 420
	wm maxsize . 1000 650

	} elseif {$wd <= 800} {
		set wdth 280
		set hght 280
		set kscale 70.0
		set center 140.0
		set radius 2.0
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 420
		wm maxsize . 1200 850
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set disp_option "large"
			set kscale 100.0
			set center 200.0
			set radius 2.5
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 970 450
			wm maxsize . 4000 3000

			}
}

proc set_para {} {
global wd ht wdth hght font disp_option kscale center radius tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 240
	set hght 240
	set kscale 60.0
	set center 120.0
	set radius 2.0
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 640 420
	wm maxsize . 1000 650

	} elseif {$disp_option == "medium"} {
		set wdth 280
		set hght 280
		set kscale 70.0
		set center 140.0
		set radius 2.0
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 420
		wm maxsize . 1200 850
	 } else {
			set wdth [expr 920/2.3]
			set hght [expr 660/1.65]
			set kscale 100.0
			set center 200.0
			set radius 2.5
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 970 450
			wm maxsize . 4000 3000

			}
	# Configuring the font for all the widgets.
	config_all

#	if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}

}


#mod spt
startup

####while running, advance one time step
proc tcl_evolve {} {
    global running data_x data_y data_e
    while {$running == 1} {
        evolve
	update
    }
}


#   update the graph, with a guard against 0-length data arrays #
proc graph_update {} {
    global data_x data_y data_e
    
    if { 0 == [lsearch -exact [.graphf.recgraph element names] dummy] } {
        .graphf.recgraph element show {kx ky excess_e}
        .graphf.recgraph element delete dummy
        .graphf.recgraph legend configure -mapped yes
    }

    if {[llength $data_x] > 0} {
	.graphf.recgraph element append kx $data_x
	set data_x {}
	.graphf.recgraph element append ky $data_y
	set data_y {}
	.graphf.recgraph element append excess_e $data_e
	set data_e {}		
    }
}






proc configure {} {
    if {[winfo exists .sommerfeldconfig]} {
        foreach win [winfo children .sommerfeldconfig] {
            destroy $win
        }
    } else {
        toplevel .sommerfeldconfig
        wm title .sommerfeldconfig "sommer configure"
    }
    set w .sommerfeldconfig
    frame $w.controls
    label $w.controls.l -text "sommer configure"
    button $w.controls.b -text close -command "destroy .sommerfeldconfig"
    button $w.controls.b2 -text revert -command "configure"

    global deltaE
    frame $w.deltaE 
    label $w.deltaE.l -text "deltaE (eV):"
    LASSPentry $w.deltaE.e \
            {expr {[catch {expr -[%W get]}] \
            || !([%W get]>0) \
            || ([expr [catch {set deltaE [%W get]}]]) \
	    || [expr {[catch {initialize}]}]}}

    LASSPentry_set $w.deltaE.e $deltaE

    global size
    frame $w.size 
    label $w.size.l -text "box size (A):"
    LASSPentry $w.size.e \
            {expr {[catch {expr -[%W get]}] \
            || !([%W get]>0) \
            || ([expr [catch {set size [%W get]}]]) \
	    || [expr {[catch {initialize}]}]}}

    LASSPentry_set $w.size.e $size

    global graph_incr
    frame $w.graph_incr 
    label $w.graph_incr.l -text "graph update increments:"
    LASSPentry $w.graph_incr.e \
            {expr {[catch {expr -[%W get]}] \
            || !([%W get]>0) \
            || ([expr [catch {set graph_incr [%W get]}]]) \
	    || [expr {[catch {initialize}]}]}}

    LASSPentry_set $w.graph_incr.e $graph_incr


    pack $w.controls.l -side left -fill x -expand yes
    pack $w.controls.b2 -side left -fill x -expand yes
    pack $w.controls.b -side left -fill x -expand yes
    pack $w.controls -side top

    pack $w.deltaE.l -side left
    pack $w.deltaE.e -side left
    pack $w.deltaE

    pack $w.size.l -side left
    pack $w.size.e -side left
    pack $w.size


    pack $w.graph_incr.l -side left
    pack $w.graph_incr.e -side left
    pack $w.graph_incr
    #mod rbr
    raise $w
}


###########presetsave procedure
proc presetsave {file} {
    
    #global variables
    foreach s {deltaE size graph_incr} {
        global $s
        puts $file "set $s [set $s]"
    }
    
    #selections
    foreach s {} {
        set val [LASSPselection_set $s]
        puts $file "LASSPselection_set $s $val"
    }
    
    #sliders
    foreach s {.control.variables.ex .control.variables.ey \
	    .control.variables.bz .control.variables.taui .control.variables.taue \
	    .control.variables.fermi .control.variables.speed} {
 # rbr scrollinc wasnt being saved??
        set val [LASSPscale2_configure $s -scrollinc]
        puts $file "LASSPscale2_configure $s -scrollinc $val"
        set val [LASSPscale2_configure $s -scrollmin]
        puts $file "LASSPscale2_configure $s -scrollmin $val"
        set val [LASSPscale2_configure $s -scrollmax]
        puts $file "LASSPscale2_configure $s -scrollmax $val"
        set val [LASSPscale2_configure $s -scrolltype]
        puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"
	
        set var [LASSPscale2_configure $s -var]
        global $var
        puts $file "LASSPscale2_set -nocommand $s [set $var]"
    } 
    puts $file "initialize"
    
}




############create frames, canvases, ...
frame .display
canvas .display.can -height $hght -width $wdth -relief raised -bg black
label .display.pos -font $font -text "wave vector (0,0) 1/A"

bind .display.can <Motion> {
    set tcl_precision 3
    set a [expr ( %x - $center)/$kscale]
    set b [expr (-%y + $center)/$kscale]
    .display.pos configure -text "wave vector ($a, $b) 1/A"
    unset tcl_precision
}

frame .control -relief flat -bd 3
frame .control.variables
frame .graphf


blt_graph .graphf.recgraph -width $wdth -height $hght -plotbackground white
.graphf.recgraph legend configure -mapped yes
.graphf.recgraph xaxis configure -title "time (ps)"
.graphf.recgraph configure -leftmargin 0
LASSPgrzoom .graphf.recgraph
LASSPgrcursor .graphf.recgraph "format {%.3lf %.3lf}"
.graphf.recgraph element create excess_e
.graphf.recgraph element configure excess_e -fg red
.graphf.recgraph element configure excess_e -label "E"
.graphf.recgraph element create kx
.graphf.recgraph element configure kx -fg blue
.graphf.recgraph element configure kx -label "kx"
.graphf.recgraph element create ky
.graphf.recgraph element configure ky -label "ky"
.graphf.recgraph element configure ky -fg green
.graphf.recgraph element show {kx ky excess_e}
.graphf.recgraph yaxis configure -title "<k> (1/A) and E_excess (E_F)"

button .graphf.graph -font $font -text "copy graph" -command {
	 incr num_graphs 1
	 graph_create .graph$num_graphs .graphf.recgraph
}

LASSPscale2 .control.variables.ex -text "E_x (10^6 V/m): " -var E_x \
	-scrollmin 0 -scrollmax 1 -initial 1 -scrollinc .1 -command calculate_constants
LASSPscale2_configure .control.variables.ex -font $font

LASSPscale2 .control.variables.ey -text "E_y (10^6 V/m): " -var E_y \
	-scrollmin 0 -scrollmax 1 -initial 0 -scrollinc .1 -command calculate_constants
LASSPscale2_configure .control.variables.ey -font $font

LASSPscale2 .control.variables.bz -text "B_z (T): " -var B_z \
	-scrollmin -5 -scrollmax 5 -initial 0  -scrollinc .1 \
	-command calculate_constants
LASSPscale2_configure .control.variables.bz -font $font

LASSPscale2 .control.variables.taui -text "tau_i (ps): " -var taui \
	-test {%v>0.0} 	-scrollmin 1e-1 -scrollmax 1e5 -initial 1e0 -scrollinc 1e-1 \
	-type real -scrolltype log -command calculate_constants
LASSPscale2_configure .control.variables.taui -font $font

LASSPscale2 .control.variables.taue -text "tau_e (ps): " -var taue \
	-test {%v>0.0} -scrollmin 1e-1 -scrollmax 1e5 -initial 1e4 -scrollinc 1e-1 \
	-type real -scrolltype log -command calculate_constants
LASSPscale2_configure .control.variables.taue -font $font

LASSPscale2 .control.variables.fermi -text "E_Fermi (eV): " -var fermi \
		  -scrollmin 0 -scrollmax 10 -initial 7  -scrollinc 0.1 -test {%v>0.0} \
	-command {initialize}
LASSPscale2_configure .control.variables.fermi -font $font

#other controls
button .control.run -font $font -text "run" -height 2 -command {
	 global running
	if {$running} {
		  set running 0
	.control.run configure -text "run"
	graph_update
	 } else {
		  set running 1
	.control.run configure -text "stop"
		  tcl_evolve
	 }
}
button .control.initialize -font $font -text "initialize" -height 2 \
	-command {initialize}
LASSPscale2 .control.variables.speed -text "speed" -var speed \
	-scrollmin 0 -scrollmax 50 -initial 1 \
	-scrollinc 1 -test {%v>0.0} -command calculate_constants
LASSPscale2_configure .control.variables.speed -font $font

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font

button .quit -font $font -text "quit" -command "exit 0" -width 10
button .config -font $font -text "configure..."  -command configure -width 10
button .help -font $font -text "help..." -width 10 \
	-command {LASSPhelp2 .t2 [file join $SSS_DIR lib/sommer/sommer.htm]}
LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font

#spt
pack .quit .disp_type .config .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top

pack .display.can -side top
pack .display.pos -side bottom
pack .display -side left -expand no

pack .control.run -fill x
pack .control.initialize -fill x

pack .control.variables.ex -fill x
pack .control.variables.ey -fill x
pack .control.variables.bz -fill x
pack .control.variables.taui -fill x
pack .control.variables.taue -fill x
pack .control.variables.fermi -fill x
pack .control.variables.speed -fill x
pack .control.variables -side top   -fill x -expand yes

#pack .control.preset -fill x
#pack .control.config -fill x
#pack .control.help  -fill x
#pack .control.quit -fill x

pack .graphf.graph -side top -fill y
pack .graphf.recgraph -side bottom -expand yes -fill both -padx 2
pack .graphf -side right -expand yes -fill both
pack .control -side right -expand no

proc graphf_init {} {
# mod rbr
# One must have at least one data point under windows and some X stations
# in order for the graph to draw at all. If the graph doesn't draw anything
# until the program has run long enough to generate some data points, then
# under windows, clicking in the graph will crash the program!
if { 0 != [lsearch -exact [.graphf.recgraph element names] dummy] } {
	.graphf.recgraph element create dummy
	.graphf.recgraph legend configure -mapped no
	.graphf.recgraph element append dummy {0.0 0.0}
}
update
#.graphf.recgraph element show {kx ky excess_e}
#.graphf.recgraph element delete dummy
#.graphf.recgraph legend configure -mapped yes
#update
# end mod rbr
}

graphf_init

############################## special bindings #######################3
bind . <Key-space> {.control.run invoke}
bind . <Key-i> {.control.initialize invoke}
bind . <Key-Escape> {.control.quit invoke}

#mod mjb 8/27/97
	 global sommer_config_palette
	 if { $sommer_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set sommer_config_palette 1
    }

#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#canvas
	.display.can configure -height $hght -width $wdth
	.display.can itemconfig surface -width [expr $wdth/120] 

	#graph
	.graphf.recgraph configure -width $wdth  -height $hght
	.graphf.recgraph config -font $font
	.graphf.recgraph xaxis config -font $font -ticklength 6
	.graphf.recgraph yaxis config -font $font -ticklength 6
	.graphf.recgraph legend config -font $font -padx 2
	


	#button
	.graphf.graph configure -font $font
	.control.run configure -font $font
	.control.initialize configure -font $font

	#scale
	LASSPscale2_configure .control.variables.ex -font $font
	LASSPscale2_configure .control.variables.ey -font $font
	LASSPscale2_configure .control.variables.bz -font $font
	LASSPscale2_configure .control.variables.taui -font $font
	LASSPscale2_configure .control.variables.taue -font $font
	LASSPscale2_configure .control.variables.fermi -font $font
	LASSPscale2_configure .control.variables.speed -font $font

	# the selections
	LASSPselection_configure .disp_type -font $font

	#label
	.display.pos configure -font $font

	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.config configure -font $font
	.help configure -font $font
	.quit configure -font $font

      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}

	graphf_init
	#procedures to redraw
	initialize

}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option

