set SSS_PROG "ziman"

set halfsize 200.
set xscale 50.
# real space range in micrometers 
set range [expr 2000./$xscale]  
set oldscale $xscale

#this is defined in both C and here, so needs to be changed in both places
set kscale 80
set center 200
set radius 2.5
# lattice constant
set lc 2.

#added by spt for redrawing vertical bars
set old_kscale $kscale
set old_halfsize 0


#wm  minsize . 900 400
set ziman_config_palette 0


###################################################################
#mod spt
#getting the screen size and using if for fixing the screen size.

#global variable font, wdth and hght and initializing them.

set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-"
set wdth 0
set hght 0
proc startup {} {
global wd ht wdth hght font disp_option kscale center halfsize radius xscale tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$wd <= 640} {
	set wdth 230
	set hght 230
	set kscale 48
	set center 115
	set halfsize 115.0
	set xscale 28.75
	set radius 2.0
	set disp_option "small"
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 630 400
	wm maxsize . 750 450

	} elseif {$wd <= 800} {
		set wdth 280
		set hght 280
		set kscale 56
		set center 140
		set halfsize 140.0
		set xscale 35.
		set radius 2.2
		set disp_option "medium"
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 380
		wm maxsize . 900 550
	 } else {
			set wdth 400
			set hght 400
			set disp_option "large"
			set kscale 80
			set center 200
			set halfsize 200.0
			set xscale 50.
			set radius 2.5
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			wm minsize . 1000 500
			wm maxsize . 4000 3000

			}
}

proc set_para {} {
global wd ht wdth hght font disp_option kscale center halfsize xscale radius tcl_platform
set wd [winfo screenwidth .]
set ht [winfo screenheight .]
if {$disp_option == "small"} {
	set wdth 230
	set hght 230
	set kscale 48
	set center 115
	set halfsize 115.0
	set xscale 28.75
	set radius 2.0
    	if { $tcl_platform(platform) == "unix" } {
		set font "-*-helvetica-medium-r-normal-*-*-80-*-*-*-*-*-*"
	} else {
		set font "-*-helvetica-bold-r-normal-*-*-90-*-*-*-*-*-*"
	}
	wm minsize . 630 400
	wm maxsize . 750 450

	} elseif {$disp_option == "medium"} {
		set wdth 280
		set hght 280
		set kscale 56
		set center 140
		set halfsize 140.0
		set xscale 35.
		set radius 2.2
	        if { $tcl_platform(platform) == "unix" } {
		    set font "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*"
		} else {
		    set font "-*-helvetica-bold-r-normal-*-*-100-*-*-*-*-*-*"
		}
		wm minsize . 740 380
		wm maxsize . 900 550
	 } else {
			set wdth 400
			set hght 400
			set font "-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*"
			set kscale 80
			set center 200
			set halfsize 200.0
			set xscale 50.
			set radius 2.5
			wm minsize . 1000 500
			wm maxsize . 4000 3000
		}
	# Configuring the font for all the widgets.
	config_all

#	if {[winfo reqwidth .] > $wd } {
		#Setting geometry as much as needed.
#		wm geometry . [winfo reqwidth .]x[winfo reqheight .]+[winfo x .]+[winfo y .]
#	}

}

#mod spt
startup


################## tcl initialize ############################
proc tcl_initialize {} {
    # initialize positions and wave vectors 
    ziman_initialize

}


####find the highest number in a list
proc get_highest {num_list} {
    set highest 0
    foreach i $num_list {
	if {$i > $highest} {
	    set highest $i
	}
    }
    return $highest
}


####while running, do the Runge-Kutta integration for one time step
proc tcl_evolve {} {
    global running
    while {$running == 1} {
	ziman_evolve
	update
    }
}
 

###########
proc draw_boundry {} {
    global halfsize kscale lc
    global old_halfsize old_kscale

    #spt - for removing old lines of blue color.
    set offset [expr $old_halfsize - 3.141/$lc*$old_kscale]
    .recipf.can create line $offset 0 $offset [expr 2*$old_halfsize] \
	    -fill black -width 5
    .recipf.can create line [expr 2*$old_halfsize -$offset] 0 \
	    [expr 2*$old_halfsize-$offset] [expr 2*$old_halfsize] \
	    -fill black -width 5
    .recipf.can create line 0 $offset  [expr 2*$old_halfsize] $offset \
	    -fill black -width 5
    .recipf.can create line 0 [expr 2*$old_halfsize -$offset] \
	    [expr 2*$old_halfsize]  [expr 2*$old_halfsize-$offset] \
	    -fill black -width 5

    set old_halfsize $halfsize
    set old_kscale $kscale

   #-----------------

    set offset [expr $halfsize - 3.141/$lc*$kscale]
    .recipf.can create line $offset 0 $offset [expr 2*$halfsize] \
	    -fill blue -width 5
    .recipf.can create line [expr 2*$halfsize -$offset] 0 \
	    [expr 2*$halfsize-$offset] [expr 2*$halfsize] \
	    -fill blue -width 5
    .recipf.can create line 0 $offset  [expr 2*$halfsize] $offset \
	    -fill blue -width 5
    .recipf.can create line 0 [expr 2*$halfsize -$offset] \
	    [expr 2*$halfsize]  [expr 2*$halfsize-$offset] \
	    -fill blue -width 5

}

################# the presetsave procedure ############################
proc presetsave {file} {
    
    #global variables & checkbuttons
    foreach s {range} {
        global $s
        puts $file "set $s [set $s]"
    }
    #selections
    foreach s {} {
        set val [LASSPselection_set $s]
	puts $file "LASSPselection_set $s $val"
    }
    
    #sliders
    foreach s {.control.variables.ex .control.variables.ey \
	    .control.variables.bz .control.variables.kx \
	    .control.variables.ky .control.variables.anisotropy \
.control.speed } {
        set val [LASSPscale2_configure $s -scrollinc]
        puts $file "LASSPscale2_configure $s -scrollinc $val"
        set val [LASSPscale2_configure $s -scrollmin]
        puts $file "LASSPscale2_configure $s -scrollmin $val"
        set val [LASSPscale2_configure $s -scrollmax]
        puts $file "LASSPscale2_configure $s -scrollmax $val"
        set val [LASSPscale2_configure $s -scrolltype]
        puts $file "LASSPscale2_configure $s -scrolltype $val"
# rbr no fonts in presets
#        set val [LASSPscale2_configure $s -font]
#        puts $file "LASSPscale2_configure $s -font $val"

        set var [LASSPscale2_configure $s -var]
        global $var
        puts $file "LASSPscale2_set -nocommand $s [set $var]"
    } 
    puts $file "tcl_initialize"
    puts $file "new_contours"
}

############################### create a configure window ############
####configure

proc configure {} {
    if {[winfo exists .zimanconfig]} {
        foreach win [winfo children .zimanconfig] {
            destroy $win
        }
    } else {
        toplevel .zimanconfig
        wm title .zimanconfig "ziman configure"
    }
    set w .zimanconfig
    frame $w.controls
    label $w.controls.l -text "ziman configure"
    button $w.controls.b -text close -command "destroy .zimanconfig"
    button $w.controls.b2 -text revert -command "configure"

    global range
    frame $w.range 
    label $w.range.l -text "real space range (10^-6 m)"
    LASSPentry $w.range.e \
	    {expr {[catch {expr -[%W get]}] \
            || !([%W get]>0) \
	    || ([expr [catch {set range [%W get]}]])}}

    bind $w.range.e <KeyPress-Return> {+
    global xscale
    global oldscale 
    set xscale [expr 2000./$range]
    set diff [expr 1.0*$xscale/(1.0*$oldscale)]
    .realf.can scale all 200 200 $diff $diff
    set oldscale $xscale
    foreach index [.realf.can find all] {
	set radius 2.5
	set corners [.realf.can coords $index]
	set  x0 [lindex $corners 0]
	set  x1 [lindex $corners 2]
	set  y0 [lindex $corners 1]
	set  y1 [lindex $corners 3]
	set xc [expr $x1-$radius]
	set yc [expr $y1-$radius]
	.realf.can coords $index [expr $xc-$radius] [expr $yc-$radius] [expr $xc+$radius] [expr $yc+$radius]
    }
}


    pack $w.controls.l -side left -fill x -expand yes
    pack $w.controls.b2 -side left -fill x -expand yes
    pack $w.controls.b -side left -fill x -expand yes
    pack $w.controls -fill x -expand yes -pady 1
    pack $w.range
    pack $w.range.l
    pack $w.range.e
    LASSPentry_set $w.range.e $range

    #mod rbr
    raise $w

}


##################create frames, buttons, etc
#real space
frame .realf
label .realf.clock -font $font -text "time (ps): 0" 
canvas .realf.can -height $hght -width $wdth -relief raised
label .realf.pos -font $font -text "position: (0,0) 10^-6 m"
bind .realf.can <Motion> {
    set a [expr ( %x - $halfsize)/$xscale*10.]
    set b [expr (-%y + $halfsize)/$xscale*10.]
    .realf.pos configure -text "position ($a, $b) 10^-6 m"
}  


#reciprocal space
frame .recipf
canvas .recipf.can -height $hght -width $wdth -relief raised -background black
label .recipf.pos -font $font -text "wave vector: (0,0) 1/A"
bind .recipf.can <Motion> {
    set a [expr (%x - $halfsize)/(3.1415927/$lc * $kscale)]
    set b [expr (-%y + $halfsize)/(3.1415927/$lc * $kscale)]
    .recipf.pos configure -text "wave vector: ($a, $b) pi/a"
}
bind .recipf.can <Button-1> {
    set ka [expr (%x - $halfsize)/(3.1415927/$lc * $kscale)]
    set kb [expr (-%y + $halfsize)/(3.1415927/$lc * $kscale)]
    LASSPscale2_set .control.variables.kx [expr $ka]
    LASSPscale2_set .control.variables.ky $kb
    tcl_initialize
}  
draw_boundry
LASSPselection .recipf.zone "zone scheme:" zonescheme \
	{} "reduced" "repeated"
LASSPselection_set .recipf.zone "reduced"
LASSPselection_configure .recipf.zone -font $font

#frame for all controls
frame .control -relief flat -bd 3
frame .control.variables 

#variable controls
LASSPscale2 .control.variables.ex -text "E_x (10^6 V/m): " -var E_x \
	-scrollmin 0 -scrollmax 1 -initial 0 
LASSPscale2_configure .control.variables.ex -font $font

LASSPscale2 .control.variables.ey -text "E_y (10^6 V/m): " -var E_y \
	-scrollmin 0 -scrollmax 1 -initial 0 
LASSPscale2_configure .control.variables.ey -font $font
  
LASSPscale2 .control.variables.bz -text "B_z (T): " -var B_z \
	-scrollmin 0 -scrollmax 5 -initial 0 -scrollinc 0.1
LASSPscale2_configure .control.variables.bz -font $font

LASSPscale2 .control.variables.kx -text "k_x (pi/a):" -var k_x_init \
	-scrollmin 0 -scrollmax 1.0 -initial 0.5 -command {ziman_initialize}
LASSPscale2_configure .control.variables.kx -font $font

LASSPscale2 .control.variables.ky -text "k_y (pi/a):" -var k_y_init \
	-scrollmin 0 -scrollmax 1.0 -initial 0.5 -command {ziman_initialize}
LASSPscale2_configure .control.variables.ky -font $font

LASSPscale2 .control.variables.anisotropy -text "anisotropy" \
	-var anis -scrollmin 0 -scrollmax 5  -initial 1 \
	-command {new_contours; ziman_initialize} -scrollinc 0.1
LASSPscale2_configure .control.variables.anisotropy -font $font

#other controls-speed, run, configure, quit, help

LASSPscale2 .control.speed -text "speed" -var speed -scrollmin 0 \
	-scrollmax 2 -initial 0.1 -test {%v>0} -scrollinc 0.1
LASSPscale2_configure .control.speed -font $font

set running 0
button .control.run -font $font -text "run" -height 2 -command {
    global running 
    if {$running} {
	set running 0
	.control.run configure -text "run"
    } else {
	set running 1
	.control.run configure -text "stop"
	tcl_evolve
    } 
}

button .control.initialize -font $font -text "initialize" -height 2 \
	-command {tcl_initialize}

#mod spt to add top panel
frame .top_panel  -relief sunken -bd 2

LASSPselection .disp_type "display: " disp_option {set_para} \
	"large" "medium" "small"
LASSPselection_configure .disp_type -font $font



button .quit -text "quit" -font $font -command "exit 0" -width 10
button .config -text "configure..."  -font $font -command configure -width 10
button .help -font $font -text "help..." -width 10 \
	-command {LASSPhelp2 .t2 [file join $SSS_DIR lib/ziman/ziman.htm]}

LASSPpresets .presets presetsave
LASSPpresets_configure .presets -font $font


#############packing
#spt
pack .quit .disp_type .config .presets .help -in .top_panel -side left -fill x -padx 10
pack .top_panel -side top


pack .recipf.zone
pack .recipf.can
pack .recipf.pos -side bottom
pack .recipf -side right -fill x -expand yes

pack .control.run -fill x -pady [expr ($wdth - 130)/80]
pack .control.initialize -fill x -pady [expr ($wdth - 130)/80]


pack .control.variables.ex -fill x -pady [expr ($wdth - 130)/80]
pack .control.variables.ey -fill x -pady [expr ($wdth - 130)/80] 
pack .control.variables.bz -fill x -pady [expr ($wdth - 130)/80]
pack .control.variables.kx -fill x -pady [expr ($wdth - 130)/80]
pack .control.variables.ky -fill x -pady [expr ($wdth - 130)/80]
pack .control.variables.anisotropy -fill x -pady [expr ($wdth - 130)/80]
pack .control.variables -side top -pady 1

pack .control.speed -fill x
#pack .control.presets -fill x 
#pack .control.config -fill x
#pack .control.help  -fill x 
#pack .control.quit -fill x 

pack .control -side right -fill x -expand yes

pack .realf.clock
pack .realf.can
pack .realf.pos -side bottom
pack .realf -side left -fill x -expand yes

############################## special bindings #######################3
bind . <Key-space> {.control.run invoke}
bind . <Key-i> {.control.initialize invoke}
bind . <Key-Escape> {.control.quit invoke}
bind . <KeyPress-e> {
    .realf.can delete position
    .recipf.can delete momentum
} 


source [file join $SSS_DIR lib/ziman/ziman08.pre]
after 5000 { .control.run invoke }

#mod mjb 8/27/97
	 global ziman_config_palette
	 if { $ziman_config_palette == 0 } {
	tk_setPalette #d9d9d9
	set ziman_config_palette 1
    }

#------------------------------------------------------
proc config_all {} {

	global font wdth hght

	#label
	.realf.clock configure -font $font
	.realf.pos configure -font $font
	.recipf.pos configure -font $font

	#canvas
	.realf.can configure -height $hght -width $wdth 
	.recipf.can configure -height $hght -width $wdth

	#selection
	LASSPselection_configure .recipf.zone -font $font

	#scale
	LASSPscale2_configure .control.variables.ex -font $font
	LASSPscale2_configure .control.variables.ey -font $font
	LASSPscale2_configure .control.variables.bz -font $font
	LASSPscale2_configure .control.variables.kx -font $font
	LASSPscale2_configure .control.variables.ky -font $font
	LASSPscale2_configure .control.variables.anisotropy -font $font
	LASSPscale2_configure .control.speed -font $font

	#button
	.control.run configure -font $font   -height 2
	.control.initialize  configure -font $font  -height 2

	# the selections
	LASSPselection_configure .disp_type -font $font


	# the presets
	LASSPpresets_configure .presets -font $font

	# the buttons
	.config configure -font $font
	.help configure -font $font
	.quit configure -font $font

#RHS cosmetics
	pack .control.run -fill x -pady [expr ($wdth - 130)/80]
	pack .control.initialize -fill x -pady [expr ($wdth - 130)/80]


	pack .control.variables.ex -fill x -pady [expr ($wdth - 130)/80]
	pack .control.variables.ey -fill x -pady [expr ($wdth - 130)/80] 
	pack .control.variables.bz -fill x -pady [expr ($wdth - 130)/80]
	pack .control.variables.kx -fill x -pady [expr ($wdth - 130)/80]
	pack .control.variables.ky -fill x -pady [expr ($wdth - 130)/80]
	pack .control.variables.anisotropy -fill x -pady [expr ($wdth - 130)/80]

   
	#labels

	#graphs

	#procedures to redraw
	tcl_initialize
	draw_boundry
	new_contours

      global tcl_platform
      if { $tcl_platform(platform) != "windows" } { 
	  wm withdraw .
        set oldx [winfo x .]
        set oldy [winfo y .]
        wm deiconify .
        if { $tcl_platform(platform) == "macintosh"} {
        	if { $oldy <=20 } { set oldy 20}
        }
        wm geometry . +$oldx+$oldy
      }
	wm geometry . {}
}

# Setting the size option as per the correct value.
LASSPselection_set .disp_type $disp_option


